/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
//try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG;
		
	var _opts = {
		type: 0,  // 0: 닮은꼴 연예인찾기 - 1장 촬영 또는 겔러리 선택, 1: 닯은꼴 배틀 - 2장~4장 촬영 또는 겔러리 선택
		targetDir: 'wgt-private-tmp',
		targetFile: 'capture'
	};
	
	var _selectedFile;
	var _responseData = {image:[], pgm:[], sourceImageUrl: ''};
	
	var _successCallback,
		_errorCallback;

    var _apiType;

	function _step2_detect(imgUrl) {
		var url = app.def.API_FACE_DETECT;
		url+= imgUrl;
		
		if (_DEBUG) { console.log('detect url', url); }

        var errback = function(e){
            if (_DEBUG) { console.log('_step2_detect detection api err', url, e.message); }
            _errorCallback({code: '408', message: '_step2_detect detection api err ' + e.message});
        };

//		var _selectedIndex = 1;
//		var makeItem = function(info){	// 배틀용
//			var targetFile = _opts.targetDir + '/' + _opts.targetFile + _selectedIndex;
//
//			xx.fexplorer.writeFile(targetFile + '.pgm', info.imageid, true, function(){
//				xx.fexplorer.copy(_selectedFile, targetFile + '.jpg', function(){
//					_responseData.image.push(targetFile + '.jpg');
//					_responseData.pgm.push(targetFile + '.pgm');
//
//					_selectedIndex++;
//
//				}, function(e){
//					if (_DEBUG) { console.log('_step2_detect file 복사 실패!', e.message); }
//				});
//			}, function(e) {
//				if (_DEBUG) { console.log('_step2_detect file  쓰기실패!' +  e.message); }
//			});
//		};
		
		
		var makeRect = function(info) {	// 닯은꼴 연예인 찾기용
			if (_DEBUG) { console.log('_step2_detect makeRect', info); }
			try{
				var i,
					len = info.length,
					chk = len;

                var writeTargetFile = function(idx) {
                    try{
                        var targetFile = _opts.targetDir + '/' + _opts.targetFile + (i+1);
                        if (_DEBUG) { console.log('_step2_detect', targetFile); }
                        xx.fexplorer.writeFile(targetFile + '.pgm', info[idx].imageid, true, function(){
                            xx.fexplorer.copy(_selectedFile, targetFile + '.jpg', function(){
                                _responseData.image.push(targetFile + '.jpg');
                                _responseData.pgm.push(targetFile + '.pgm');

                                if (_apiType === 'findFace') {
                                    _responseData.rect.push(info[idx].rect);
                                }

                                chk--;

                                if (chk === 0) {
                                    _successCallback(_responseData);
                                }
                            }, function(e){
                                if (_DEBUG) { console.log('_step2_detect file 복사 실패!', e.message); }
                                errback(e);
                            });
                        }, function(e) {
                            if (_DEBUG) { console.log('_step2_detect file  쓰기실패!' +  e.message); }
                            errback(e);
                        });

                    }catch(e){
                        if (_DEBUG) {  console.log('makeRect err', e.message); }
                        errback(e);
                    }
                };

				for (i=0; i<len; i++) {

                    writeTargetFile(i);
//					(function(idx) {
//
//					})(i);
				
				}
			}catch(e){
				//alert('rect err ' + e.message);
				errback(e);
			}
		};
		
		var callback = function(response) {
			
			try {
                //errback({code: '000', message: '테스트 강제 얼굴인식 실패'}); return;
				var data = app.api.validateResponse(response);
				if (data.detectionInfo) {
					makeRect(data.detectionInfo);
				} else {
					_errorCallback({code:'000', message: 'no detectionInfo'});
				}

			} catch(e) {
				_errorCallback(e);
			}
		};

		ax.ext.net.curl({
			method : 'GET',
			url : url,
			timeout : 2000,
			success : callback,
			error : errback
		}); 
	}
	
	function _step1_upload(file) {
		
		var params = {
				svckey: app.def.SVC_KEY,
				v: app.def.APP_VERSION
			},
			files = {
				upFile: file
			};
			
		_selectedFile = file;

        var errback = function(e){
            if (_DEBUG) { console.log('_step1_upload upload err', file, e.message); }
            _errorCallback.apply(null,[{code:'408', message: '_step1_upload upload err ' + file + ' ' + e.message}]);
        };

        var callback = function(response) {
			try {
                //errback({code: '000', message: '테스트 강제 업로드 실패'}); return;

				var data = app.api.validateResponse(response);

				if (_DEBUG) { console.log('_step1_upload API_UPLOAD SUCCESS', ax.util.dump(response)); }
				if (_DEBUG) { console.log(ax.util.dump(data)); }
				_responseData.sourceImageUrl = data.fileUrl;
				_step2_detect(data.fileUrl);

			} catch(e) {
                console.log('WHY???', e.message);
				errback({code: '000', message: 'validateResponse err ' + e.message});
			}
		};

		var opts = {
			url: app.def.API_UPLOAD,
			headers: app.def.API_HEADERS,
			params: params,
			files: files,
			method: 'POST',
			success: callback,
			error: errback
		};
		
		ax.ext.net.curl(opts); 
	}

    function findFace(scb, ecb, opts) {
        if (_DEBUG) { console.log('app.findFace.findFace called', ax.util.dump(opts)); }

        _opts = opts;
        _responseData.rect = [];
        _apiType = 'findFace';

        _step1_upload(opts.sourceImage);

        _successCallback = scb;
        _errorCallback = ecb;
    }


    var oFindFace = {};
	ax.def(oFindFace)
		.method('findFace', findFace);

	ax.def(g.app).constant('findFace', oFindFace);

//}catch(e){
//	console.log('app_api_findface.js def err ', e.message);
//}
}(window));
