/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG;

	var _btnGlobalTouchActionFlag = false,
		_btnGlobalTouchActionTimer;
	
	function onButtonTouched(btnName, eventPage) {
		if (_btnGlobalTouchActionFlag === true) {
			console.log('XXX 두번 터치된 경우입니다!!!', btnName, eventPage);

			if (_btnGlobalTouchActionTimer !== undefined) {
				g.clearTimeout(_btnGlobalTouchActionTimer);
			}

			_btnGlobalTouchActionTimer = setTimeout(function(){
				_btnGlobalTouchActionFlag = false;
				_btnGlobalTouchActionTimer = undefined;
			}, 1000);

			return;
		}

		switch(btnName) {	// basic button
		case 'btnMy':
			xx.page.pageMy.show();
			break;
		case 'btnSettings':
			xx.page.pageSetting.show();
			break;
		case 'btnBack':
		case 'btnClose':
			if($('#mainBigBiz').length > 0){
				xx.scroll.wrapperMain.scrollTo(0, 0);
			}
			xx.page.back();
			break;
		case 'btnHome':
			var history = xx.page.history,
				i,
				len = history.length;
				
			for(i=1; i<len-1; i++) {
				xx.page[history[i]].hide();
			}
			xx.page.back();
			break;
		}
		
		switch (eventPage) {
		case 'pageMain':
			if (typeof xx.scroll.wrapperMain === 'undefined') {
				switch (btnName) {
					case 'btnFind':
						xx.page.pageFind.show();
						break;
					case 'btnChallenge':
                        app.common.recommendStarMode = 'challenge';
						xx.page.pageBattleSearchStar.show();
						break;
					case 'btnBattle':
                        app.common.recommendStarMode = 'battle';
						xx.page.pageBattleSearchStar.show();
//						xx.page.pageBattle.show(function(){
//							
//							app.common.trackEvent('AB테스트', '닮은꼴배틀_' + app.pageMain.groupName);
//							if (_DEBUG) { console.log('AB테스트 닮은꼴배틀_' + app.pageMain.groupName); }
//							
//                            if (app.common.useKM) {
//                                g._kmq.push(['record', '닮은꼴배틀_메인']);
//                            }
//                        });
						break;
				}
			}
			break;
		case 'pageFind':
        case 'pageChallenge':
			switch (btnName) {
//			case 'btnInfoClose':
//				app.pageFind.closeInfo();
//				break;
			case 'btnCamera':
				$('#global_loading').addClass('finding');
				app.common.trackEvent(eventPage, '직접촬영');
				app.common.isLoading = true;
				_btnGlobalTouchActionFlag = true;
				app.pageFind.captureImage();
				break;
			case 'btnGallery':
				$('#global_loading').addClass('finding');
				app.common.trackEvent(eventPage, '앨범');
				app.common.isLoading = true;
				_btnGlobalTouchActionFlag = true;
				app.pageFind.pickImage();
				break;
			case 'btnFacebook':
				app.common.trackEvent(eventPage, '페이스북앨범');
				xx.page.pageFacebookGallery.show();
				break;
            case 'btnStarSearch':
                xx.page.back();
                break;
            }
			break;
		case 'pageSelectFace':
			switch (btnName) {
			case 'btnSelectBack':
				if (!$('#btn_select_back').hasClass('off')) {	
					app.pageSelectFace.cancelAutoSelect();
					xx.page.back();
				}
				break;
			}
			break;
		case 'pageFound':
		case 'pageBattleResult':
        case 'pageChallengeResult':
			switch (btnName) {
			case 'btnFoundPrev':
				if (!$('#btnFoundPrev').hasClass('off')) {
					xx.scroll.wrapperFound.scrollToPage(xx.scroll.wrapperFound.currPageX-1);
				}
				break;
			case 'btnFoundNext':
				if (!$('#btnFoundNext').hasClass('off')) {
					xx.scroll.wrapperFound.scrollToPage(xx.scroll.wrapperFound.currPageX+1);
				}
				break;
			case 'btnBattleRetry':
				_btnGlobalTouchActionFlag = true;
				if (!$('#btn_battle_retry button').hasClass('off')) {
//					xx.page.pageBattleSearch.show(function() {
//						xx.page.pageBattleResult.hide();
//					});

                    xx.page.back();
				}
				break;
            case 'btnChallengeRetry':
                xx.page.back();
                break;
			case 'btnShare':
				_btnGlobalTouchActionFlag = true;
				app.share.showShareMenu(eventPage);
				
				break;
			case 'btnFoundBannerClose':
				$('#whois_banner').addClass('hide');
                // g._kmq.push(['record', 'ad_' + app.pageFound.result.biz.bizName + '_click_x']);
				break;
			case 'btnBattleStarSearch':
				app.common.trackEvent(eventPage, '연예인사진');
				xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('found_search_headline');
				xx.page.pageEmpty.show();
				
				if (app.pageBattleResult.result.linkUrl) {
					app.common.addWebView(app.pageBattleResult.result.linkUrl + encodeURIComponent($('#br_st_name').attr('queryName')));
				} else {
					app.common.addWebView('http://www.google.co.kr/search?hl=' + app.nls.lang + '&source=pudding&lr=lang_ko&pws=0&q=' + encodeURIComponent($('#br_st_name').attr('queryName')));
				}

				break;
			}
			break;
		case 'pageShare':
			switch (btnName) {
			case 'btnShareCancel':
				app.share.cancel();
				break;
			case 'btnShareSend':
				app.share.send();
				break;		
			}
			break;
		case 'pageSetting':
			switch (btnName) {
			case "btnSuggest":
				xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('suggestion_headline');
                xx.page.pageEmpty.show();
				app.common.addWebView(app.nls.get('suggestion_link'));
				break;
			}
			break;
		case 'pageBattleSearch':
			switch (btnName) {
			case 'btnStarSearch':
                xx.page.pageBattleSearchStar.hide(function() {

                    app.common.recommendStarMode = 'battle';
                    xx.page.pageBattleSearchStar.show(function() {
                        xx.page.pageBattleSearch.hide();
                    });
                });
				break;
			case 'btnStartBattle':
				if (app.common.inappBackground === 0 || xx.page.platform !== 'android') {
					if (!$('#btnStartBattle').hasClass('off')) {
						_btnGlobalTouchActionFlag = true;
						app.pageBattleSearch.startBattle();
					}
				}
				break;
			case 'btnBattleCaptureImage':
				app.common.trackPageview('배틀카메라');
				_btnGlobalTouchActionFlag = true;
				app.pageBattleSearch.captureImage();
				break;
			}
			break;
		case 'pageBattleSearchStar':
			switch (btnName) {
			case 'btnSearch':
				setTimeout(function(){
					app.pageBattleSearchStar.search();
				}, 100);
				break;
			case 'btnResetSearchKeyword':
				
				$('#pageBattleSearchStar .search input').val('');
				if (app.pageBattleSearchStar.isKeyboardShown === true) {
					g.bx.ext.screw.ui.resetTextView();
				}
				
				
				break;
			}
			break;
		case 'pageMy':
			switch (btnName) {
            case 'btnMyChallenge':
				app.pageMy.showTab(3);
				break;
			case 'btnMyHistory':
				app.pageMy.showTab(1);
				break;
			case 'btnMyBattle':
				app.pageMy.showTab(2);
				break;
            case 'btnGoToChallenge':
                app.common.recommendStarMode = 'challenge';
                xx.page.pageBattleSearchStar.show(function(){
					xx.page.pageMy.hide();
				});
                break;
			case 'btnGoToFind':
				xx.page.pageFind.show(function(){
					xx.page.pageMy.hide();
				});
				break;
			case 'btnGoToBattle':
                app.common.recommendStarMode = 'battle';
				xx.page.pageBattleSearchStar.show(function(){
					xx.page.pageMy.hide();
				});
				break;
			}
			break;
		case 'layer_gobattle':
			switch (btnName) {
			case 'gobattle_close':
				app.common.setPreference('goBattleFlag', new Date().getTime());
				app.common.destroyGoBattleLayer();

				app.common.trackEvent('메인레이어', 'X버튼');
				break;
			case 'gobattle_go':
				//app.common.setPreference('goBattleFlag', app.def.APP_VERSION);
                app.common.setPreference('goBattleFlag', new Date().getTime());
				app.common.goGoBattleLayer();

				app.common.trackEvent('메인레이어', '배틀하러가기');
				//if (app.common.useKM) {
				//	g._kmq.push(['record', '배틀하러가기']);
				//}
				break;
			}
			break;
		default:

		}
		
		if (_btnGlobalTouchActionFlag === true) {
			_btnGlobalTouchActionTimer = setTimeout(function(){
				_btnGlobalTouchActionFlag = false;
				_btnGlobalTouchActionTimer = undefined;
			}, 1000);
		}
	}
	
	function startButton() {
		var isTouchEvent = true;
		if (typeof g.document.body.ontouchstart === 'undefined' ) { isTouchEvent = false; }
		
		/* apply fast button to common buttons */
		//g.document.body.addEventListener(isTouchEvent ? 'touchstart' : 'mousedown', function(e) {
		g.document.body.addEventListener('click', function(e) {
			var target = e.target,
				btnName,
				eventPage,
				i = 10;
				
			try{
				
				while(i--) {
					//console.log(target.tagName );
					if (target.tagName === 'BODY') { return; } 
					
					//if(target.getAttribute('data-role') === 'button') {
					if($(target).attr('data-role') === 'button') {
						i = 10; 
						break;
					}
					target = target.parentNode;
				}
				
				if (target.getAttribute('data-role') === 'button') {
					
					btnName = $(target).attr('title');
					
					if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>>>>>>>> ' + btnName + ' touch'); }
					//console.log('>>>>>>>>>>>>>>>>>>>>>>>>> ' + btnName + ' touch');

					// XXX: 메인 페이지는 캐로셀이 있을수도 없을수도 있음. 있는 경우 버튼 핸들러를 xx.scroll에 맞김.
					if (btnName === 'btnBattle' || btnName === 'btnFind' || btnName === 'btnChallenge' || btnName === 'btnMainAD') {
						if (xx.scroll.wrapperMain) {
							return ;
						}
					//} else if (btnName === 'btnStarSearch' && app.pageBattle.battleMode === 'random') {
					//	return;
					} else if (btnName === 'btnBattleCaptureImage') {
						if (app.pageBattle.battleMode !== 'random' && !app.pageBattleSearch.star) { return; }
					}
					
					$(target).addClass('pressed'); 

					setTimeout(function() {
						
						if (xx.page.loadingPage) {
							console.log('XXX 페이지 로딩 중!!!!', xx.page.loadingPage);
							return;
						}
						
						$(target).removeClass('pressed');

						try{
							while (i--) {
								if($(target).hasClass('page')) {
									eventPage = $(target).attr('id');
									break;
								}
								target = target.parentNode;
							}
						}catch(e){
							eventPage = 'layer_gobattle';
							if (_DEBUG) { console.log('maybe layer_gobattle'); }
						}
						
						setTimeout(function(){
							if (_DEBUG) { console.log('touch action:', eventPage, btnName); }
							onButtonTouched(btnName, eventPage);
						}, 0);
						
					}, 200);
					
					e.stopPropagation();
					e.preventDefault();
				} 
			}catch(err) {
				console.log('button err:', err.message, 'target.getAttribute', target.getAttribute);
			}
		}, false);
	}
	
	var oButtonAction = {};
	ax.def(oButtonAction)
		.method('startButton', startButton)
		.method('onButtonTouched', onButtonTouched);
	
	ax.def(g.app).constant('button', oButtonAction);

// }catch(e){
// console.log('app_button.js def err ' , e.message);
// }
}(window));

