/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g) {
	"use strict";
	
	var ax = g.ax,	// require('ax');
		xx = g.xx,
        app = g.app,
		oCommon = {},
		lazyScriptLoading = {},
		_preference = {},
		_preferenceFile = 'documents/pref.json',
		_DEBUG = !!g._DEBUG,
		_globalLoadingEl,
		_globalLoading = false;

    var _recommendStarMode = 'challenge'; // challenge or battle

    var _groupPrefix;
		
	// _DEBUG = true;
	
	var _statusFile = 'documents/status.json',
		_status = {};
	
	var _inappBackground = 0;
	var _isNetworkError = false;
	var _shareCount = null;

	var ADMOB_PUB_ID = 'a14daf979ddd520', // production
		TRACK_PAGE_VIEW_DELAY = 50,
		GA_ID = 'UA-19916117-21';

	var _isAdmobShown = false;

    var _useKM = false;

	function saveStatus(stat) {
		stat = JSON.stringify(stat||{});
		g.localStorage.setItem('_status', stat);
		xx.fexplorer.writeFile(_statusFile, stat);
	}
	
	// 카메라 또는 겔러리를 띄웠을때 앱이 재시작 된 경우인지 판단하는 상태정보 읽기
	function _loadStatus(){
		var stat = g.localStorage.getItem('_status');
		
		if(stat === null) {
			xx.fexplorer.readFile(_statusFile, false, function(stat){
				_status = JSON.parse(stat);
				if (_DEBUG) { console.log('app.common.loadStatus', _status); }
			}, function(e) {
				_status = {};
			});
		} else {
			_status = JSON.parse(stat);
		}
	}
	_loadStatus();
	
	
	function startGA(){
		if(_DEBUG) { console.log('***** ga start *****'); }
		ax.ext.ga.startTracker(GA_ID);
	}
	
	function _trackPageview(page, delay) {
		// if (_DEBUG) { return; }

		g.setTimeout(function() {
			if(_DEBUG) { console.log('***** ga: page=' + page + ' *****'); }
			try {
				ax.ext.ga.trackPageview(page);
			 } catch(e) { console.error('trackPageview error: error=' + e); }
		}, delay||TRACK_PAGE_VIEW_DELAY);
	}

	function _getTrackPageName(page, isEvent) {
		switch (page) {
		case 'pageMain':
			page = '메인홈';
			break;
		case 'pageFind':
			page = '얼굴인식가이드';
			break;
        case 'pageFound':
			page = '닮은꼴결과';
			break;
        case 'pageChallenge':
			page = '닮은꼴도전';
			break;
        case 'pageChallengeResult':
			page = '닮은꼴도전결과';
			break;
		case 'pageBattle':
			page = '배틀모드';
			break;
		case 'pageBattleSearch_random':
			page = '랜덤모드';
			break;
		case 'pageBattleSearch_search':
			page = '검색모드';
			break;
		case 'pageBattleSearchStar':
			page = '연예인검색';
			break;
		case 'pageBattleResult':
			page = '배틀결과 ';
			if (!isEvent) { page += app.pageBattleResult.result.face.length; }
			break;
		case 'pageSetting':
			page = '설정';
			break;
		case 'pageMy':
			page = '마이';
			break;
		}
		
		return page;
	}
	
	function trackPageview(page, delay) {
		
		if (page === 'pageBattleSearch') {
			page += '_' + app.pageBattle.battleMode;
		}
		page = _getTrackPageName(page);
		
		_trackPageview(page, delay);
	}
	
	function trackEvent(page, action, label, value) {
		page = _getTrackPageName(page, true);
		
		ax.ext.ga.trackEvent(page, action, label, value);
		
		if(_DEBUG) { console.log('***** ga event : page=' + page + ' ' + action + ' ' + (label || '') + ' *****'); }
	}

	var _globalLoadingTimer;
	var _globalLoadingTTL = 20000;
	
	
	function _globalLoadingTimeout() {
		
		if (_inappBackground === 0) {
			if (xx.page.platform === 'android') {
				return;
			} 
				
			if (_DEBUG) { console.log('XXX _globalLoadingTimeout!!!'); }
			//xx.page.back();
			app.button.onButtonTouched('btnHome');
			_globalLoadingEl.addClass('hide');
			_globalLoading = false;
			_globalLoadingTimer = undefined;
			
		} else {
			
			if (_DEBUG) { console.log('XXX _globalLoadingTimeout but  아마도 카메라 뜬 상태인듯'); }
			if (xx.page.platform === 'android' && _globalLoadingTimer) { g.clearTimeout(_globalLoadingTimer); }
			
			_globalLoadingTimer = setTimeout(_globalLoadingTimeout, _globalLoadingTTL);
		}
	}
	
	function showLoading(tf) {
		if (!_globalLoadingEl) {
			_globalLoadingEl = $('#global_loading');
		}
		
		if (tf === true) {
			if (_DEBUG) { console.log('IS_GLOBAL_LOADING TRUE'); }
			
			if (_globalLoadingTimer) {
				g.clearTimeout(_globalLoadingTimer);
			}
			_globalLoadingTimer = setTimeout(_globalLoadingTimeout, _globalLoadingTTL);
			
			_globalLoadingEl.removeClass('hide');
		} else {
			if (_globalLoading === false) { return; }
			if (_globalLoadingTimer) {
				g.clearTimeout(_globalLoadingTimer);
			}
			if (_DEBUG) { console.log('IS_GLOBAL_LOADING FALSE'); }
			_globalLoadingEl.addClass('hide');
			_globalLoadingTimer = undefined;
		}
		
		_globalLoading = tf;
	}
	
	function getPreference(key){
		if (!key) { return _preference; }
		var val = _preference[key] || g.localStorage.getItem(key);
		if (val === null) { val = ''; }
		return val;
	}
	
	function setPreference(key, value){
		if (value === undefined) {
			return getPreference(key);
		}
		_preference[key] = value;
		xx.fexplorer.writeFile(_preferenceFile, JSON.stringify(_preference));

		var k;
		for (k in _preference) {
			if (_preference.hasOwnProperty(k)) {
				g.localStorage.setItem(k, _preference[k]);
			}
		}

	}

	var _preferenceDefault = {
			sound: 'true',
			vibrate: 'true',
			animation: 'true',
			animationType: (xx.page.platform === 'android') ? 'fade' : 'slide',
			useSplash: 'true',
			starCategory: 'KR',
			noticeNumber: '0',
			autosave: 'true',
			facebook_oauth_prefs: '{access_token: null, user_id: null, user_name: null}',
			twitter_oauth_prefs: '{token: null, tokenSecret: null, user_id: null, screen_name: null}',
			kpnsLang: '',
			kpnsToken: '',
			kpnsOldGroup: '',
			goBattleFlag: '0',
			battleCount: '0',
            appVersion: '0'
	};
	
	if (app.nls.langApp !== 'ko') {
		_preferenceDefault.starCategory = 'AS';	// 한류스타
	}

	function showAdmob() {
		//if (_DEBUG) { return; }

		_isAdmobShown = true;

		var opts = {position:2};
		if (xx.page.platform !== 'android') { opts.type = 1; }
		g.com.appspresso.plugin.admob.showAdmob(function() {
			if (_DEBUG) { console.log('showAdmob successed!'); }
		}, function(e) {
			if (_DEBUG) { console.log('showAdmob err!', e.message); }

			_isAdmobShown = false;
			showAdmob(); // retry!!
		}, ADMOB_PUB_ID, opts);
	}

	function destroyGoBattleLayer(useAdmob, timer) {

		$('#layer_gobattle').animate({opacity:0}, 500, function(){
			$(this).remove();
		});

		setTimeout(function() {
			if (useAdmob !== false && _isAdmobShown === false && !app.common.isFortuneLayer) { showAdmob(); }
			app.common.trackPageview('pageMain');
		}, timer || 1000);

	}

	function goGoBattleLayer() {
//		app.common.isLoading = true;
//		xx.page.pageBattle.show(function(){
//			app.pageBattle.battleMode = 'search';
//			xx.page.pageBattleSearch.show(function() {
//				xx.page.pageBattleSearchStar.show(function(){
//					app.common.isLoading = false;
//					destroyGoBattleLayer(false);
//				});
//			});
//		});

        xx.page.pageBattleSearchStar.show(function(){
            destroyGoBattleLayer(false);
        });
	}

	function checkGoBattleLayer() {
		var flag = _preference.goBattleFlag,
			currentTimeForCheck = new Date().getTime(),
			imageUrl = 'image/img_battlelayer.png',
			battleCount = _preference.battleCount || 0,
            timer = (xx.page.platform === 'android') ? 1000 : 5000;

        // XXX: 3.1.0 부터 배틀안내 레이어 사용안함으로 정책 변경. 추후 사용할 수도 있으니 당장은 destroyGoBattleLayer 호출
        destroyGoBattleLayer(true, timer);


		// _preference.goBattleFlag === app.def.APP_VERSION // goBattleFlag 체크 타임체크용도로만 사용
		if (app.nls.langApp !== 'ko' || g.parseInt(battleCount, 10) > 0) {
			destroyGoBattleLayer(true, timer);
			return;
		}

		flag = g.parseInt(flag, 10) + (60 * 1000 * 60 * 24 * 7);
		//console.log(flag, currentTimeForCheck, flag - currentTimeForCheck);

		if (currentTimeForCheck < flag) {
			destroyGoBattleLayer(true, timer);
			return;
		}

		$('#layer_gobattle img').attr('src', imageUrl);
	}
	
	xx.fexplorer.readFile(_preferenceFile, false, function(pref){
		_preference = JSON.parse(pref);
		if (!_preference.starCategory) {
			_preference = _preferenceDefault;
			
			if (_DEBUG) { console.log('_preference (force default)', _preference); }
		} else {
            if (app.nls.langApp !== 'ko' && _preference.appVersion !== app.def.APP_VERSION) {
                _preference.starCategory = 'AS';	// 한류스타
                setPreference('appVersion', app.def.APP_VERSION);
            }

			if (_DEBUG) { console.log('_preference', _preference); }
		}

		checkGoBattleLayer();
	}, function(e){
		_preference = _preferenceDefault;
		checkGoBattleLayer();
		if (_DEBUG) { console.log('_preference (default)', _preference); }
	});
	
	
	function addScript(url, callback) {
		
		if (_DEBUG) { console.log('addScript', url); }
		
		if (typeof lazyScriptLoading[url] === 'undefined') {
			(function(e) {
				e.onload = callback;
				e.setAttribute("src", url);
				document.getElementsByTagName("body")[0].appendChild(e);
			}(document.createElement("script")));
			lazyScriptLoading[url] = true;
		} else {
			if (typeof callback === 'function') {
				callback();
			}
		}
	} 

	function hideProgress() {
		try {
			ax.ext.ui.hideProgress();
		} catch (e) {
			if (_DEBUG) { console.log('hide progress error: ' + e); }
		}
	}

	function showProgress(msg, ttl) {
		try{
			ax.ext.ui.showProgress(msg || 'Loading...');		
			setTimeout(function(){
				hideProgress();
			}, ttl || 10000);
		} catch (e) {
			//console.log('show progress error: ' + e);
		}
	}
	
	function alert(scb, msg) {
		
		ax.ext.ui.alert(scb, msg, {'positive': app.nls.get('common_ok')});
	}
	
	function addWebView(url, loadCallback, zoomDensity) {
		if (_DEBUG) { console.log('ADD WEBVIEW', url); }
		
		var top = 44, 
			left = 0,
			width = window.innerWidth,
			height = window.innerHeight - top;
	
		if (xx.page.prePage === 'pageSetting') {
			height-=50;
		}
		
		var opts = {
					left: left,
					top: top,
					width: width,
					height: height,
					zoomDensity: zoomDensity || 'MEDIUM'
				};
		
		var urlCallback = function(maybe, url) {
			var theURL = /^\w+:\/\//.test(maybe) ? maybe : url;
			//console.log('load callback url: ' + theURL);
			loadCallback(theURL);
		};
		
		if (typeof loadCallback !== 'function') {
			urlCallback = function(handle, callbackUrl) {
	            if (callbackUrl.indexOf('itms://itunes.apple.com/app') === 0
	                    || callbackUrl.indexOf('itms-apps://itunes.apple.com/app') === 0
	                    || callbackUrl.indexOf('http://itunes.apple.com') === 0
	                    || callbackUrl.indexOf('https://play.google.com') === 0
	                    || callbackUrl.indexOf('http://market.olleh.com') === 0
	                    || callbackUrl.indexOf('http://www.tstore.co.kr/userpoc') === 0
	                    || callbackUrl.indexOf('http://ozstore.uplus.co.kr/') === 0
	                    || callbackUrl.indexOf('http://www.samsungapps.com/topApps') === 0
	                    || callbackUrl.indexOf('http://kr.lgworld.com/front/product') === 0
	                    || callbackUrl.indexOf('http://m.nstore.naver.com/appstore') === 0
	                    ) {
					ax.ext.ui.stopWebView(function(){
						ax.ext.ui.open(callbackUrl, '_blank');
					});
	                return;
	            }
	        };
		}
		
		if (xx.page.platform === 'ios') {
			opts.load = urlCallback;
		} else if (xx.page.platform === 'android') {
			opts.start = urlCallback;
		} else {
			console.log('unsupported device: ' + navigator.userAgent);
			return;
		}
		
		if (_DEBUG) { console.log('addWebView opts:', ax.util.dump(opts)); }

		//added by yanni
		if (_DEBUG){ console.log('>>>>>>>>>>>isWebView: ' + ax.ext.ui.isWebView); }
		if(!ax.ext.ui.isWebView){
			return;
		}
				
		ax.ext.ui.addWebView(function(result) {
			if (_DEBUG){ console.log('>>>>>>>>>>>addWebView: ' + result); }
		}, url, opts);
		
		//console.log('success call api');
		
	}
	
	function removeWebView() {
		ax.ext.ui.removeWebView(function() {}, 'webView');
	}
	
	
	function _initAndroid() {
		try{

			var onBackPressed = function() {
				
				if (xx.page.isToggleMenu) {
					xx.page.toggleMenu();
					return;
				}
				
				var currentPage = xx.page.currentPage();
				
				if (currentPage === 'pageSelectFace') {
					app.button.onButtonTouched('btnSelectBack', 'pageSelectFace');
					return;
				} else if (currentPage === 'pageFinding') {
					if (_DEBUG) { console.log('finding 중에는 백으로 못갑니다!!'); }
					return;
				}
				if (xx.page.history.length > 1) {
					if($('#mainBigBiz').length > 0){
						xx.scroll.wrapperMain.scrollTo(0, 0);
					}
					xx.page.back();
					return;
				}
	
				ax.ext.ga.stopTracker();
				ax.ext.android.finish();
				
				/* 
				ax.ext.ui.confirm(function(res) {
					if (res) {
						
						try {
							ax.ext.android.finish();
						} catch(e) {
							ax.ext.ios.finish();
						}
					}
				}, app.nls.get('quit'));
				*/
			};

			ax.ext.android.setOnBackPressed(onBackPressed);
			

		}catch(e) {
			// iOS? WAC?
		}
	}
	if (xx.page.platform === 'android') {
		_initAndroid();
	}

	function refreshAdmob() {
		g.com.appspresso.plugin.admob.refreshAdmob();
	}
	
	function hideAdmob() {
		_isAdmobShown = false;
		if (xx.page.platform) { //  === 'android') {
			g.com.appspresso.plugin.admob.hideAdmob();
		} else {
			ax.ext.admob.hideAdmob(ADMOB_PUB_ID);
		}
		
	}
	
	
	function _setShareCount(count) {
		_shareCount = count;
		setPreference('shareCount', _shareCount);
	}
	
	function _getShareCount() {
		
		//if (_shareCount === null) {
			_shareCount = getPreference('shareCount') || 0;
			_shareCount = parseInt(_shareCount, 10);	
		//}
		
		return _shareCount;
	}


    function _showReviewMarketList(checkPage) {

        var links = [
            app.nls.get("review_market_android_link"),
            app.nls.get("review_market_olleh_link"),
            app.nls.get("review_market_tstore_link"),
            app.nls.get("review_market_uplus_link"),
            app.nls.get("review_market_samsung_link"),
            app.nls.get("review_market_lg_link"),
            app.nls.get("review_market_nhn_link")
        ];

        var arrayItems = [
            app.nls.get("review_market_android"),
            app.nls.get("review_market_olleh"),
            app.nls.get("review_market_tstore"),
            app.nls.get("review_market_uplus"),
            app.nls.get("review_market_samsung"),
            app.nls.get("review_market_lg"),
            app.nls.get("review_market_nhn")
        ];

        var scb = function(pickedButtonIdx){
            if (_DEBUG) { console.log('picked button idx: ' + pickedButtonIdx); }


//			_kmq.push(['record', 'Selected market in ' + checkPage, {
//				'market': arrayItems[pickedButtonIdx]
//			}]);
            ax.ext.ui.open(links[pickedButtonIdx]);
        };

//		_kmq.push(['record', 'Market list is shown in ' + checkPage, {
//			'OS':xx.page.platform,
//			'OS Version': xx.page.os,
//			'App Version': app.def.APP_VERSION,
//			'Language': app.nls.lang,
//			'Model': xx.page.model
//		}]);


        var opts = {'title': app.nls.get('review_market_title')};
        //var opts = {'cancel':'Cancel Button'}; // only for iOS
        //var opts = {'destructive':'Destructive Button'}; // only for iOS
        //var opts = {'cancel':'Cancel Button', 'destructive':'Destructive Button'}; // only for iOS

        ax.ext.ui.pick(scb, arrayItems, opts);
    }

    function reviewCountCheck(checkPage) {
        if (_DEBUG) { console.log('android 3.0.3 / ios 3.0.2에서 리뷰유도얼럿 제거 (매소드 내용 주석처리함)'); }

//if (xx.page.platform === 'android') { return; } // JPUDINGINSIG-783
//
//		var reviewGameCount = getPreference('reviewGameCount') || 0,
//			reviewAppVersion = getPreference('reviewAppVersion') || 0,
//			reviewCheckTTL = getPreference('reviewCheckTTL') || 0,
//			currentTime = new Date().getTime();
//		
//		reviewGameCount = parseInt(reviewGameCount, 10);
//		reviewCheckTTL = parseInt(reviewCheckTTL, 10);
//		
//		reviewGameCount++;
//		
//		if (_DEBUG) { console.log('reviewCountCheck', reviewGameCount, reviewAppVersion, reviewCheckTTL, currentTime); }
//		
//		if (reviewAppVersion === app.def.APP_VERSION) { return; }	// 본 버전에서 리뷰 남긴 유저
//		if (reviewCheckTTL > currentTime) { return; }	// 리뷰 싫어 버튼 누른 뒤 7일이 지났는지 체크
//		
//		setPreference('reviewGameCount', reviewGameCount);
//		
//		if (reviewGameCount%3 === 0) {
//			var opts = {'positive': app.nls.get('review_alert_btn_ok'), 'negative': app.nls.get('review_alert_btn_cancel')};
//			
//			//_kmq.push(['record', 'Review alert']);
//			
//			ax.ext.ui.confirm(function(res) {
//				if (res) {
//					//_kmq.push(['record', 'Yes_review in ' + checkPage]);
//					
//					if (xx.page.platform === 'android') {
//						//_kmq.push(['record', 'Selected market in ' + checkPage]);
//						_showReviewMarketList(checkPage);
//					} else {
//						ax.ext.ui.open(app.def.STORE_APPSTORE);
//					}
//					setPreference('reviewAppVersion', app.def.APP_VERSION);
//				} else {
//					//_kmq.push(['record', 'No_review in ' + checkPage]);
//					
//					reviewCheckTTL = currentTime + 86400 * 1000 * 7;
//					setPreference('reviewCheckTTL', reviewCheckTTL);
//				}
//			}, app.nls.get('review_alert_message'), opts);
//		}
	}


	if (typeof g.app === 'undefined') {
		ax.def(g).constant('app', {});		
	}
	
	ax.def(oCommon)
		.property('isLoading', function(){ return _globalLoading; }, function(tf){ showLoading(tf); })
		.property('loadStatus', function() { return _status; })
		.property('isAdmobShown', function() { return _isAdmobShown; })
		.property('inappBackground', function() { return _inappBackground; }, function(tf) { _inappBackground = tf; })
		.property('isNetworkError', function(){ return _isNetworkError; }, function(tf) { _isNetworkError = tf; })
		.property('shareCount', _getShareCount, _setShareCount)
        .property('useKM', function() { return _useKM; }, function(tf) { _useKM = tf; })
        .property('groupPrefix', function() { return _groupPrefix; }, function(prefix) { _groupPrefix = prefix; })
        .property('recommendStarMode', function() { return _recommendStarMode; }, function(mode) { _recommendStarMode = mode; })
		.method('saveStatus', saveStatus)
		.method('addWebView', addWebView)
		.method('removeWebView', removeWebView)
		.method('showProgress', showProgress)
		.method('hideProgress', hideProgress)
		.method('addScript', addScript)
		.method('getPreference', getPreference)
		.method('setPreference', setPreference)
		.method('trackPageview', trackPageview)
		.method('trackEvent', trackEvent)
		.method('showAdmob', showAdmob)
		.method('refreshAdmob', refreshAdmob)
		.method('hideAdmob', hideAdmob)
		.method('startGA', startGA)
		.method('alert', alert)
		.method('reviewCountCheck', reviewCountCheck)
		.method('showReviewMarketList', _showReviewMarketList)
		.method('destroyGoBattleLayer', destroyGoBattleLayer)
		.method('goGoBattleLayer', goGoBattleLayer);
	
	ax.def(g.app).constant('common', oCommon);

}(window));

