/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		_DEBUG = g._DEBUG || false;
	
	var SVC_KEY = 'face',
		APP_VERSION = '3.2.1',
		LANG = g.app.nls.lang,
		KTH_USAGE_KEY = 'Pudding_Face_Match',
		KTH_USAGE_EVENT = 'APP_START';
	
	if (xx.page.platform === 'android') {
		SVC_KEY = 'anface';
		APP_VERSION = '3.2.4';
	}

	
	// in production
	var API_PREFIX = 'http://api.pudface.pudding.kr/';
	
	// in development
	// API_PREFIX = 'http://211.113.54.175/';	// mtest
	// KTH_USAGE_EVENT = 'APP_START_DEV';
	
	var ETAG = ' puddingface/' + APP_VERSION;

	var oDef = {
		SVC_KEY: SVC_KEY,
		APP_VERSION: APP_VERSION,
		KTH_USAGE_KEY: KTH_USAGE_KEY,
		KTH_USAGE_EVENT: KTH_USAGE_EVENT,

		API_SUCCESS_CODE: '0x02000', 
		
		// mandatory headers for apis
		API_HEADERS: { 'Accept': 'application/json', 'ETag': ETAG, 'referer': '', 'User-Agent': '' },
		
		// timeout for apis
		TIMEOUT_API_DEFAULT: 10*1000,
		TIMEOUT_API_DRIVEINFO: 15*1000,
		TIMEOUT_API_UPLOAD: 20*1000,
		TIMEOUT_API_WHOIS: 10*1000,
		TIMEOUT_API_FIND: 10*1000,

		// XXX: special errors for apis
		ERROR_CANCEL: 'ERROR_CANCEL',
		ERROR_TIMEOUT: 'ERROR_TIMEOUT',
		
		// poststat() params
		POSTSTAT_TWITTER: 'sendpublishtw',
		POSTSTAT_FACEBOOK: 'sendpublishfb'

	};
	
	/* API_WHOIS */
	oDef.API_WHOIS					= API_PREFIX + 'pudface//match/whois?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';

	/* MAIN PAGE */
	oDef.API_NOTICE					= API_PREFIX + 'pudface/main/notice?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&enabled=Y';
	oDef.API_MAIN_INFO				= API_PREFIX + 'pudface/main/info?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG;
	
	/* FACE DETECT */
	oDef.API_FACE_DETECT			= API_PREFIX + 'pudface/match/detect?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&fileUrl=';
	oDef.API_CROP					= API_PREFIX + 'pudface/match/makeThumbImg?svckey=' + SVC_KEY + '&fileUrl={0}&rect={1}&faceId=0';
		
	/* BATTLE APIS */
	oDef.API_BATTLE_INFO			= API_PREFIX + 'pudface/battle/info?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';
	
	oDef.API_BATTLE_STAR_RANDOM		= API_PREFIX + 'pudface/battle/random?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';
	oDef.API_BATTLE_STAR_SEARCH		= API_PREFIX + 'pudface/battle/search/keyword/{0}?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';
	oDef.API_BATTLE_STAR_GALLERY	= API_PREFIX + 'pudface/battle/search/whoid/{0}?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';
	oDef.API_BATTLE_REQUEST			= API_PREFIX + 'pudface/battle/whois?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&'; //+ '&mode=random&fileUrl=http://uccfs.paran.com/PUD/fa/ce/FACE/STAR_457/457_93998_130.jpg&featureId=16088&whoId=475&imgId=1&featureList=TEST1&imgId=0&featureList=TEST3';
	
	oDef.API_BATTLE_STAR_RECOMMEND	= API_PREFIX + 'pudface/battle/search/info?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';
    oDef.API_CHALLENGE_STAR_RECOMMEND	= API_PREFIX + 'pudface/challenge/info?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';

    // DEV
    //oDef.API_CHALLENGE_STAR_RECOMMEND	= 'http://211.113.54.175/' + 'challenge/info?svckey=' + SVC_KEY + '&v=' + APP_VERSION + '&lang=' + LANG + '&starCategory=';

	/* UPLOAD - for iOS */
	oDef.API_UPLOAD					= 'http://pudfaceup.paran.com/partner/faceImgUpJson_v2.jsp'; 
	
	/* UPLOAD -dev server */
	//oDef.API_UPLOAD					= 'http://211.113.46.201/partner/faceImgUpJson.jsp';
	
	oDef.STORE_APPSTORE				 = 'http://itunes.apple.com/kr/app/id378461555';	// 앱스토어. 안드로이드 마켓 링크는 messages.json파일에 정의	
	
	if (xx.page.platform === 'android') {
		oDef.FEATURE_FILE_NAME			= 'bin';
	} else {
		oDef.FEATURE_FILE_NAME			= 'pgm';
	}
	
	if (typeof g.app === 'undefined') {
		ax.def(g).constant('app', {});		
	}

	ax.def(g.app).constant('def', oDef);

// }catch(e){
// console.log('app_definition.js err ' + e.message);
// }
}(window));