/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		_DEBUG = !!g._DEBUG;
		
	var _messages = {},
		_lang = null,
		_langApp = null,
		NLS_CLS_PREFIX = 'nls_',
		NLS_SELECTOR = '.nls',
		NLS_KEY_ATTR = 'nls-key';

	function load(lang, callback, errback) {
		if (!lang) {
			if (xx.page.platform === 'android') {
				var ua = navigator.userAgent;
				
				if (/(ko-kr)/i.test(ua)) {
					lang = 'ko';
				} else if (/(ja-jp)/i.test(ua)) {
					lang = 'ja';
				} else if (/(zh-cn|zh-tw)/i.test(ua)) {
					lang = 'zh';
				} else {
					lang = 'en';
				}
			} else {
				lang = navigator.language.substring(0, 2);
			}
		}
		if(lang !== 'en' && lang !== 'ja' && lang !== 'zh' && lang !== 'ko') {
			lang = 'en';
		}
	
		// remove all nls_ class
		var htmlNode = $(document.documentElement);
//		$.each(htmlNode.attr('class').split(/\s+/), function(index, cls) {
//			if(cls.indexOf(NLS_CLS_PREFIX) === 0) {
//				htmlNode.removeClass(cls);
//			}
//		});
		// add applied nls_ class
		
	
		var nlsFileDir =  (lang === 'ko' || lang === 'ja') ? lang : 'en';
		_langApp = nlsFileDir;
        // lang = "ja";  _langApp = "ja";
		var msgFile = 'wgt-package/locales/' + nlsFileDir + '/messages.json';
		htmlNode.addClass(NLS_CLS_PREFIX + nlsFileDir);
		htmlNode.attr('lang',nlsFileDir);//html에 lang속성 추가

		_lang = lang;
		
		if (_DEBUG === '????') {	//XXX: 왜  ajax가 더 빨리 로딩될까??
			xx.fexplorer.readFile(msgFile, false, function(data) {
					_messages = JSON.parse(data);
					if(_DEBUG) { console.log('nls load success:', _messages); }
					if(typeof callback === 'function') { callback(lang); }
				},
				function(e) {
					_lang = 'en';
					if (_DEBUG) { console.log('nls load err:', e.message); }
					if (typeof errback === 'function') { errback(); }
				}
			);
		} else {
			$.ajax({
				url: 'locales/' + nlsFileDir + '/messages.json',
				success: function(data) {
					_messages = data;
				},
				error: function(e) {
					console.log('DEBUG nls messages.json load err', ax.util.dump(arguments));
				}
			});
		}
	}
	load();
	
	function get(key) {
		var msg = _messages[key];
		if (arguments.length === 1) {
			return msg;
		}
		if(!msg) { return null; }
		var args = Array.prototype.slice.call(arguments);
		args[0] = msg;
		return ax.util.format.apply(null, args);
	}
	
	function update(rootNode) {
		$(NLS_SELECTOR, rootNode).each(function(index, node) {
			var key = $(node).attr(NLS_KEY_ATTR);
			if(key) {
				var msg = _messages[key];
				if(msg) {
					$(node).html(msg);
				}
			}
		});
	}

    if (typeof g.app === 'undefined') {
        ax.def(g).constant('app', {});
    }

    //-------------------------------------------------------------
	var nls = {};
	
	ax.def(nls)
		.method('load', load)
		.method('get', get)
		.method('update', update)
		.property('messages', function() { return _messages; })
		.property('lang',  function() { return _lang; })
		.property('langApp', function() { return _langApp; });

	ax.def(g.app).constant('nls', nls);

// }catch(e){
// console.log('app_nls.js def err ' + e.message);
// }
}(window));

