/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG,
		pageID = 'pageBattle',
		oPage = {};

	var _carouselItemWidth,
		pref = app.common.getPreference(),
		_battleMode = 'random';	// random || search	(pageBattleSearch에서 참조됨)

	var _onTouchEnd = function(e){
		
		var target = e.target,
			i=4,
			targetButton;

		while(i--) {
			if(target.tagName === 'LI') {
				targetButton = $(target).attr('title');
				break;
			}
			target = target.parentNode;
		}

		if (targetButton) {
			$(target).addClass('pressed');

            //if (app.common.useKM) {
            //    g._kmq.push(['record', '모드선택']);
            //}

			setTimeout(function(){
				$(target).removeClass('pressed');
				
				if(targetButton === 'btnBattleR') {
					_battleMode = 'random';
					xx.page.pageBattleSearch.show();
				} else if (targetButton === 'btnBattleL') {
					if (_DEBUG) { console.log('라이징 모드는 phase1에선 빼기??'); }
				} else if (targetButton === 'btnBattleS') {
					_battleMode = 'search';
					xx.page.pageBattleSearch.show();
				}
			}, 150);
		}
	};
		
	function _initCarouselWithServerData(iconSet) {
		try{
			var data = ['R','S'];
			
			if (_DEBUG) { console.debug('battle mode info: ', ax.util.dump(iconSet)); }
		
			var wrapper = document.getElementById('wrapperBattle'),
				i,
				len;
			
			var template,
				html = '',
				mode,
				icons = {
					F: 'image/battle_icon_f.png',	// free
					H: 'image/battle_icon_h.png',	// hot
					E: 'image/battle_icon_e.png',	// event
					P: 'image/battle_icon_p.png'	// paid
				},
				buttons = {
					R: 'image/battle_img1.png',
					S: 'image/battle_img2.png',
					L: 'image/battle_img3.png'
				},
				titles = {
					R: app.nls.get('battle_title_random'),
					S: app.nls.get('battle_title_search'),
					L: app.nls.get('battle_title_rising')
				},
				descs = {
					R: app.nls.get('battle_desc_random'),
					S: app.nls.get('battle_desc_search'),
					L: app.nls.get('battle_desc_rising')
				};
				

			for (i=0, len=data.length; i<len; i++) {
				template = $("#" + pageID + ' .template').clone()[0];
				mode = data[i];
				
				template.querySelector('.txt img').src = buttons[mode];
				template.querySelector('.txt p').innerHTML = titles[mode];
				template.querySelector('.txt span').innerHTML = descs[mode];
				
				if (typeof iconSet[mode] !== 'undefined') {
					template.querySelector('.icon img').src = icons[iconSet[mode]];
				} else {
					template.querySelector('.icon img').className = 'hide';
				}
				template.querySelector('li').title = 'btnBattle' + mode;
				if (mode === 'S') {
					template.querySelector('li').className = 'selected';
				}
				
				html += template.innerHTML;
			}
			
			
			$('#wrapperBattle #thelist').html(html);
			
			var bb = wrapper.querySelectorAll('li'),
				screenWidth = window.innerWidth,
				itemWidth = screenWidth * 220 / 320;
			len = bb.length;
			
			wrapper.querySelector('.scroller').style.width = (itemWidth*(len)) + 'px';
			while(len--) {
				bb[len].style.cssText = 'width:' + screenWidth + 'px; left: ' + itemWidth*len + 'px; ';
			}
			
			g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = itemWidth;
			_carouselItemWidth = itemWidth;
			
			var scrollOption = {
					'wrapperId': 'wrapperBattle',
					scrollbarClass: 'noScroll',
					hScrollbar: false,
					snap: true,
					momentum: false,
					bounce: true,
					useTransform: true,
					onTouchEnd: _onTouchEnd
				};
			xx.scroll.addScroll(scrollOption);
			
			setTimeout(function() {
				$(wrapper).animate({opacity:1}, 1000);
			},500);
		} catch (e) {
			console.log('_initCarousel err', e.message);
		}
	}
	
	function _onScrollEnd() {
		$('.wrap-battlepage span.state').removeClass('on').after(function(){
			$($('.wrap-battlepage span.state')[xx.scroll.wrapperBattle.currPageX]).addClass('on');
		});
		//$('#pageBattle .scroller li').removeClass('current').after(function(){
			//$($('#pageBattle .scroller li')[xx.scroll.wrapperBattle.currPageX]).addClass('current');
		//});
	}
	
	function _updateIcon(iconSet) {
			var i,
				len,
				mode,
				icons = {
					F: 'image/battle_icon_f.png',	// free
					H: 'image/battle_icon_h.png',	// hot
					E: 'image/battle_icon_e.png',	// event
					P: 'image/battle_icon_p.png'	// paid
				},
				buttons = {
					R: 'image/battle_img1.png',
					S: 'image/battle_img2.png',
					L: 'image/battle_img3.png'
				},
				titles = {
					R: app.nls.get('battle_title_random'),
					S: app.nls.get('battle_title_search'),
					L: app.nls.get('battle_title_rising')
				},
				descs = {
					R: app.nls.get('battle_desc_random'),
					S: app.nls.get('battle_desc_search'),
					L: app.nls.get('battle_desc_rising')
				};
			
			if (_DEBUG) { console.debug(ax.util.dump(iconSet)); }

			for (mode in iconSet) {
				if (iconSet.hasOwnProperty(mode)) {
					
					if (mode === 'R') {
						$('#wrapperBattle li .icon img')[0].src = icons[iconSet[mode]];
						$('#wrapperBattle li .icon img')[0].className = ''; 
					} else if (mode === 'S') {
						$('#wrapperBattle li .icon img')[1].src = icons[iconSet[mode]];
						$('#wrapperBattle li .icon img')[1].className = ''; 
					}
				}
			}
						
			
	}
		
	function initPage() {
		//app.nls.update('#pageBattle');
		
		var wrapper = document.getElementById('wrapperBattle'),
				i,
				len;
				
		var bb = wrapper.querySelectorAll('li'),
			screenWidth = window.innerWidth,
			itemWidth = screenWidth * 220 / 320;
		len = bb.length;
		
		wrapper.querySelector('.scroller').style.width = (itemWidth*(len)) + 'px';
		while(len--) {
			bb[len].style.cssText = 'width:' + screenWidth + 'px; left: ' + itemWidth*len + 'px; ';
		}
		
		g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = itemWidth;
		_carouselItemWidth = itemWidth;
		
		var scrollOption = {
				'wrapperId': 'wrapperBattle',
				scrollbarClass: 'noScroll',
				hScrollbar: false,
				snap: true,
				momentum: false,
				bounce: true,
				useTransform: true,
				onTouchEnd: _onTouchEnd,
				onScrollEnd: _onScrollEnd
			};
		xx.scroll.addScroll(scrollOption);
		
		setTimeout(function() {
			$(wrapper).animate({opacity:1}, 400);
		},500);
		
		
		
		var url = app.def.API_BATTLE_INFO + pref.starCategory;
		if (_DEBUG) { console.log('BATTLE_INFO url', url); }
		
		var errback = function(e) {
			if (_DEBUG) { console.log('BATTLE_INFO ERR', e.message); }
		};
		
		var callback = function(result) {
			if (_DEBUG) { console.log('BATTLE_INFO SUCCESS', result); }
			try {
				var data = app.api.validateResponse(result),
					iconSet = {},
					key;
					
				if (data !== null) {
					data = data.battleInfo;
					for(key in data){
						if (data.hasOwnProperty(key)) {
							iconSet[data[key].mode] = data[key].layer;
						}
					}
				}
				_updateIcon(iconSet);
			} catch(e) {
				errback(e);
			}
		};
		
		// setTimeout(function(){
			// _initCarousel({});
		// }, 500);
		
		ax.ext.net.curl({
			method:'GET',
			url: url,
			headers: app.def.API_HEADERS,
			timeout: app.def.TIMEOUT_API_DEFAULT,
			success: callback,
			error: errback
		});
	
	}

	ax.def(oPage)
	.property('carouselItemWidth', function(){ return _carouselItemWidth;})
	.property('battleMode', function() { return _battleMode; }, function(mode) { _battleMode = mode; })
	.method('initPage', initPage);

	ax.def(g.app).constant(pageID, oPage);

	//initPage();	// 즉시초기화!!
// }catch(e){
	// console.log('app_page_battle.js def err ' + e.message);
// }
}(window));

