/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG;

	var _shareImageFile = (xx.page.platform === 'android') ? 'removable/pud/pudface3.jpg' : 'wgt-private-tmp/pudface3.jpg';
	
	var _shareOpts = {};
	
	function _showShareText(headline) {
		xx.page.pageShare.querySelector('.header h2').innerHTML = headline;
		
		var headerSize = xx.page.admobHeight;
		
		var text = app.nls.get('share_text');
		var opts = {
			'height': xx.page.screenHeight/2 - headerSize,
			'left': 0,
			'maxLength': 100,  
			'top': headerSize,
			'width': xx.page.screenWidth
		};
		
		ax.ext.ui.addTextView(function(){
			app.common.isLoading = false;
		}, text, opts);
		xx.page.pageShare.show();
	}
	
	
	var _targetBannerIsHidden = false;
	function _captureScreenBefore() {
		
		app.common.hideAdmob();
		$('.sns_wrapper').each(function() {
			$(this).addClass('hide');
		});
		$('#pageFound .header button').addClass('hide');
		$('#pageBattleResult .header button').addClass('hide');
        $('#pageChallengeResult .header button').addClass('hide');

        $('#wrapperFound').addClass('capture');
		$('#btn_battle_retry').addClass('hide');
		$('.txt_share').removeClass('hide');
		$('#battle_result_body').addClass('result-share');
        $('#challenge_result_body').addClass('result-share');


		if(!$('#whois_banner').hasClass('hide')) {
			_targetBannerIsHidden = true;
			$('#whois_banner').addClass('hide');
		} else {
			_targetBannerIsHidden = false;
		}
	}
	
	function _captureScreenAfter() {

		$('.sns_wrapper').each(function() {
			$(this).removeClass('hide');
		});
		
		if (xx.page.prePage !== 'pageMy') {
			$('#btn_battle_retry').removeClass('hide');
		}
		
		$('#pageFound .header button').removeClass('hide');
		$('#pageBattleResult .header button').removeClass('hide');
        $('#pageChallengeResult .header button').removeClass('hide');
		$('#wrapperFound').removeClass('capture');
		$('.txt_share').addClass('hide');
		$('#battle_result_body').removeClass('result-share');
        $('#challenge_result_body').removeClass('result-share');

		if (_targetBannerIsHidden) {
			$('#whois_banner').removeClass('hide');
		}
		app.common.showAdmob();
	}
	
	function shareFacebook(scb) {
		_shareOpts = {
			successCallback: function(txt) {
				xx.page.back();
				if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_send_ing')); }
				
				facebook.post(txt, _shareImageFile, function(){
					console.log('facebook upload successed!!');
					app.common.hideProgress();
					_captureScreenAfter();
					if (scb) { scb(); }
					app.common.shareCount++;
					app.common.alert(function(){}, app.nls.get('common_send_ok'));
					
				}, function(e){
					console.log('facebook upload failed', e.message);
					app.common.hideProgress();
					_captureScreenAfter();
					app.common.alert(function(){}, app.nls.get('common_send_failed'));
					
				});
			},
			errorCallback: function(e) {
				app.common.alert(function(){}, app.nls.get('common_send_failed'));
				app.common.hideProgress();
			}
		};
		
		
		var shareAction = function() {
			_captureScreenBefore();
			
			if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_save_ing')); }
		
			var capture = function() {
				ax.ext.media.captureScreen(function(){
                    if (xx.page.platform === 'android') { app.common.hideProgress(); }
                    _captureScreenAfter();
                    _showShareText(app.nls.get('share_headline_facebook'));
                }, function(e){
                    _captureScreenAfter();
                    console.log('saving share image for facebook err', e.message);
                    // CHECK: 콜백이 필요한가? ecb(e);
                }, {'out': _shareImageFile});
            };
			
			setTimeout(function() {
				
				if (xx.page.platform === 'android') {
					xx.fexplorer.deleteFile(_shareImageFile, function(){
						capture();
					}, function(e) {
						capture();
					});
				} else {
					capture();
				}
				
			}, 500);
		};
		
		if (!facebook.is_connected) {
			xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('setting_facebook');
			xx.page.pageEmpty.show();
			
			facebook.connect(function(){
				xx.page.back();
				setTimeout(function(){
					shareAction();
				}, 700);
			}, function(e){
				if (_DEBUG) { console.log('Facebook 연결 실패!!'); }
			});
		} else {
			shareAction();
		}
	}
	
	function shareTwitter(scb) {
		_shareOpts = {
			successCallback: function(txt) {
				xx.page.back();
				if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_send_ing')); }
				
				twitter.upload(_shareImageFile, txt, function(){
					console.log('twitter upload success!!');
					app.common.hideProgress();
					_captureScreenAfter();
					if (scb) { scb(); }
					app.common.shareCount++;
					app.common.alert(function(){}, app.nls.get('common_send_ok'));

				}, function(e){
					console.log('twitter upload failed', e.message);
					app.common.hideProgress();
					_captureScreenAfter();
					app.common.alert(function(){}, app.nls.get('common_send_failed'));

				});
			},
			errorCallback: function(e) {
				app.common.alert(function(){}, app.nls.get('common_send_failed'));
				app.common.hideProgress();
			}
		};
		
		
		
		var shareAction = function() {
			if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_save_ing')); }
			_captureScreenBefore();
			
			var capture = function() {
				ax.ext.media.captureScreen(function(){
						if (xx.page.platform === 'android') { app.common.hideProgress(); }
						
						_showShareText(app.nls.get('share_headline_twitter'));
						_captureScreenAfter();
					}, function(e){
						_captureScreenAfter();	
					console.log('saving share image for twitter err', e.message);
                    // CHECK: 콜백이 필요한가? ecb(e);
				}, {'out': _shareImageFile});
			};
			
			setTimeout(function() {
				if (xx.page.platform === 'android') {
					xx.fexplorer.deleteFile(_shareImageFile, function(){
						capture();
					}, function(e) {
						capture();
					});
				} else {
					capture();
				}
			}, 500);
		};
		
		
		if (!twitter.is_connected) {
			xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('setting_twitter');
			xx.page.pageEmpty.show();
			
			twitter.connect(function(){
				xx.page.back();
				setTimeout(function(){
					shareAction();
				}, 700);
			}, function(e){
				if (_DEBUG) { console.log('트위터 연결 실패!!'); }
			});
		} else {
			shareAction();
		}
	}
	
	
	function shareGallery(scb) {
		_captureScreenBefore();
		
		if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_save_ing')); }
		
		var _share = function() {
			ax.ext.media.captureScreen(function(){
				if (xx.page.platform === 'android') { app.common.hideProgress(); }
			
				ax.ext.media.addToGallery(function(){						
						app.common.alert(function() {
							if (_DEBUG) { console.log('addToGallery SUCCESS!!!!'); }
						}, app.nls.get('share_gallery_ok'));
					}, function(e){
						if (xx.page.platform !== 'android') {
							app.common.alert(function() {
								if (_DEBUG) { console.log('addToGallery ERROR!!!!', e.message); }
							}, app.nls.get('share_gallery_failed'));
						}
					}, _shareImageFile);

				app.common.hideProgress();
				_captureScreenAfter();
	
				if (scb) { scb(); }
				

			}, function(e){
				if (_DEBUG) { console.log('saving share image for gallery err', e.message); }
			}, {'out': _shareImageFile});
		};
		
		xx.fexplorer.deleteFile(_shareImageFile, function(){ _share(); }, function(e){ _share(); });
	}
	
	function _shareMedia(shareTarget) {
		_captureScreenBefore();
		
		if (xx.page.platform === 'android') { app.common.showProgress(app.nls.get('common_save_ing')); }
		
		var _share = function() {
			ax.ext.media.captureScreen(function(){
				if (xx.page.platform === 'android') { app.common.hideProgress(); }
				g.plugin.mediashare.sendMedia(function(){
					if (_DEBUG) { console.log('share media success'); }
				}, function(e){
                    if (xx.page.platform === 'android') {
                        app.common.alert(function() {
                        }, app.nls.get('share_action_error'));
                    } else {
                        app.common.alert(function() {
                        }, app.nls.get('common_send_failed'));
                    }
				},{filepath: _shareImageFile, target: shareTarget || ''});
				
				_captureScreenAfter();

                // CHECK: 콜백이 필요한가? if (scb) { scb(); }
				
			}, function(e){
				if (_DEBUG) { console.log('saving share image for other apps err', e.message); }
			}, {'out': _shareImageFile});
		};
		
		xx.fexplorer.deleteFile(_shareImageFile, function(){ _share(); }, function(e){ _share(); });
		
	}
	
	function cancel() {
		xx.page.back();
	}
	
	function send() {
		ax.ext.ui.removeTextView(function(txt){
			_shareOpts.successCallback(txt);
		});
	}
	
	function _shareActionAndroid(idx, eventPage) {

        var shareList = [
            {name: '카카오톡', activity: 'com.kakao.talk'},
            {name: '카카오스토리', activity: 'com.kakao.story'},
            {name: '라인', activity: 'jp.naver.line.android'},
            {name: '푸딩투', activity: 'com.kth.pudding'},
            {name: '페이스북'},
            {name: '트위터'},
            {name: '사진첩'}
        ];

        try{
            console.log(ax.util.dump(shareList), shareList[idx].name, shareList[idx].activity);
        }catch(e){
            console.log('test', e.message);
        }
        app.common.trackEvent(eventPage, shareList[idx].name);

        switch(idx){
            case 0:
            case 1:
            case 2:
            case 3:
                _shareMedia(shareList[idx].activity);
                break;
            case 4:
                app.share.shareFacebook(function() {
                    app.common.trackEvent(eventPage, '페이스북-완료');
                });
                break;
            case 5:
                app.share.shareTwitter(function() {
                    app.common.trackEvent(eventPage, '트위터-완료');
                });
                break;
            case 6:
                app.share.shareGallery(function() {
                    app.common.trackEvent(eventPage, '사진첩-완료');
                });
                break;
            case 7:
                if (_DEBUG) { console.log('취소??'); }
                break;
        }
    }

    function _shareActionIOS(idx, eventPage) {
        switch(idx){
            case 0:
                app.common.trackEvent(eventPage, '다른앱으로보내기');
                _shareMedia();	//'com.kakao.talk');
//				if (eventPage === 'pageFound') {
//					_kmq.push([ 'record', 'celeb_share_to_other_apps' ]);
//				} else {
//					_kmq.push([ 'record', 'battle_share_to_other_apps' ]);
//				}
                break;
            case 1:
                app.common.trackEvent(eventPage, '페이스북');
                app.share.shareFacebook(function() {
                    app.common.trackEvent(eventPage, '페이스북-완료');
                });
                break;
            case 2:
                app.common.trackEvent(eventPage, '트위터');
                app.share.shareTwitter(function() {
                    app.common.trackEvent(eventPage, '트위터-완료');
                });
                break;
            case 3:
                app.common.trackEvent(eventPage, '사진첩');
                app.share.shareGallery(function() {
                    app.common.trackEvent(eventPage, '사진첩-완료');
                });
                break;
            case 4:
                if (_DEBUG) { console.log('취소??'); }
                break;
        }
    }

	function showShareMenu(eventPage) {
        //var _kmq = g._kmq;
		var scb = function(pickedButtonIdx){
		    console.log('picked button idx: ' + pickedButtonIdx);

            if (xx.page.platform === 'android') {
                _shareActionAndroid(pickedButtonIdx, eventPage);
            } else {
                _shareActionIOS(pickedButtonIdx, eventPage);
            }

		};
		 
		var arrayItems = [
					app.nls.get('share_headline_others'),
					app.nls.get('share_headline_facebook'),
					app.nls.get('share_headline_twitter'),
		            app.nls.get('share_headline_gallery')];

        if (xx.page.platform === 'android') {
            arrayItems = [
                app.nls.get('share_headline_kakaotalk'),
                app.nls.get('share_headline_kakaostory'),
                app.nls.get('share_headline_line'),
                app.nls.get('share_headline_puddingto'),
                app.nls.get('share_headline_facebook'),
                app.nls.get('share_headline_twitter'),
                app.nls.get('share_headline_gallery')];
        }

		var opts = {};
		if (xx.page.platform === 'android') {	
			// XXX: JPUDINGINSIG-603
			/*
			arrayItems.push(app.nls.get('share_headline_kakaotalk'));
			arrayItems.push(app.nls.get('share_headline_kakaostory'));
			*/
			arrayItems.push(app.nls.get('common_cancel'));
            opts.title = app.nls.get('share_list_title_android');
		} else {
			opts = {'destructive': app.nls.get('common_cancel')}; // only for iOS
		}

		
		//var opts = {'title':'Title'};
		//var opts = {'cancel':'Cancel Button'}; // only for iOS
		//var opts = {'destructive':'Destructive Button'}; // only for iOS
		//var opts = {'cancel':'Cancel Button', 'destructive':'Destructive Button'}; // only for iOS

		//if (app.common.useKM) {
		//	if (eventPage === 'pageFound') {
		//		_kmq.push([ 'record', 'share btn in celeb' ]);
		//	} else {
		//		_kmq.push([ 'record', 'share btn in battle' ]);
		//	}
		//}

		ax.ext.ui.pick(scb, arrayItems, opts);
	}
	
	var oShare = {};
	ax.def(oShare)
		.method('shareFacebook', shareFacebook)
		.method('shareTwitter', shareTwitter)
		.method('shareGallery', shareGallery)
		.method('cancel', cancel)
		.method('send', send)
		.method('showShareMenu', showShareMenu)
		.method('captureScreenBefore', _captureScreenBefore)
		.method('captureScreenAfter', _captureScreenAfter);
		
		
	// .property('photos', function(){ return _photos; })
	// .method('initPage', initPage);

	ax.def(g.app).constant('share', oShare);


// }catch(e){
	// console.log('app_share.js def err ', e.message); 
// }
}(window));
