/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageBattleSearchStar',
		oPage = {},
		_DEBUG = !!g._DEBUG;

    var findModeData,
        findModeDataPre;

	var recommendSelector = '#' + pageID + ' .recommand',
		searchSelector = '#' + pageID + ' .search-result';
		
	var _starInfo = {},	// 선택된 연예인 
		_star,	// app.BattleSearchStarGallery 에서 사용할 선택된 스타정보
		_starRecommend = {}; // 추천 연예인
		
	var _isKeyboardShown = false;
//    var _kmq = g._kmq;

    function checkMission(scb, starName) {
        var count = app.common.shareCount,
            title,
            message,
            ok = app.nls.get('common_ok');

        if (count >=3) {
            title = app.nls.get('lock_release_title');
            message = app.nls.get('lock_release_message');
//            _kmq.push(['record', 'celeb_unlock', {'celeb_name': starName}]);
        } else {
            title = app.nls.get('lock_mission_title');
            message = app.nls.get('lock_mission_message');
            message = ax.util.format(message, count);
//            _kmq.push(['record', 'celeb_lock', {'celeb_name': starName}]);
        }

        var opts = {'positive':ok, 'title':title};

        ax.ext.ui.alert(function() {
            if (count >=3) {
                scb();
                app.common.setPreference('_star_search_unlock', 'true');
                $('#wrapperBattleSearchStar ul li .grade.lock').removeClass('lock').addClass('unlock');
            }
        }, message, opts);

    }

    function _onTouchEnd(e) {
		var target = e.target,
			i=4;

		while(i--) {
			if(target.tagName === 'LI') {
				target.style.backgroundColor = '#ddd';
				break;
			}
			target = target.parentNode;
		}
		
		setTimeout(function(){
			target.style.backgroundColor = '';
			var starName = $(target).attr('data-starname');
			
            if (starName === 'random') {
                app.pageBattle.battleMode = 'random';
                if (app.pageBattleSearch) {
                    app.pageBattleSearch.resetStatus();
                }
                xx.page.pageBattleSearch.show();


                if (app.common.recommendStarMode === 'battle') {
                    app.common.trackEvent('닮은꼴배틀', '랜덤연예인선택');
                } else if (app.common.recommendStarMode === 'challenge') {
                    app.common.trackEvent('닮은꼴도전', '랜덤연예인선택');
                }

                return;
            }

            app.pageBattle.battleMode = 'search';

			if (starName) {
				_star = _starInfo[starName]; 
				xx.page.pageBattleSearchStarGallery.show();

                if (app.common.recommendStarMode === 'battle') {
                    app.common.trackEvent('닮은꼴배틀', '검색연예인선택');
                } else if (app.common.recommendStarMode === 'challenge') {
                    app.common.trackEvent('닮은꼴도전', '검색연예인선택');
                }
				return;
			}
			
			starName = $(target).attr('data-recommend');


            if (starName) {
				_star = _starRecommend[findModeData][starName];
				
				var layer = _starRecommend[findModeData][starName].layer;
//				var _kmqData = {
//					'F': 'celeb_free',
//					'E': 'celeb_event',
//					'P': 'celeb_paid',
//					'H': 'celeb_hot',
//					'L': 'celeb_lock'
//				};
				var showGallery = function() {
					xx.page.pageBattleSearchStarGallery.show();
				};
				
				var _name = _starRecommend[findModeData][starName].starName;
				
				if (layer === 'L' && app.common.getPreference('_star_search_unlock') !== 'true') {	//LOCK 타입
					checkMission(showGallery, _name);
				} else if (layer === 'L') {
//					_kmq.push(['record', 'celeb_unlock', {'celeb_name': _name}]);
					showGallery();
				} else {
//					_kmq.push(['record', _kmqData[layer], {'celeb_name': _name}]);
					showGallery();
				}

                if (app.common.recommendStarMode === 'battle') {
                    app.common.trackEvent('닮은꼴배틀', '추천연예인선택');
                } else if (app.common.recommendStarMode === 'challenge') {
                    app.common.trackEvent('닮은꼴도전', '추천연예인선택');
                }
                return;
			}



		}, 200);

	}
	
	function _showSearchResult(data) {
		var i=0, 
			len = data.length,
			html = '';
		
		if (_DEBUG) { console.log('_showSearchResult data', data); }	// XXX: 임시 Lock 이벤트 ㅠㅠ
		if (len === 0) { return; }
		
		for (i=0; i<len; i++) {
			_starInfo[data[i].name + i] = data[i];
			html += '<li data-starname="' + data[i].name + i + '"><div class="img thumnail"><img src="' + data[i].fileUrl +'" alt="' + data[i].name +'"></div><div class="txt">' + data[i].name + '</div></li>';
		}
		
		$(searchSelector + ' ul').html(html);
		$(searchSelector + ' .result').removeClass('hide');
		$(searchSelector + ' .noresult').addClass('hide');
		
		
		xx.scroll.wrapperBattleSearchStar.scrollTo(0,0);
		setTimeout(function() {
			xx.scroll.wrapperBattleSearchStar.refresh();
		}, 300);
		app.common.isLoading = false;
	}
	
	function search() {
		
		if (app.common.recommendStarMode === 'battle') {
			app.common.trackEvent('닮은꼴배틀', '검색');
		} else if (app.common.recommendStarMode === 'challenge') {
			app.common.trackEvent('닮은꼴도전', '검색');
		}
		
		
		var searchEl = $('#pageBattleSearchStar .search input');
		var name = searchEl.val();
		
		
		var searchStart = function() {
			if (name === '') {
				app.common.alert(function(){}, app.nls.get('battle_search_alert'));
				return;
			}
			app.common.isLoading = true;
			
			var url = ax.util.format(app.def.API_BATTLE_STAR_SEARCH , encodeURIComponent(name));
			
			url += app.common.getPreference('starCategory');
			if (_DEBUG) { console.log('API_BATTLE_STAR_SEARCH', url); }
			
			var callback = function(result) {
				try {
					var data = app.api.validateResponse(result);
					_showSearchResult(data.starList);
				} catch(e) {
					$(searchSelector + ' .result').addClass('hide');
					$(searchSelector + ' .noresult').removeClass('hide');
					app.common.isLoading = false;
					xx.scroll.wrapperBattleSearchStar.scrollTo(0,0);
					setTimeout(function() {
						xx.scroll.wrapperBattleSearchStar.refresh();
					}, 300);
				}
			};
			
			var errback = function(e) {
				if (_DEBUG) { console.log('API_BATTLE_STAR_SEARCH err', e.message, e.code); }
				app.common.alert(function(){ app.common.isLoading = false; }, app.nls.get('error_detect_message'));
			};
			
			
			ax.ext.net.curl({
				method:'GET',
				url: url,
				headers: app.def.API_HEADERS,
				timeout: app.def.TIMEOUT_API_DEFAULT,
				success: callback,
				error: errback
			});
		};
		
		if (xx.page.platform === 'android' && _isKeyboardShown === true) {
			g.bx.ext.screw.ui.removeTextView(function(txt) {
				_isKeyboardShown = false;
				name = txt;
				searchEl.val(txt);
				searchStart();
			});
		} else {
			searchEl[0].blur();
			searchStart();
		}
		
	}
	
	function initPage() {
		if (_DEBUG) { console.log('initPage', pageID); }
		//app.nls.update('#' + pageID);
		
		if (xx.page.platform === 'android') {
			$('#search_delete').unbind().bind('touchstart', function(){console.log('xxx');});
			$('#search_search').unbind().bind('touchstart', function(){console.log('xxx');});
			$('.close').unbind().bind('touchstart', function(){console.log('xxx');});
		}
		
		var height = xx.page.wrapperHeight - xx.page.admobHeight;
		$('#wrapperBattleSearchStar').css({height: height});
		
		var scrollOption = {
			'wrapperId': 'wrapperBattleSearchStar',
			onTouchEnd: _onTouchEnd
		};
		xx.scroll.addScroll(scrollOption);
			
	}
	
	function _renderRecommendStar() {
		if (_DEBUG) { console.log('_renderRecommendStar', _starRecommend[findModeData]); }

        if (findModeData !== findModeDataPre) {
            $('#wrapperBattleSearchStar .recommand ul').html('');
        }

		var i,
			len = _starRecommend[findModeData].length,
			star, 
			html = '',
			icons = {
				E: 'Event',
				H: 'Hot',
				F: 'Free',
				P: 'Paid',
				L: 'Lock'
			};
		
		if (app.common.shareCount >=3) {
			icons.L = 'unlock';
		}

		var iconClass;
		var className;
		for (i=0; i<len; i++) {
			try{
				star = _starRecommend[findModeData][i];

				if (icons[star.layer]) {
					iconClass = icons[star.layer];
					className = iconClass.toLowerCase();
				} else {
					iconClass = '';
					className = '';
				}

				html += '<li data-recommend="' + i + '"><div class="img thumnail"><img src="' + star.starImg + '" alt=" ' + star.starName + ' "><div class="grade ' + className + '"><span>' + iconClass + '</span></div></div>';
				html += '<div class="txt">' + star.starName + '</div></li>'; // <em class="icon"><img src="' + icons[star.layer] + '" alt="' + star.layer + '"/></em>
			} catch(e) {
				console.log('XXXX _renderRecommendStar err 여기로 들어오면 안됨', e.message);
			}
			//alert (star.layer);
		}

		$('#wrapperBattleSearchStar .recommand ul').html(html);
		$(recommendSelector).removeClass('hide');
        $('#pageBattleSearchStar .scroller').animate({opacity: 1});
		xx.scroll.wrapperBattleSearchStar.refresh();

		
	}
	
	function getRecommmendStar() {
        var url = '',
            ts = new Date().getTime();

        findModeDataPre = findModeData;

        xx.scroll.wrapperBattleSearchStar.scrollTo(0,0);

        if (app.common.recommendStarMode === 'battle') {
            $('#randombattle').show();
            findModeData = 'searchInfo';
            url = app.def.API_BATTLE_STAR_RECOMMEND + app.common.getPreference('starCategory');

        } else if (app.common.recommendStarMode === 'challenge') {
            $('#randombattle').hide();
            findModeData = 'challengeInfo';
            url = app.def.API_CHALLENGE_STAR_RECOMMEND + app.common.getPreference('starCategory');
        }

		if (_DEBUG) { console.log('API_BATTLE_STAR_RECOMMEND', url); }
		if (_starRecommend[findModeData] && _starRecommend[findModeData + '_ts'] < ts) {
            if (findModeData === findModeDataPre) {
                $('#pageBattleSearchStar .scroller').animate({opacity: 1});
                return;
            }
        }
		
		var errback = function(e) {
			if (_DEBUG) { console.log('API_BATTLE_STAR_RECOMMEND ERR', e.message); }
		};
		
		var callback = function(result) {
			try {
				if (_DEBUG) { console.log('API_BATTLE_STAR_RECOMMEND SUCCESS', result); }
				var data = app.api.validateResponse(result);
				//data.ts = ts + 60*60;
				_starRecommend[findModeData] = data[findModeData];
                _starRecommend[findModeData + '_ts'] = ts + 60*60;
				_renderRecommendStar();
			} catch(e) {
				errback(e);
			}
		};

		ax.ext.net.curl({
			method:'GET',
			url: url,
			headers: app.def.API_HEADERS,
			timeout: app.def.TIMEOUT_API_DEFAULT,
			success: callback,
			error: errback
		});

	}
	
	
	function showKeyboard(txt) {
		
		var width = xx.page.screenWidth;
		
		g.bx.ext.screw.ui.addTextView(function(actionId){
			_isKeyboardShown = true;
			if (actionId === '6') {
				search();
			}
		}, function(e){
			
		}, txt || '', {
			'height': 40,
			'left': 41, 
			'top': 53,
			'width': 150,
			'padding': 0
		});
		
		if (xx.scroll.wrapperBattleSearch ) {
			xx.scroll.wrapperBattleSearch.refresh();
		}
		
	}
	
	function hideKeyboard() {
		if (xx.page.platform === 'android' && xx.page.os < '4') {
			$('#pageBattleSearchStar .search input')[0].blur();
			g.bx.ext.screw.ui.removeTextView(function(){
				app.pageBattleSearchStar.isKeyboardShown = false;
			});
		} else {
			$('#pageBattleSearchStar .search input')[0].blur();
		}
	}

	function resetStatus() {
		hideKeyboard();
		$('#pageBattleSearchStar .search input').val('');
		$(searchSelector + ' ul').html('');
		$(searchSelector + ' .result').addClass('hide');
		$(searchSelector + ' .noresult').addClass('hide');

        $('#pageBattleSearchStar .scroller').css({opacity: 0});
	}
	
	ax.def(oPage)
		.property('star', function(){ return _star; })
		.property('starRecommend', function() { return _starRecommend; })
		.property('isKeyboardShown', function() { return _isKeyboardShown; }, function(tf) { _isKeyboardShown = tf; })
		.method('initPage', initPage)
		.method('search', search)
		.method('showKeyboard', showKeyboard)
		.method('hideKeyboard', hideKeyboard)
		.method('resetStatus', resetStatus)
		.method('checkMission', checkMission)
		.method('getRecommmendStar', getRecommmendStar);
		
	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); //즉시실행!!
	
	if (xx.page.platform === 'android' && xx.page.os < '4') {
		var searchEl = $('#pageBattleSearchStar .search input'); 
		searchEl.attr('disabled','true');
		searchEl.bind('touchstart', function() {
			showKeyboard(searchEl.val());
			_isKeyboardShown = true;
		});
	}
	
	$('#frmSearchStar').bind('submit',function(e){
		search();
		return false;
	});

// }catch(e){
	// console.log('page_battle_search_star.js def err ', e.message); 
// }
}(window));