/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageBattleSearchStarGallery',
		oPage = {},
		_DEBUG = !!g._DEBUG;
	
	var _photos;
	
	function _showGallery() {
		var i,
			len = _photos.length,
			template,
			item,
			column = 0,
			html = '',
			targetDiv;
		
		var thumbsize = parseInt(window.innerWidth * 0.25, 10);
		
		for (i=0; i<len; i++) {
			item = _photos[i];

			//if (_DEBUG) { console.log(ax.util.dump(item)); }
			if (column%3 === 0 ) {
				if (i>0) {
					html += template.innerHTML;
				}
				column = 0; 
				template = $("#" + pageID + ' .template').clone()[0];
			}
			
			if (_DEBUG) { console.log(item.fileUrl); }
			targetDiv = template.querySelectorAll('div')[column];
			targetDiv.style.cssText = 'background: url(\'' + item.fileUrl + '\');background-size: 100% 105%;width: ' + thumbsize + 'px;height: ' + thumbsize + 'px';
			targetDiv.title = i;

			column++;
		}

		html += template.innerHTML;

		$('#wrapperBattleSearchStarGallery ul').html(html);
		
		setTimeout(function(){
			xx.scroll.wrapperBattleSearchStarGallery.refresh();
		}, 500);
		
		app.common.isLoading = false;
	}
	
	function loadGallery(star) {
		app.common.isLoading = true;
		
		var url = ax.util.format(app.def.API_BATTLE_STAR_GALLERY, star.whoId);
		url += app.common.getPreference('starCategory');

		if (_DEBUG) { console.log('API_BATTLE_STAR_GALLERY', url); }
		
		var callback = function(result) {
			try {
				var data = app.api.validateResponse(result);
				_photos = data.starList;
				_showGallery();
			} catch(e) {
				xx.page.back();
			}
		};
		
		var errback = function(e) {
			ax.ext.ui.alert(function(){}, app.nls.get('error_battle_message'));
			app.common.isLoading = false;
			xx.page.back();
		};
		
		ax.ext.net.curl({
			method:'GET',
			url: url,
			headers: app.def.API_HEADERS,
			timeout: app.def.TIMEOUT_API_DEFAULT,
			success: callback,
			error: errback
		});
	}	
	
	function _onTouchEnd(e) {
		var target = e.target,
			idx = $(target).attr('title');
			
		if (idx) {
			if (_DEBUG) { console.log('selected Star', idx, _photos[parseInt(idx,10)]); }
			
			//xx.page.pageBattleSearchStar.hide();
			//app.pageBattleSearch.star = _photos[parseInt(idx, 10)];
			//xx.page.back();

            if (app.common.recommendStarMode === 'battle') {
                xx.page.pageBattleSearch.show(function() {
                    app.pageBattleSearch.star = _photos[parseInt(idx, 10)];
                    xx.page.pageBattleSearchStarGallery.hide();
                });
            } else {
                xx.page.pageChallenge.show(function() {
                    app.pageFind.challengeStar = _photos[parseInt(idx, 10)];
                    xx.page.pageBattleSearchStarGallery.hide();
                });
            }
		}
		
		e.stopPropagation();
		e.preventDefault();
	}
	
	function initPage() {
		console.log('initPage', pageID);
		//app.nls.update('#' + pageID);
		
		//var height = xx.page.wrapperHeight - xx.page.admobHeight*2;
		//$('#wrapperBattleSearchStarGallery').css({height: height});
		var height = xx.page.wrapperHeight - xx.page.admobHeight;
		
		$('#wrapperBattleSearchStarGallery').css({height: height});
		
		var scrollOption = {
			'wrapperId': 'wrapperBattleSearchStarGallery',
			scrollbarClass: 'noScroll',
			onTouchEnd: _onTouchEnd
		};
		xx.scroll.addScroll(scrollOption);
	}
	
	ax.def(oPage)
		.property('photos', function() { return _photos; })
		.method('initPage', initPage)
		.method('loadGallery', loadGallery);
		
	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!!

// }catch(e){
	// console.log('page_battle_search_star_gallery.js def err ', e.message); 
// }
}(window));
