/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		nls = app.nls,
		pageID = 'pageChallengeResult',
		oPage = {},
		_DEBUG = !!g._DEBUG;

	var _result;
	var _historyDir = 'documents/mychallenge/';

	var _isResultFromHistory;
	
	xx.fexplorer.createDirectory(_historyDir);
	
	function _renderResult() {
		try{
            var percent = '',
                similarity = _result.face[0].similarity,
                grade = 'grade_aplus';

            if (similarity >= 95) {
                grade = 'grade_aplus';
            } else if (similarity >= 90) {
                grade = 'grade_a';
            } else if (similarity >= 80) {
                grade = 'grade_bplus';
            } else if (similarity >= 70) {
                grade = 'grade_b';
            } else if (similarity >= 50) {
                grade = 'grade_c';
            } else {
                grade = 'grade_f';
            }

            var playerImage = _historyDir + '/' + _result.historyID + '/face.jpg';
            if (!_isResultFromHistory) {
                playerImage = _result.sourceImage;
            }


            $('#pageChallengeResult .wrap_result .grade')[0].className = 'grade ' + grade;

            $('#pageChallengeResult .wrpa_thumb.celeb div').css({'background': 'url(' + _result.fileUrl + ')'});
            $('#pageChallengeResult .wrpa_thumb.player div')
                .css({'background': 'url(/appspresso/file/' + playerImage + '?' + (new Date().getTime()) + ')'});


           var resultText =  ax.util.format(app.nls.get('challenge_txt'), _result.name);
           $('#pageChallengeResult .txt_name strong').html(resultText);


            if (similarity === 100) {
                percent += '<span class="num"><span>1</span></span> ';
                percent += '<span class="num"><span>0</span></span> ';
                percent += '<span class="num"><span>0</span></span> ';
            } else {
                percent += '<span class="num"><span>' + similarity.toString().charAt(0) + '</span></span> ';
                percent += '<span class="num"><span>' + similarity.toString().charAt(1) + '</span></span> ';
            }
            percent += '<span class="per"><span>%</span></span> ';
            
            $('#pageChallengeResult .percent').html(percent);
            
            //숫자를 랜덤으로 뿌려줌.
            setTimeout(function(){
                var timesRun = 0;
                var interval = setInterval(function(){
                    timesRun += 1;
                    var random = Math.floor(Math.random() * 10);
                    $('#pageChallengeResult .percent .num span').html(random);
                    if(timesRun === 60){
                        $('#pageChallengeResult .percent').html(percent);
                        clearInterval(interval);
                    }
                }, 10);
            }, 300);
            
            if (!_isResultFromHistory) {
                setTimeout(function(){
                    $('#pageChallengeResult .wrap_btn').removeClass('hide');
                }, 1000);
            }
            setTimeout(function(){
                $('#challenge_grade').css({opacity: 1, '-webkit-transform': 'scale(1)'}).after(function(){
//                    setTimeout(function(){
//                        $('#pageChallengeResult .percent').animate({opacity: 1}, 1000);
//                    }, 500);
                });
            }, 2000);

			
            //if (app.common.useKM) { g._kmq.push(['record', 'Challengeresult']); }
            
		}catch(e){
			if (_DEBUG) { console.log('_renderResult err', e.message); }
		}
	}

    function resetStatus() {
        $('#challenge_grade').css({opacity: 0, '-webkit-transform': 'scale(4)'});
        var percent = '<span class="num"><span>0</span></span>';
        percent += '<span class="num"><span>0</span></span>';
        percent += '<span class="num per"><span>%</span></span>';

//        $('#pageChallengeResult .percent').css({opacity: 0.2});
        $('#pageChallengeResult .percent').html(percent);
        $('#pageChallengeResult .wrpa_thumb.celeb div').css({'background': 'url(image/beacon.png)'});
        $('#pageChallengeResult .wrpa_thumb.player div').css({'background': 'url(image/beacon.png)'});
        $('#pageChallengeResult .wrap_btn').addClass('hide');
	}

	function _cleanMyHistory(count) {
		xx.fexplorer.dir(_historyDir, function(history){

			var i = 0,
				len = history.length - (count || 20);

//			if (xx.page.platform === 'android') {
//				i = count || 20;
//				len = history.length;
//			}

			history.sort();

			var delete_history = function(idx) {
				xx.fexplorer.deleteFile(_historyDir + history[idx], function(){
					if (_DEBUG) { console.log('_cleanMyHistory success ', _historyDir + history[idx], ' deleted!'); }
				}, function(e) {
					if (_DEBUG) { console.log('_cleanMyHistory err', _historyDir + history[idx], e.message); }
				});
			};

			for (i; i<len; i++) {
				delete_history(i);
			}

		}, function(e){
			if (_DEBUG) { console.log('cleanMyHistory err', e.message); }
		});
	}

	function _saveChallengeHistory(result) {

		var file = _historyDir + result.historyID + '/challenge.json',
			folder = _historyDir + result.historyID;


        xx.fexplorer.createDirectory(folder, function(){
            xx.fexplorer.writeFile(file, JSON.stringify(result), false, function(){
                _cleanMyHistory();
            }, function(e) {
                if (_DEBUG) { console.log('saveMyHistory writeFile err', e.message); }
            });

            if (_DEBUG) { console.log('플레이어 사진복사', result.sourceImage + ' to ' + folder + '/face.jpg'); }

            xx.fexplorer.copy(result.sourceImage, folder + '/face.jpg', function(){

            }, function(e) {
                if (_DEBUG) { console.log('saveMyHistory copy image err', e.message); }
            });

		});

		app.common.isLoading = false;

		if (app.pageMy) {
			app.pageMy.needTab3Refresh = true;
		}
	}

    function goSearch() {
        var starName = _result.queryName;

        xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('found_search_headline');
        xx.page.pageEmpty.show();
        app.common.trackEvent('pageChallengeResult', '연예인사진');

        if (_result.linkUrl) {
            app.common.addWebView(_result.linkUrl + encodeURIComponent(starName.replace('<br>', '')));
        } else {
            app.common.addWebView('http://www.google.co.kr/search?hl=' + nls.lang + '&source=pudding&lr=lang_ko&pws=0&q=' + encodeURIComponent(starName.replace('<br>', '')));
        }

    }

	function checkResult() {
		if (_DEBUG) { console.log('pageChallengeResult checkResult'); }
		//try{
		
		if (xx.page.prePage === 'pageMy') {
			_result = app.pageMy.historyChallengeResult;
			_isResultFromHistory = true;
			
			$('#btn_found_back').attr('title', 'btnBack');
			$('#btn_found_back img').attr('src', 'image/icon_back.png');
			
//			_updateKM('_my');
		} else {

            try {
                _result = app.pageFinding.result_challenge;
            } catch(e) {
                _result = ax.util.decodeJSON('{"face":[{"rank":1,"descript":"1\uc704\ud558\uae34 \ud588\ub294\ub370.. ","imgId":"0","similarity":95}],"fileUrl":"http://uccfs.paran.com/PUD/fa/ce/FACE/WHOID_2905/2905_20121019170317.jpg","name":"\uba4d\uc9c0\ud6a8","queryName":"\uba4d\uc9c0\ud6a8","mode":"challenge","featureId":"26319","whoId":"2905","linkUrl":"http://search.daum.net/search?w=tot&rtupcate=issue&rtupcoll=DQP,NNS&f=channel&nil_ch=24&q=","sourceImage":"removable/pud/pick1.jpg","historyID":1352110164560}');
            }


            console.log(ax.util.dump(_result));
			_saveChallengeHistory(_result);
			_isResultFromHistory = false;
			
			$('#btn_found_back').attr('title', 'btnHome');
			$('#btn_found_back img').attr('src', 'image/icon_home.png');
			
//			_updateKM('');
		}

		_renderResult();
	}
	


    function initPage() {
		//nls.update('#pageChallenge');

        $('#pageChallengeResult .wrpa_thumb.celeb div').bind('touchstart', goSearch);
	}
	

	ax.def(oPage)
		.property('result', function(){ return _result; })
		.method('checkResult', checkResult)
		.method('initPage', initPage)
		.method('resetStatus', resetStatus);

	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!!
	
// }catch(e){
	// console.log('page_found.js def err ', e.message); 
// }
}(window));
