(function(g){
try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		pageID = 'pageDevGallery',
		oPage = {},
		download = [],
		_DEBUG = !!g._DEBUG;

	var _cacheFacebook = 'documents/devgallery.json',
		_galleryDir = 'downloads/devgallery/',
		_upload_url = 'http://althjs.2do.kr/p/upload.html';

	var _tmpFile = 'wgt-private-tmp/pudface3.jpg';
	
	var _selectedFile,
		_selectedIndex = 1;
	var _responseData = {image:[], pgm:[]};

	xx.fexplorer.createDirectory(_galleryDir); 
	
	var readyButton = $('#pageDevGallery .btn'),
		readyArea = $('#pageDevGallery .selected-area .imgs');
	
	var _opts = {
		type: 0,  // 0: 닮은꼴 연예인찾기 - 1장 촬영 또는 겔러리 선택, 1: 닯은꼴 배틀 - 2장~4장 촬영 또는 겔러리 선택
		targetDir: 'wgt-private-tmp',
		targetFile: 'capture'
	};
	
	var _apiType;
	
	var _successCallback,
		_errorCallback;

	function _checkReady() {
		
		if (_opts.type === 0) {	//닯은꼴 연예인
			if (_selectedIndex >1) {
				$('#pageDevGallery .btn').show();
			}
		} else {	// 배틀
			if (_selectedIndex >2) {
				$('#pageDevGallery .btn').show();
			}
		}
	}
	
	function _step2_detect(imgUrl) {
		var url = app.def.API_FACE_DETECT;
		url+= imgUrl;
		
		console.log('detect url', url);
	
		
		
		var makeItem = function(info){	// 배틀용
			var targetFile = _opts.targetDir + '/' + _opts.targetFile + _selectedIndex;
			
			xx.fexplorer.writeFile(targetFile + '.pgm', info.imageid, true, function(){
				xx.fexplorer.copy(_selectedFile, targetFile + '.jpg', function(){
					_responseData.image.push(targetFile + '.jpg');
					_responseData.pgm.push(targetFile + '.pgm');
					
					_selectedIndex++;
					
					readyArea.html(readyArea.html() + '<img src="/appspresso/file/' + targetFile + '.jpg?' + (new Date().getTime()) + '"/>');
					app.common.isLoading = false;
					_checkReady();
				}, function(e){
					app.common.isLoading = false;
					alert('file 복사 실패!' + e.message);
				});
			}, function(e) {
				app.common.isLoading = false;
				alert('file  쓰기실패!' +  e.message);
			});
		};
		
		
		var makeRect = function(info) {	// 닯은꼴 연예인 찾기용
			try{
			var i,
				len = info.length,
				chk = len;
				
			for (i=0; i<len; i++) {
				
				(function(idx) {
					
					var targetFile = _opts.targetDir + '/' + _opts.targetFile + (i+1);
					
					xx.fexplorer.writeFile(targetFile + '.pgm', info[idx].imageid, true, function(){
						xx.fexplorer.copy(_selectedFile, targetFile + '.jpg', function(){
							_responseData.image.push(targetFile + '.jpg');
							_responseData.pgm.push(targetFile + '.pgm');
							
							if (_apiType === 'findFace') {
								_responseData.rect.push(info[idx].rect);
							}
							
							chk--;
							
							if (chk === 0) {
								xx.page.back();
								_successCallback(_responseData);
								
							}
						}, function(e){
							alert('file 복사 실패!' + e.message);
						});
					}, function(e) {
						alert('file  쓰기실패!' +  e.message);
					});
				})(i);
			
			}
			}catch(e){
				alert('rect err ' + e.message);
			}
		};
		
		var callback = function(response) {
			
			try {
				var data = app.api.validateResponse(response);
					data = data.battleFind[0];
					
				var pickItems = [],
					pgm;
				
				if (_apiType === 'findFace') {
					makeRect(data.detectionInfo);
				} else {
					if (data.detectionCnt > 1) {
						for (var i =0; i<data.detectionCnt; i++) { 
							pickItems.push(i + '번째 얼굴영역');
						}
						
						var scb = function(idx) {
							makeItem(data.detectionInfo[idx]);
						};
						
						var opts = {'title': '얼굴 영역을 선택하세요'};
						
						ax.ext.ui.pick(scb, pickItems, opts);
					} else {
						makeItem(data.detectionInfo[0]);
					}
				}
				console.debug(data);
			
			} catch(e) {
				//alert('얼굴인식 실패! ' + url + ' ' + e.message);
				xx.page.pageDevGallery.hide();
				_errorCallback(e);
				app.common.isLoading = false;
			}
			
			

		};
	
		var errback = function(){
			console.log(' detection api err', url, e.message);
			app.common.isLoading = false;
		};
		ax.ext.net.curl({
			method : 'GET',
			url : url,
			timeout : 2000,
			success : callback,
			error : errback
		}); 
	}
	
	function _step1_upload(file) {
		app.common.isLoading = true;
		
		 var callback = function(response) {
			console.debug('upload succes', response.data);
			_step2_detect(response.data);
		};
	
		var errback = function(){
			app.common.isLoading = false;
			console.log(' upload err', file, e.message);
		};

		var files = {'file1' : file};
		_selectedFile = file;
			
		ax.ext.net.curl({
			method : 'POST',
			url : _upload_url,
			files : files,
			timeout : 2000,
			success : callback,
			error : errback
		}); 
	}
	
	function _onTouchEnd(e){
		try{
			
			var allowCount = 4;
			if (_opts.type === 0) {
				allowCount = 1;	
			}
			
			if (_selectedIndex>allowCount) {
				// console.log('inventory is full!!');
				readyButton.css({'background-color': 'red'});
				setTimeout(function(){ readyButton.css({'background-color': 'green'});},200);
				return;
			}
			var target = e.target,
				filename = $(target).attr('title');
	
			$(target).addClass('selected');
			
			setTimeout(function(){
				$(target).removeClass('selected');
				
				var file = _galleryDir + filename;
				_step1_upload(file);
			}, 200);
			
			e.stopPropagation();
			e.preventDefault();
		} catch(e) {
			alert(e.message);
		}
	}
	
	
	function resetStatus() {
		_selectedFile = undefined;
		_selectedIndex = 1;
		_responseData = {image:[], pgm:[]};
		readyButton.hide();
		readyArea.html('');
		app.common.isLoading = false;
	}

	function captureImage(scb, ecb, opts) {
		_opts = opts;
		_apiType = 'captureImage';
		
		if (_opts.type === 0) {
			_responseData.rect = [];
		}
		
		_successCallback = scb;
		_errorCallback = ecb;
	}
	
	
	function findFace(scb, ecb, opts) {
		console.log('DEV GALLERY findFace', ax.util.dump(opts));
		
		_opts = opts;
		_responseData.rect = [];
		_apiType = 'findFace';
		
		_step1_upload(opts.sourceImage);
		
		_successCallback = scb;
		_errorCallback = ecb;
	}
	
	function initPage() {
		console.log('initPage', pageID);
			
		readyButton.bind('touchstart', function(e) {
			readyButton.addClass('pressed');
			setTimeout(function(){
				readyButton.removeClass('pressed');
				
				_successCallback(_responseData);
				xx.page.back();
			}, 200);
		});
		
		var tmpHeight = 130;
		if (xx.page.platform === 'android') {
			tmpHeight = 200;	
		}
		
		var scrollOption = {
				wrapperId:'wrapperDevGallery', 
				wrapperHeight: (xx.page.wrapperHeight - tmpHeight),
				onTouchEnd: _onTouchEnd
				//useLazyImageLoading: true
			};
		
		xx.scroll.addScroll(scrollOption);

	
		setTimeout(function() {
			$('#'+scrollOption.wrapperId).animate({opacity:1}, 1000);
		},500);
	}
	
	function loadGallery() {
		
		if (_apiType === 'findFace') { return; }
		
		var html = '',
			chk = 0;
			
		var callback = function(pics) {

			for (var i=0, len=pics.length, filename; i<len; i++) {
				filename = pics[i];
				
				chk = i%3;
				if(chk === 0) {
					html+='<li>';
				}
				
				html+= '<div title="' + filename + '" style="background: url(/appspresso/file/' + _galleryDir + encodeURIComponent(filename) + ');">&nbsp;</div>';
				
				if(chk === 2) {
					html+='</li>';
				}

			}
			
			$('#wrapperDevGallery ul').html(html);

			xx.scroll.wrapperDevGallery.refresh();
		};
		xx.fexplorer.dir(_galleryDir, callback);
	}
	
	function downloadDevImage(){
		
		app.common.isLoading = true;
		
		var iu = [
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg', 'downloads/devgallery/','1.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110839.jpg', 'downloads/devgallery/','2.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110849.jpg', 'downloads/devgallery/','3.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804111007.jpg', 'downloads/devgallery/','4.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804111022.jpg', 'downloads/devgallery/','5.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86540.jpg', 'downloads/devgallery/','6.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86541.jpg', 'downloads/devgallery/','7.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86542.jpg', 'downloads/devgallery/','8.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86543.jpg', 'downloads/devgallery/','9.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86544.jpg', 'downloads/devgallery/','10.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86547.jpg', 'downloads/devgallery/','11.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86548.jpg', 'downloads/devgallery/','12.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86559.jpg', 'downloads/devgallery/','13.jpg']];
		
		//xx.download.addFiles(iu, function(){console.log('>>>>>>> 아이유 사진 다운로드  done <<<<<<<');});
		
		var rain = [
			['http://211.42.140.173/starimg/newimg/15/15_171.jpg', 'downloads/devgallery/','14.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_173.jpg', 'downloads/devgallery/','15.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_174.jpg', 'downloads/devgallery/','16.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_175.jpg', 'downloads/devgallery/','17.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_177.jpg', 'downloads/devgallery/','18.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_20100628171201.jpg', 'downloads/devgallery/','19.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_20100628171224.jpg', 'downloads/devgallery/','20.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_20100628171254.jpg', 'downloads/devgallery/','21.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_20100628171339.jpg', 'downloads/devgallery/','22.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_20100628171351.jpg', 'downloads/devgallery/','23.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86948.jpg', 'downloads/devgallery/','24.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86949.jpg', 'downloads/devgallery/','25.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86950.jpg', 'downloads/devgallery/','26.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86976.jpg', 'downloads/devgallery/','27.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86977.jpg', 'downloads/devgallery/','28.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86978.jpg', 'downloads/devgallery/','29.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86979.jpg', 'downloads/devgallery/','30.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86980.jpg', 'downloads/devgallery/','31.jpg'],
			['http://211.42.140.173/starimg/newimg/15/15_86982.jpg', 'downloads/devgallery/','32.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg', 'downloads/devgallery/','1.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110839.jpg', 'downloads/devgallery/','2.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804110849.jpg', 'downloads/devgallery/','3.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804111007.jpg', 'downloads/devgallery/','4.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_20100804111022.jpg', 'downloads/devgallery/','5.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86540.jpg', 'downloads/devgallery/','6.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86541.jpg', 'downloads/devgallery/','7.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86542.jpg', 'downloads/devgallery/','8.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86543.jpg', 'downloads/devgallery/','9.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86544.jpg', 'downloads/devgallery/','10.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86547.jpg', 'downloads/devgallery/','11.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86548.jpg', 'downloads/devgallery/','12.jpg'],
			['http://211.42.140.173/starimg/newimg/1553/1553_86559.jpg', 'downloads/devgallery/','13.jpg'],
			['http://althjs.2do.kr/p/sample/1.JPG', 'downloads/devgallery/','33.jpg'],
			['http://althjs.2do.kr/p/sample/2.JPG', 'downloads/devgallery/','34.jpg'],
			['http://althjs.2do.kr/p/sample/3.JPG', 'downloads/devgallery/','35.jpg'],
			['http://althjs.2do.kr/p/sample/4.JPG', 'downloads/devgallery/','36.jpg'],
			['http://althjs.2do.kr/p/sample/5.JPG', 'downloads/devgallery/','37.jpg'],
			['http://althjs.2do.kr/p/sample/6.JPG', 'downloads/devgallery/','38.jpg'],
			['http://althjs.2do.kr/p/sample/7.JPG', 'downloads/devgallery/','39.jpg'],
			['http://althjs.2do.kr/p/sample/8.JPG', 'downloads/devgallery/','40.jpg'],
			['http://althjs.2do.kr/p/sample/9.JPG', 'downloads/devgallery/','41.jpg'],
			['http://althjs.2do.kr/p/sample/10.JPG', 'downloads/devgallery/','42.jpg'],
			['http://althjs.2do.kr/p/sample/11.JPG', 'downloads/devgallery/','43.jpg'],
			['http://althjs.2do.kr/p/sample/12.JPG', 'downloads/devgallery/','44.jpg'],
			['http://althjs.2do.kr/p/sample/13.JPG', 'downloads/devgallery/','45.jpg'],
			['http://althjs.2do.kr/p/sample/14.JPG', 'downloads/devgallery/','46.jpg']];
						
			
		xx.download.addFiles(rain, function(){
			console.log('>>>>>>> 비 사진 다운로드  done <<<<<<<');
			alert('임시 이미지를 다운로드 하였습니다. 다시한번 사진을 선택해 주세요.');
			
			app.common.isLoading = false;
			app.common.setPreference('_devgallery', 'true');
			xx.page.back();
		});
	}

	ax.def(oPage)
	.property('photos', function(){ return _photos; })
	.property('selected', function(){ return _responseData; })
	.method('initPage', initPage)
	.method('resetStatus', resetStatus)
	.method('captureImage', captureImage)
	.method('findFace', findFace)
	.method('loadGallery', loadGallery)
	.method('downloadDevImage', downloadDevImage);

	ax.def(g.app).constant(pageID, oPage);

}catch(e){
	console.log('page_dev_gallery.js def err ', e.message); 
}
})(window);

app.pageDevGallery.initPage();
