/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true, continue: true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageFacebookGallery',
		oPage = {},
		download = [],
		_DEBUG = !!g._DEBUG;

	var _cacheFacebook = 'documents/facebook.json',
		_photos,
		PAGING_COUNT = 24,
		_lastShownID = 0,
		_cacheFileCount = 100;
		
	var _tmpFile = (xx.page.platform === 'android') ? 'removable/pud/pudface3.jpg' : 'wgt-private-tmp/pudface3.jpg',
		_tmpDir = (xx.page.platform === 'android') ? 'removable/pud' : 'wgt-private-tmp';
		
	xx.fexplorer.createDirectory('downloads/fb'); 
	
	function _sortFeed(pics) {
		var i,
			j,
			len = pics.length,
			len2,
			p,
			allPhoto = {},
			newPhoto = {},
			sortKey = [];

		for(i=0; i<len; i++) {
			for (j=0, len2=pics[i].length; j<len2; j++) {
				p = pics[i][j];
				allPhoto[p.created_time] = p;
				sortKey.push(p.created_time);
			}
		}

		sortKey.sort(function(a, b) {
			if (a > b) { return -1; }
			if (b > a) { return 1; }
			return 0;
		});

		for(i=0,len=sortKey.length; i<len; i++) {
			newPhoto[allPhoto[sortKey[i]].id] = allPhoto[sortKey[i]];
		}
		return newPhoto;
	}
	
	function _onTouchEnd(e){

		var target = e.target,
			id = $(target).attr('title');

		if (id) {
			var url = _photos[id].source;
			
			app.common.isLoading = true;
			
			var callback = function(o){
                if (_DEBUG) { console.log('donwload facebook source image success:'); }

				var _opts = {
					sourceImage: _tmpFile,
					targetDir: _tmpDir,
					targetFile: 'pick'
				};
				// detectFace(_tmpFile);
				
				var cb = function(data) {
					data.sourceImage = _opts.sourceImage;
					if (_DEBUG) { console.log('camera return succes!!' , ax.util.dump(data)); }

					app.pageFind.targetImageData = data;
					xx.page.pageSelectFace.show(function() {
						xx.page.pageFacebookGallery.hide();
					});
				};
				
				var eb = function(e) {
					app.common.isLoading = false;
					if (_DEBUG) { console.log('camera return error!!' , e.message); }

                    if (e.code && e.code === '408') {
                        app.common.alert(function(){ app.common.isLoading = false; }, app.nls.get('error_whois_message'));
                        return;
                    }

					app.pageFind.targetImageData = {sourceImage: _tmpFile};
					xx.page.pageSelectFace.show(function() {
						xx.page.pageFacebookGallery.hide();
					});
				};
				
				if (xx.page.platform === 'android') {
					g.puddingface.findFace(cb, eb, _opts);
				} else {
					app.findFace.findFace(cb, eb, _opts);
				}

			};
			
			var errback = function(e){
				app.common.alert(function(){ app.common.isLoading = false; }, app.nls.get('error_whois_message'));
				if (_DEBUG) { console.log('donwload facebook source image err:', e.message, e.code); }
			};
			 
			if (_DEBUG) { console.log(url, _tmpFile); }
			
			//ax.ext.net.download(url, _tmpFile, callback, errback);

            ax.ext.net.curl({
                'method':'GET',
                'url':url,
                'headers':{},
                'params':{},
                'files':{},
                'download': _tmpFile,
                'success': callback,
                'error': errback,
                'timeout': app.def.TIMEOUT_API_DEFAULT
            });
		}
	
		e.stopPropagation();
		e.preventDefault();
	}
	
	
	
	function _makeHtml(pics, isPaging){
		
		if (_DEBUG) { console.log('_makeHtml', pics, isPaging); }
		
		var chk,
			target = document.getElementById('wrapperFacebookGallery'),
			html = '',
			i=0,
			count=0,	// 화면에 뿌려지는 카운트
			p,
			key = null;
		
		var renderImage = function(p) {
		
			var scb = function(src){
				try{
					//console.log('scb', p.id);
					//$('#fbimg' + p.id).css({'background':'url('+ src + ') no-repeat'});
					target.querySelector('#fbimg' + p.id).style.background = 'url('+ src + ') no-repeat';
				}catch(e){
					console.log('renderImage err', e.message, p.id);
//					setTimeout(function(){
//						scb(src);
//					},500);
				}
			};
			
			var ecb = function(e){
				console.log(p.id , 'err', e.message);
			};
			
			//console.log('XXXXXXX renderImage', ax.util.dump(p));
			download.push([p.picture, 'downloads/fb', p.id + '.jpg', scb, ecb]);
		};
		
		for(key in pics) {
		
			if (pics.hasOwnProperty(key)) {
				p = pics[key];
	
				if (isPaging) {
					// console.log(_lastShownID, p.id);
					if (_lastShownID && _lastShownID <= p.id) {
						continue;
					}
				}
				
				chk = i%4;
				if(chk === 0) {
					html+='<li>';
				}
				
				if(xx.download.db[p.id+'.jpg']) {
					html+= '<div title="' + p.id + '" style="background: url(' + xx.download.db[p.id+'.jpg'].path + ') no-repeat;">&nbsp;</div>';
				} else {
					html+= '<div id="fbimg' + p.id + '" title="' + p.id + '">&nbsp;</div>';
					renderImage(p);
				}
				
				if(chk === 4) {
					html+='</li>';
				}
				i++;
				count++;
				
				if (isPaging) { _lastShownID = p.id; }
				
				
				if (isPaging) {
					if (count >= PAGING_COUNT) {
						break; 
					}
				} else {
					if (_lastShownID >= p.id) {
						break;	
					}
				}
				
			}
		
		}
		
		
		if (count < PAGING_COUNT) {
			$('#wrapperFacebookGallery .pullUp').addClass('hide');
			if (typeof xx.scroll.wrapperFacebookGallery !== 'undefined') {
				xx.scroll.wrapperFacebookGallery.args.useUpdateUp = false;
			}
		}
		
		return html;
	}
	
	function refreshGallery(){
		
		console.log('REFRESH!!');
		
		facebook.photos(function(data){
			
			data = _sortFeed(data);
			
			var newImages = {},
				html = '', //$('#wrapperFacebookGallery ul').html(),
				newCount = 0,
				key,
				removeChk = 0,
				removeTarget = [];
			
			for (key in data) {
				if (data.hasOwnProperty(key)) {
					removeChk ++;
					if (!_photos[key]) {
						newImages[key] = data[key];
						newCount++;
					}
					
					if (removeChk > _cacheFileCount) {
						removeTarget.push(data[key].id + '.jpg');
					}
				}
			}
			
			xx.download.removeFiles(removeTarget, function() {
				if (_DEBUG){ console.log('facebook image cache deleted ', removeTarget); } 
			});
			
			if (newCount === 0) {
				xx.scroll.wrapperFacebookGallery.refresh();
				if (_DEBUG) { console.log('no new images'); }
				return;
			}
			
			if (_DEBUG) { console.log('refresh photos', newImages); }
			
			for (key in _photos) {
				if (_photos.hasOwnProperty(key)) {
					newImages[key] = _photos[key];
				}
			}
			_photos = newImages;
			
			html = _makeHtml(_photos); // + html; 
			
			if(download.length >0){ 
				//ax.ext.ui.showProgress(app.nls.get('facebook_gallery_caching'));
				app.common.isLoading = true;
				xx.download.addFiles(download, function(){
					//alert('all done!!!');
					//ax.ext.ui.hideProgress();
					app.common.isLoading = false;
					download = [];
				});
			}
			
			$('#wrapperFacebookGallery ul').html(html);
			xx.scroll.wrapperFacebookGallery.refresh();
			
			xx.fexplorer.writeFile(_cacheFacebook, JSON.stringify(_photos));
			
		}, function(e) {
			xx.scroll.wrapperFacebookGallery.refresh();
			if (_DEBUG) { console.log('facebook.photos err:', e.message); }
		});
		
	}
	
	function nextPage() {
		var html = _makeHtml(_photos, true);
		if (html) {
			//$('#wrapperFacebookGallery ul').html($('#wrapperFacebookGallery ul').html() + html);
            $('#wrapperFacebookGallery ul').append(html);
		}
		
		if(download.length >0){ 
			//ax.ext.ui.showProgress(app.nls.get('facebook_gallery_caching'));
			app.common.isLoading = true;
			xx.download.addFiles(download, function(){
				//alert('all done!!!');
				//ax.ext.ui.hideProgress();
				app.common.isLoading = false;
				
				xx.scroll.wrapperFacebookGallery.refresh();
				download = [];
			});
		} else {
			xx.scroll.wrapperFacebookGallery.refresh();	
		}
		
		
		
	}

	function initPage() {
	
		var html = _makeHtml(_photos, true);
		
		$('#wrapperFacebookGallery ul').html(html);
		//$('#wrapperFacebookGallery').height(xx.page.wrapperHeight - xx.page.admobHeight);
		if(download.length >0){ 
			//ax.ext.ui.showProgress(app.nls.get('facebook_gallery_caching'));
			app.common.isLoading = true;
			xx.download.addFiles(download, function(){
				//alert('all done!!!');
				//ax.ext.ui.hideProgress();
				app.common.isLoading = false;
				download = [];
			});
		}
		
		if (typeof xx.scroll.wrapperFacebookGallery !== 'undefined') {
			xx.scroll.wrapperFacebookGallery.refresh();
			return;
		} 
		

		var scrollOption = {
				wrapperId:'wrapperFacebookGallery', 
				wrapperHeight: g.innerHeight - 42,
				onTouchEnd: _onTouchEnd,
				pullDownAction: refreshGallery,
				pullUpAction: nextPage,
				pullDownMsg: app.nls.get('iscroll_pull_down_label'),
				pullUpMsg: app.nls.get('iscroll_pull_up_label'),
				pullDownUpLoading: app.nls.get('common_loading'),
				y: 85
				//useLazyImageLoading: true
			};
		
		
		xx.scroll.addScroll(scrollOption);
	
		setTimeout(function() {
			$('#'+scrollOption.wrapperId).animate({opacity:1}, 1000);
		},500);
		var thumbsize = parseInt(window.innerWidth * 0.23, 10);
		$('.fbg div').css({'height': thumbsize + 'px', 'width': thumbsize + 'px'});
	}

	function _getPhotos() {
		facebook.photos(function(data){
			_photos = _sortFeed(data);
			xx.fexplorer.writeFile(_cacheFacebook, JSON.stringify(_photos));
			if (_DEBUG) { console.log('photos from facebook graph api', _photos); }
			initPage();
		}, function(e) {
			if (_DEBUG) { console.log('facebook.photos err:', e.message); }
		});
	}
	
	xx.fexplorer.readFile(_cacheFacebook, false, function(cache){
		_photos = JSON.parse(cache);
		if (_DEBUG) { console.log('photos from cache', _photos); }
		initPage();
	}, function(e){
		if (_DEBUG) { console.log('no facebook cache'); }
	});
	
	function checkStatus() {
		setTimeout(function(){
			if (typeof xx.scroll.wrapperFacebookGallery === 'undefined' || $('#wrapperFacebookGallery ul').html() === '') {
				_getPhotos();
			} else {
				xx.scroll.wrapperFacebookGallery.refresh();
			}
		}, 500);
		
		//$('wrapperFacebookGallery').css({'-webkit-transform': 'translate3d(0px, -81px, 0px)'});
	}
	
	function resetStatus() {
		_photos = [];
		_lastShownID = 0;
		$('#wrapperFacebookGallery ul').html('');
		$('#wrapperFacebookGallery .pullUp').removeClass('hide');
		xx.scroll.wrapperFacebookGallery.args.useUpdateUp = true;
	}
	
	ax.def(oPage)
		.property('photos', function(){ return _photos; })
		.method('checkStatus', checkStatus)
		.method('nextPage', nextPage)
		.method('initPage', initPage)
		.method('resetStatus', resetStatus);

	ax.def(g.app).constant(pageID, oPage);

	//app.nls.update('#' + pageID);
// }catch(e){
	// console.log('page_facebook.js def err ', e.message); 
// }
}(window));


