/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{

	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageFind',
		oPage = {},
		_DEBUG = !!g._DEBUG;
		
	var _tmpFile = (xx.page.platform === 'android') ? 'removable/pud/pudface3.jpg' : 'wgt-private-tmp/pudface3.jpg',
		_tmpDir = (xx.page.platform === 'android') ? 'removable/pud' : 'wgt-private-tmp';
	
	var _targetImageData;

    var _challengeStar,
        findMode = 'find';
	
	if (xx.page.platform === 'android') { xx.fexplorer.createDirectory(_tmpDir); }
	
	/*
	 * TODO: 얼굴인식 엔진이 내장된 플러그인에서는 썸네일 이미지와 얼굴인식파일(*pgm) 파일을 떨구어 준다.
	 * 플러그인 개발 전까지는 얼굴인식 2.0 API (upload, detect, whois까지포함) 을 사용하며 이는 app.dev 객체에 정의되어 있다.
	 * 플러그인 개발 후에는 아래 detectFace  펑션 전체를 수정해야함.
	 */
	/*
	function detectFace(filePath) {
		xx.fexplorer.createDirectory(_targetDir);
		
		var opts = {
			sourceImage: filePath,
			targetDir: _targetDir,
			targetFile: _targetFile
		};
		
		var successCallback = function(o) {
			console.log('app.dev.findFace success');
			saveMyHistory(o);
		};
		
		var errorCallback = function(e) {
			app.common.isLoading = 0;
			console.log('findFace err', e);
		};
		
		app.dev.findFace(successCallback, errorCallback, opts);
	}
	*/
	
	function pickImage(){
		if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>> STEP0 PICK IMAGE <<<<<<<<<<<<<<<<<<<<'); }
		app.common.inappBackground = 2;
		var scb = function(file){
			$('#global_loading .box').html(app.nls.get('common_detect_ing'));
			
			var _opts = {
				sourceImage: _tmpFile,
				targetDir: _tmpDir,
				targetFile: 'pick'
			};
			
			var callback = function(data) {
				if (_DEBUG) { console.log('findFace success', ax.util.dump(data)); }
				data.sourceImage = _opts.sourceImage;
				
				if (xx.page.platform !== 'android') {
					app.common.inappBackground = 0;
				}
				
				_targetImageData = data;
				xx.page.pageSelectFace.show(function(){
					$('#global_loading .box').html(app.nls.get('common_loading'));
				});
			};
			
			var errback = function(e) {
				if (_DEBUG) { console.log('findFace error!!' , e.message); }
				
				if (xx.page.platform !== 'android') {
					app.common.inappBackground = 0;

                    if (e.code && e.code === '408') {
                        app.common.alert(function(){ app.common.isLoading = false; }, app.nls.get('error_whois_message'));
                        return;
                    }
				}
				
				_targetImageData = {sourceImage: _tmpFile};
				xx.page.pageSelectFace.show(function(){
					$('#global_loading .box').html(app.nls.get('common_loading'));
				});
			};
			
			if (xx.page.platform === 'android') {
				if (_DEBUG) { console.log('pickImage success', ax.util.dump(_opts)); }
				g.puddingface.findFace(callback, errback, _opts);
			} else {
				app.findFace.findFace(callback, errback, _opts);
			}
		};
		var ecb = function(e){
			app.common.isLoading = false;
			if (_DEBUG) { console.log('pickImage err', e.message); }
		};
		
		var opts = {'crop':true, 'out': _tmpFile};
		
		if (xx.page.platform === 'android') {
			xx.fexplorer.deleteFile(_tmpFile, function() {
				ax.ext.media.pickImage(scb, ecb, opts);
			}, function(e){
				ax.ext.media.pickImage(scb, ecb, opts);
			});
		} else {
			ax.ext.media.pickImage(scb, ecb, opts);
		}
		
	}

	function captureImage(){
		if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>> STEP0 CAPTURE IMAGE <<<<<<<<<<<<<<<<<<<<'); }
		app.common.inappBackground = 1;
		
		var autosave = app.common.getPreference('autosave');
		
		autosave = autosave === 'true';

		var _opts = {
			type: 0,  // 0: 닮은꼴 연예인찾기 - 1장 촬영 또는 겔러리 선택, 1: 닯은꼴 배틀 - 2장~4장 촬영 또는 겔러리 선택
			targetDir: _tmpDir,
			targetFile: 'find',
			autoSave: autosave
		};
		
		var callback = function(data) {
			try{
				//wwww();
				//if (typeof data === "string") { data = JSON.parse(data); }
				if (_DEBUG){ console.log('camera return succes!!' , ax.util.dump(data), data); }
				
				if (xx.page.platform !== 'android') {
					app.common.inappBackground = 0;
				}

				xx.page.pageFinding.show(function(){
                    if (app.pageFind.findMode === 'find') {
                        //app.pageFinding.whois(_rectData, idx);
                        app.pageFinding.whois(data, 0);
                    } else {
                        app.pageFinding.challenge(data, 0);
                    }
				});
				// app.common.isLoading = true;
			}catch(e){
				//alert(e.message);
			}
		};
		
		var errback = function(e) {
			app.common.isLoading = false;
			
			if (xx.page.platform !== 'android') {
				app.common.inappBackground = 0;
			}
			
			console.log('camera return error!!' , e.message);
		};

		g.puddingface.captureImage(callback, errback, _opts);
		
		// xx.page.pageDevGallery.show(function(){
			// app.pageDevGallery.captureImage(callback, errback, _opts);
			// app.common.isLoading = false;
		// });
		
	}
	
	function initPage() {
		//app.nls.update('#pageFind');
		//$('#find_engine_help').attr('src', 'locales/' + app.nls.langApp + '/image/find_bg_layer.png');
		
//		if (app.common.getPreference('isCloseEngineInfo') !== 'true') {
//			$('#pageFind .layer_find').removeClass('hide');
//		}
		
		if (typeof xx.scroll.wrapperFind === 'undefined') {
			xx.scroll.addScroll({wrapperId:'wrapperFind'});
		}
	}
	

    function _setChallengeStar(star) {
		//_historyID = new Date().getTime();

		_challengeStar = star;

		$('#challengeStarArea').css({background: 'url("'+ star.fileUrl +'")'});

		//$('#pageBattleSearch .select').removeClass('artist-off').addClass('artist-on');

		//$('#pageBattleSearch .filming .btn-user').removeClass('off');
		//$('#pageBattleSearch .filming .user-list').removeClass('off');

		//img.src = star.fileUrl;
		//_checkReady();

	}

	//function closeInfo() {
		//app.common.setPreference('isCloseEngineInfo', 'true');
		//$('#pageFind .layer_find').addClass('hide');
	//}
	
	ax.def(oPage)
		//.method('detectFace', detectFace)
		.property('targetImageData', function() { return _targetImageData;}, function(o) { _targetImageData = o; })
        .property('challengeStar', function() { return _challengeStar; }, _setChallengeStar)
        .property('findMode', function() { return findMode;}, function(mode) { findMode = mode; })
		.method('pickImage', pickImage)
		.method('captureImage', captureImage)
		//.method('closeInfo', closeInfo)
		.method('initPage', initPage);

	ax.def(app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!!
// }catch(e){
	// console.log('page_find.js def err ', e.message); 
// }
}(window));