/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageFinding',
		oPage = {},
		_DEBUG = !!g._DEBUG;

	var _result,    // 닮은꼴 연예인 찾기
        _result_challenge;  // 닮은꼴 연예인 도전모드

	function challenge(info, idx){
        //	function battle(star, player, scb, ecb, mode) {

        var star = app.pageFind.challengeStar;
		if(_DEBUG) { console.log('CHALLENGE!!!', ax.util.dump(star), ax.util.dump(info)); }

		var pgmFile = info.pgm[idx],
            player = {};

        xx.fexplorer.readFile(pgmFile, true, function(txt){

            player.features = [txt];

            var callback = function(result) {
                if(_DEBUG) { console.log('API_BATTLE_REQUEST(CHALLENGE) SUCCESS', JSON.stringify(result)); }

                result.sourceImage = info.image[idx];
                result.historyID = new Date().getTime();
                _result_challenge = result;

                xx.page.pageChallengeResult.show(function(){
                    setTimeout(function(){
                        xx.page.pageFinding.hide();
                    }, 300);
                });
                //alert('CHALLENGE SUCCESS! ' + ax.util.dump(result));
            };

            var errback = function(e) {
                app.common.alert(function(){ xx.page.back(); app.common.isLoading = false; }, app.nls.get('error_whois_message'));
				if (_DEBUG) { console.log('API_BATTLE_REQUEST(CHALLENGE) ERROR', e.message); }
            };

            app.api.battle(star, player, callback, errback, 'challenge');
        });
	}

	function whois(info, idx){

		//info = info || ax.util.decodeJSON('{"image":["wgt-private-tmp/pick1.jpg","wgt-private-tmp/pick2.jpg"],"pgm":["wgt-private-tmp/capture1.pgm","wgt-private-tmp/pick2.pgm"],"rect":["304|245|111|111","60|276|135|135"],"sourceImage":"removable/pudface3.jpg"}');

		var pgmFile = info.pgm[idx];
		if (_DEBUG) { console.log('pageFinding.whois', info, idx, pgmFile); }

		xx.fexplorer.readFile(pgmFile, true, function(txt){

			var url = app.def.API_WHOIS + app.common.getPreference('starCategory') + '&';
			var params = {
				imageId: txt,
				faceId: 0,
				deviceToken: app.common.getPreference('kpnsToken')
			};

			url+= $.param(params);

			app.api.whois(url, function(o){
					if (_DEBUG) { console.log('API_WHOIS SUCCESS', o); }
					o.sourceImage = info.image[idx];

					_result = o;
					xx.page.pageFound.show(function(){
						setTimeout(function(){
							xx.page.pageFinding.hide();
						}, 300);
					});
				}, function(e){
					app.common.alert(function(){ xx.page.back(); app.common.isLoading = false; }, app.nls.get('error_whois_message'));
					if (_DEBUG) { console.log('API_WHOIS ERROR', e.message); }
				});

		}, function(e){
			if (_DEBUG) { console.log('pgmFile read err', e.message, pgmFile); }
		});
	}

	ax.def(oPage)
		.property('result', function(){ return _result; })
        .property('result_challenge', function() { return _result_challenge; })
		.method('challenge', challenge)
        .method('whois', whois);

	ax.def(g.app).constant(pageID, oPage);
	
// }catch(e){
	// console.log('page_finding.js def err ', e.message); 
// }
}(window));