/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		nls = app.nls,
		pageID = 'pageFound',
		oPage = {},
		_DEBUG = !!g._DEBUG;
	
	var _result;
	

	var _historyDir = 'documents/myhistory/';

	var _isResultFromHistory;
	
	xx.fexplorer.createDirectory(_historyDir);
	
	function _renderBasic() {
		try{
			var ageText = (_result.age === -1 || _result.age === '-1') ? '??' : _result.age;
			if (app.nls.lang !== 'en') {
				ageText = ageText + nls.get('found_age');
			} else {
				ageText = nls.get('found_age') + ' ' + ageText + ',';
			}
			
			$('#faceFound_user .ageText').html(ageText);

			if (_result.sex === 'M') {
				$('#faceFound_user .maleText').removeClass('hide');
			} else if (_result.sex === 'F')  {
				$('#faceFound_user .femaleText').removeClass('hide');
			} else {
				if (_DEBUG) { console.log('성별파악이 안되네.'); }
				$('#faceFound_user .nosexText').removeClass('hide');
			}
			
			if (_result.rate !=="") {
				$('#faceFound_user .male .graph').css('width',_result.rate.M + '%');
				$('#faceFound_user .female .graph').css('width',_result.rate.F + '%');
				$('#faceFound_user .male .rateText').html(_result.rate.M);
				$('#faceFound_user .female .rateText').html(_result.rate.F);
			} else {
				$('#faceFound_user .graph').each(function() {
					$(this).css('width','0%');
				});
				
				$('#faceFound_user .rateText').each(function() {
					$(this).html('0');
				});
			}
			
			if (_isResultFromHistory) {
				$('#faceFound_user .face').attr('src', '/appspresso/file/' + _historyDir + _result.tmppostid + '/face.jpg?' + (new Date().getTime()));
			} else {
				$('#faceFound_user .face').attr('src', '/appspresso/file/' + _result.sourceImage + '?' + (new Date().getTime()));
			}
			
		}catch(e){
			if (_DEBUG) { console.log('_renderBasic err', e.message); }	
		}
	}
	
	function _renderFirst() {
		var star = _result.sameinfo[0];
		if (_DEBUG) { console.log('_renderFirst', ax.util.dump(star)); }
		
		$('#wrapperFound .grade1 .thumb .face').attr('src', star.starurl);
		
		$('#wrapperFound .grade1 .txt strong').html(star.rate + '%');
		$('#wrapperFound .grade1 .txt em').html(star.name.replace(',', ',<br>'));
		$('#wrapperFound .grade1 .txt em').attr('queryName', star.queryName || star.name);
		
		var ageText = star.age;
		if (app.nls.lang !== 'en') {
			ageText = ageText + nls.get('found_age_txt');
		} else {
			ageText = nls.get('found_age_txt') + ageText + ', ';
		}
		
		$('#wrapperFound .grade1 .txt span').html(ageText + nls.get('found_sex_txt_' + star.sex));
		$('#wrapperFound .grade1 .txt p').html(star.descript);
	}
	
	
//	function _updateKM(prefix) {
//        g._kmq.push(['record', 'celeb_result' + prefix, {
//				'OS':xx.page.platform,
//				'OS Version': xx.page.os,
//				'App Version': app.def.APP_VERSION,
//				'Language': app.nls.lang,
//				'Model': xx.page.model,
//				'Gender and Age': _result.sex + ' ' + _result.age
//				}]);
//	}
	
	function _renderOthers() {
		var i = 1,
			len = _result.sameinfo.length,
			star,
			pageCount = 5;
		
		var ageText = '';
		
			
		for (i; i<len; i++) {
			star = _result.sameinfo[i];
			
			$('#wrapperFound .grade' + (i+1) + ' .thumb2 .face').attr('src', star.starurl);
			
			$('#wrapperFound .grade' + (i+1) + ' .txt2 strong').html(star.rate + '%');
			$('#wrapperFound .grade' + (i+1) + ' .txt2 em').html(star.name);
			$('#wrapperFound .grade' + (i+1) + ' .txt2 em').attr('queryName', star.queryName || star.name);
			
			ageText = star.age;
			if (app.nls.lang !== 'en') {
				ageText = ageText + nls.get('found_age_txt');
			} else {
				ageText = nls.get('found_age_txt') + ageText + ', ';
			}
			
			$('#wrapperFound .grade' + (i+1) + ' .txt2 span').html(ageText + nls.get('found_sex_txt_' + star.sex));
		}
		
		for (i; i<5; i++) {
			$('#wrapperFound .grade' + (i+1)).addClass('hide');
		}
		
		
		
		$($('#wrapperFound li')[3]).addClass('hide');	// 미생명체
		pageCount--;
		
		if (len <= 3) {
			$($('#wrapperFound li')[2]).addClass('hide');	// 2~3위
			pageCount--;
		}
		if (len <=1) {
			$($('#wrapperFound li')[1]).addClass('hide');	// 4~5위
			pageCount--;
		}
		
		
		setTimeout(function() {
			$('#wrapperFound .scroller').css({width: (g.innerWidth * pageCount) + 'px'});
			xx.scroll.wrapperFound.refresh();
			$('#btnFoundNext').removeClass('off');
		}, 500);
		
		
	}
	
	function _cleanMyHistory(count) {
		xx.fexplorer.dir(_historyDir, function(history){	
			
			console.log(ax.util.dump(history));
			var i = 0,
				len = history.length - (count || 20);
			
//			if (xx.page.platform === 'android') { 
//				i = count || 20;
//				len = history.length;
//			}
			
			history.sort();
			
			var delete_history = function(idx) {
				xx.fexplorer.deleteFile(_historyDir + history[idx], function(){
					if (_DEBUG) { console.log('_cleanMyHistory success ', _historyDir + history[idx], ' deleted!'); }
				}, function(e) {
					if (_DEBUG) { console.log('_cleanMyHistory err', _historyDir + history[idx], e.message); }
				});
			};
			
			for (i; i<len; i++) {
				delete_history(i);
			}
			
		}, function(e){
			if (_DEBUG) { console.log('cleanMyHistory err', e.message); }
		});
	}
	
	function _saveMyHistory(result) {
		console.debug('saveMyHistory',result);
		var file = _historyDir + result.tmppostid + '/match.json',
			folder = _historyDir + result.tmppostid;
	
		
		xx.fexplorer.createDirectory(folder, function(){
			
			xx.fexplorer.writeFile(file, JSON.stringify(result), false, function(){
				_cleanMyHistory();
			}, function(e) {
				if (_DEBUG) { console.log('saveMyHistory writeFile err', e.message); }
			});
			
			if (_DEBUG) { console.log('플레이어 사진복사', result.sourceImage + ' to ' + folder + '/face.jpg'); }
			xx.fexplorer.copy(result.sourceImage, folder + '/face.jpg', function(){
				
			}, function(e) {
				if (_DEBUG) { console.log('saveMyHistory copy image err', e.message); }
			});
		});
		
		app.common.isLoading = false;
		
		if (app.pageMy) { 
			app.pageMy.needTab1Refresh = true;
		}
	}
	
	function _renderAD() {
		//if (_DEBUG){ if(!_result.biz) { _result.biz = {}; _result.biz.bizImg = 'image/result_bnr.png'; _result.biz.bizUrl = 'http://m.naver.com'; } }
		if (_DEBUG) { console.log('BIZ INFO:', ax.util.dump(_result.biz)); }
		if (_result.biz && _result.biz.bizImg) {
            //if (app.common.useKM) { g._kmq.push(['record', 'ad_' + app.pageFound.result.biz.bizName]); }
			$('#whois_banner').removeClass('hide');
			$('#whois_banner img')
				.attr('src', _result.biz.bizImg)
				.unbind('touchstart')
				.bind('touchstart', function() {
					xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('main_ad_headline');
					xx.page.pageEmpty.show();
					app.common.addWebView(_result.biz.bizUrl);
                    //if (app.common.useKM) { g._kmq.push(['record', 'ad_' + app.pageFound.result.biz.bizName + '_click_o']); }
					$('#whois_banner').addClass('hide');
					app.common.trackEvent('얼굴인식결과', '타겟광고클릭', _result.biz.bizName);
				});
			app.common.trackEvent('얼굴인식결과', '타겟광고노출', _result.biz.bizName);
		}
	}
	
	function checkResult() {
		if (_DEBUG) { console.log('pageFound checkResult'); }
		//try{
		
		if (xx.page.prePage === 'pageMy') {
			_result = app.pageMy.historyMyResult;
			_isResultFromHistory = true;
			
			$('#btn_found_back').attr('title', 'btnBack');
			$('#btn_found_back img').attr('src', 'image/icon_back.png');
			
//			_updateKM('_my');
		} else {
			_result = app.pageFinding.result;
			_saveMyHistory(_result);
			_isResultFromHistory = false;

			$('#btn_found_back').attr('title', 'btnBack');
			$('#btn_found_back img').attr('src', 'image/icon_back.png');
			
			//$('#btn_found_back').attr('title', 'btnHome');
			//$('#btn_found_back img').attr('src', 'image/icon_home.png');
			
			// android 3.0.3 / ios 3.0.2에서 리뷰유도얼럿 제거
//			setTimeout(function() {
//				app.common.reviewCountCheck('celeb');
//			}, 3000);
			
//			_updateKM('');
		}
		
		//}catch(e){
		//	_result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"}]}');
		// 5 _result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"},{"rank":2,"name":"\uc11c\ud604","sex":"F","rate":54,"age":21,"faceid":"13658","attrid":"271","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/271/271_20090821170306.jpg","descript":null},{"rank":3,"name":"\ub0a8\uaddc\ub9ac","sex":"F","rate":54,"age":27,"faceid":"7147","attrid":"172","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/172/172_1048.jpg","descript":null},{"rank":4,"name":"\uc6a9\uc900\ud615","sex":"M","rate":54,"age":23,"faceid":"3094","attrid":"1448","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1448/1448_20100219163235.jpg","descript":null},{"rank":5,"name":"\uae40\uc0ac\ub791","sex":"F","rate":53,"age":34,"faceid":"13702","attrid":"274","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/274/274_20100628164404.jpg","descript":null}]}');
		// 4 _result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"},{"rank":2,"name":"\uc11c\ud604","sex":"F","rate":54,"age":21,"faceid":"13658","attrid":"271","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/271/271_20090821170306.jpg","descript":null},{"rank":3,"name":"\ub0a8\uaddc\ub9ac","sex":"F","rate":54,"age":27,"faceid":"7147","attrid":"172","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/172/172_1048.jpg","descript":null},{"rank":4,"name":"\uc6a9\uc900\ud615","sex":"M","rate":54,"age":23,"faceid":"3094","attrid":"1448","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1448/1448_20100219163235.jpg","descript":null}]}');
		// 3 _result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"},{"rank":2,"name":"\uc11c\ud604","sex":"F","rate":54,"age":21,"faceid":"13658","attrid":"271","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/271/271_20090821170306.jpg","descript":null},{"rank":3,"name":"\ub0a8\uaddc\ub9ac","sex":"F","rate":54,"age":27,"faceid":"7147","attrid":"172","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/172/172_1048.jpg","descript":null}]}');
		// 2 _result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"},{"rank":2,"name":"\uc11c\ud604","sex":"F","rate":54,"age":21,"faceid":"13658","attrid":"271","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/271/271_20090821170306.jpg","descript":null}]}');
		// 1 _result = ax.util.decodeJSON('{"tmppostid":"201207061650564533370056608295","age":"13","sex":"M","rate":"","cropimg":null,"sameinfo":[{"rank":1,"name":"\uc544\uc774\uc720","sex":"F","rate":64,"age":19,"faceid":"4249","attrid":"1553","nation":"KR","starurl":"http://211.42.140.173/starimg/newimg/1553/1553_20100804110805.jpg","descript":"\ud639\uc2dc 10\ubbf8\ud130 \uc5f0\uc608\uc778 \uc774\ub77c\uace0 \ub4e4\uc5b4\ubcf4\uc168\ub098\uc694?"}]}');
		//}
		
		
		
		
		_renderBasic();
		_renderFirst();
		_renderOthers();
		
		if (_isResultFromHistory === false) { _renderAD(); }
	}
	
	function _onTouchEnd(e) {
		var target = e.target,
			i=10,
			btnName = target.title;
	
		if (btnName) {
			if (btnName === 'btnRetry') {
				// XXX: 히스토리 ㅠㅠ
				xx.page.pageFind.hide(function(){
					xx.page.pageFind.show(function(){
						xx.page.pageFacebookGallery.hide(function() {
							xx.page.pageSelectFace.hide(function(){
								xx.page.pageFound.hide();
							});	
						});
					});
				});
			} else if (btnName === 'btnGoBattle') {
				xx.page.pageFind.hide(function(){
					xx.page.pageBattleSearchStar.show(function(){
						xx.page.pageFacebookGallery.hide(function() {
							xx.page.pageSelectFace.hide(function(){
								xx.page.pageFound.hide();

                                //if (app.common.useKM) {
                                //    g._kmq.push(['record', '닮은꼴배틀_연예인']);
                                //}
							});	
						});
					});
				});
			}
			return;
		}

        if ($('#btnFoundNext').hasClass('off')) { return; }

		while(i--) {
			if(/grade/i.test(target.className)) {
				
				break;
			}
			target = target.parentNode;
		}

		if (target.querySelector('em')) {
			//var starName = target.querySelector('em').innerHTML;
			var starName = $(target.querySelector('em')).attr('queryName');
			
			xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('found_search_headline');
			xx.page.pageEmpty.show();
			app.common.trackEvent('pageFound', '연예인사진');
			
			if (_result.linkUrl) {
				app.common.addWebView(_result.linkUrl + encodeURIComponent(starName.replace('<br>', '')));
			} else {
				app.common.addWebView('http://www.google.co.kr/search?hl=' + nls.lang + '&source=pudding&lr=lang_ko&pws=0&q=' + encodeURIComponent(starName.replace('<br>', '')));
			}
			
		}
	}

    function checkCarouselButton() {
        setTimeout(function() {
            var x = xx.scroll.wrapperFound.x,
                pagesX = xx.scroll.wrapperFound.pagesX,
                len = pagesX.length-1,
                currPageX = xx.scroll.wrapperFound.currPageX;

            if (_DEBUG) { console.log('checkCarouselButton', x, ax.util.dump(pagesX), x, pagesX[len], pagesX[1]); }

            $('#btnFoundNext').removeClass('off');
            $('#btnFoundPrev').removeClass('off');

            if (x <= pagesX[len]) {
                if (_DEBUG) { console.log('btnFoundNext >> off'); }
                $('#btnFoundNext').addClass('off');
            } else if (x === 0 || x> pagesX[1]) {
                if (_DEBUG) { console.log('btnFoundPrev >> off'); }
                $('#btnFoundPrev').addClass('off');
            }

            $('.wrap-foundpage span.state').removeClass('on').after(function(){
                $($('.wrap-foundpage span.state')[currPageX]).addClass('on');
            });

            if (currPageX === len) {
                app.common.trackPageview('닮은꼴결과_이동');
            } else if (currPageX === 1) {
                app.common.trackPageview('닮은꼴결과_2to3');
            } else if (currPageX === 2) {
                app.common.trackPageview('닮은꼴결과_4to5');
            } else if (currPageX === 0) {
                app.common.trackPageview('닮은꼴결과_1');
            }

        }, 10);
    }

    function initPage() {
		//nls.update('#pageFound');

		$('#wrapperFound .scroller').css({width: (g.innerWidth * 5) + 'px'});//xx.page.screenWidth로 했을 시에 width가 화면 밖으로 넘치는 현상이 있어서 수정. - 영일
		$('#wrapperFound .scroller li').each(function(){
			$(this).css({width: g.innerWidth + 'px'});//xx.page.screenWidth로 했을 시에 width가 화면 밖으로 넘치는 현상이 있어서 수정.- 영일
		});
		
		g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = g.innerWidth;//xx.page.screenWidth;
		
		var scrollOption = {
			'wrapperId': 'wrapperFound',
			hScrollbar: false,
			snap: true,
			momentum: false,
			bounce: true,
			onTouchEnd: _onTouchEnd,
			onScrollEnd: function() {
				checkCarouselButton();
			}
		};
		xx.scroll.addScroll(scrollOption);
		
	}
	
	function resetStatus() {
		
		$('#faceFound_user .maleText').addClass('hide');
		$('#faceFound_user .femaleText').addClass('hide');
		$('#faceFound_user .nosexText').addClass('hide');
		$('#whois_banner').addClass('hide');
		
		$($('#wrapperFound li')[2]).removeClass('hide');
		$($('#wrapperFound li')[1]).removeClass('hide');
		
		$('#wrapperFound').removeClass('capture');
		
		var i=0;
		for (i; i<5; i++) {
			$('#wrapperFound .grade' + (i+1)).removeClass('hide');
		}
		xx.scroll.wrapperFound.scrollTo(0);
		
		setTimeout(function(){
			xx.scroll.wrapperFound.currPageX = 0;
			$('.wrap-foundpage span.state').removeClass('on').after(function(){
				$($('.wrap-foundpage span.state')[0]).addClass('on');
			});
			
			$('#btnFoundPrev').addClass('off');
			$('#btnFoundNext').addClass('off');
		}, 50);
		
		
		//$('#' + pageID + ' .sns_wrapper').addClass('hide');
	}

	var w = g.innerWidth,
		userW = parseInt(w * 0.25, 10),
		celeb1 = parseInt(w * 0.35, 10);
	$('#faceFound_user .face').css({'height': userW + 'px', 'width': userW + 'px'});
	$('#faceFound_star_scroller .grade1 .face').css({'height': celeb1 + 'px', 'width': celeb1 + 'px', 'margin-top': -(celeb1/2) + 'px'});
	$('#faceFound_star_scroller .noface .thumb img').css({'height': celeb1 + 'px', 'width': celeb1 + 'px', 'margin-top': -(celeb1/2) + 'px'});
	$('#faceFound_star_scroller .thumb2 .face').css({'height': userW + 'px', 'width': userW + 'px'});
	
	ax.def(oPage)
		.property('result', function(){ return _result; })
		.method('checkResult', checkResult)
		.method('initPage', initPage)
		.method('resetStatus', resetStatus)
		.method('checkCarouselButton', checkCarouselButton);

	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!!
	
// }catch(e){
	// console.log('page_found.js def err ', e.message); 
// }
}(window));
