/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageMy',
		oPage = {},
		_DEBUG = !!g._DEBUG;

	var _historyDir = 'documents/myhistory',
		_history = [],
		_battleDir = 'documents/mybattle',
		_battle = [],
        _challengeDir = 'documents/mychallenge',
		_challenge = [];

	var _selectedTab = 1,
		_tab1El = $('.tabHeader .tab1'),
		_tab2El = $('.tabHeader .tab2'),
        _tab3El = $('.tabHeader .tab3'),
		_wrapper1El = $('#wrapperMyTab1'),
		_wrapper2El = $('#wrapperMyTab2'),
        _wrapper3El = $('#wrapperMyTab3'),
		_pageMyBodyEl = $('#pageMy .body');
		
	var _needTab1Refresh = true,
		_needTab2Refresh = true,
        _needTab3Refresh = true;

	var _historyMyResult,
		_historyBattleResult,
        _historyChallengeResult;
	
	xx.fexplorer.createDirectory(_historyDir);
	xx.fexplorer.createDirectory(_battleDir);
    xx.fexplorer.createDirectory(_challengeDir);

	var wrapperHeight = g.innerHeight - 142;
	if (xx.page.platform !== 'android') {
		wrapperHeight = 318;
	}

	_wrapper1El.css({height: wrapperHeight});
	_wrapper2El.css({height: wrapperHeight});
    _wrapper3El.css({height: wrapperHeight});

	function _goMyItem(historyId) {
		var callback = function(result) {
			_historyMyResult = ax.util.decodeJSON(result);
			xx.page.pageFound.show();
		};

		var errback = function(result) {

		};
		xx.fexplorer.readFile(_historyDir + '/' + historyId + '/match.json', false, callback, errback);
	}

    function _goChallengeItem(historyId) {
		var callback = function(result) {
			_historyChallengeResult = ax.util.decodeJSON(result);
			xx.page.pageChallengeResult.show();
		};

		var errback = function(e) {
            if (_DEBUG) { console.log('_goChallengeItem file read err:', e.message); }
		};
		xx.fexplorer.readFile(_challengeDir + '/' + historyId + '/challenge.json', false, callback, errback);
	}

	function _goBattleItem(battleId) {
		try{
		var callback = function(result) {
			console.log(result);
			_historyBattleResult = ax.util.decodeJSON(result);

			xx.page.pageBattleResult.show();
		};

		var errback = function(e) {
			if (_DEBUG) { console.log('_goBattleItem err', e.message + _battleDir + '/' + battleId + '/battle.json'); }
		};
		xx.fexplorer.readFile(_battleDir + '/' + battleId + '/battle.json', false, callback, errback);
		}catch(e){
			if (_DEBUG) { console.log('_goBattleItem err ' + e.message); }
		}
	}

	function _getChallengeHTML(data) {

        console.debug(ax.util.dump(data));
		var html = '',
			item,
			star,
			i,
			len = data.length;

		if (_DEBUG) { console.log('_getChallengeHTML data', data); }

		try{
			for (i=0; i<len; i++) {
				item = data[i];
				star = item;


				html += '<li data-item="' + item.historyID + '">';
				html += '<div class="item">';
				html += '<img class="i1" src="' + star.fileUrl + '" /><img class="i2" src="/appspresso/file/' + _challengeDir + '/' + item.dir + '/face.jpg" />';
				html += '<div class="info">';
				html += '<strong>' + star.face[0].similarity + '%</strong>';
				html += '<h3>' + star.name +'</h3>';
				html += '<span>' + app.nls.get('my_challenge_txt') + '</span>';
				html += '</div>';
				html += '<button class="del"><img src="../image/my_btn_del.png" alt="삭제" /><span></span></button>';
				html += '</div>';
				html += '</li>';
			}
		} catch(e) {
			console.log(e.message);
		}

		$('#wrapperMyTab3 .scroller').html(html);
		if (len > 0) {
            showScroll(_wrapper3El);
			_wrapper3El.removeClass('no');
		} else {
			_wrapper3El.addClass('no');
		}
	}

	function getChallengeHistory() {
		app.common.isLoading = true;
		_challenge = [];

		xx.fexplorer.dir(_challengeDir, function(dir){
			var i,
				len = dir.length,
				fileDir,
				item,
				chkLoad = len;

			dir.sort().reverse();
			_needTab3Refresh = false;

			var readFile = function(idx) {
				fileDir = _challengeDir + '/' + dir[idx];
				xx.fexplorer.readFile(fileDir + '/challenge.json', false, function(match){
					item = JSON.parse(match);

					item.dir = dir[idx];
					_challenge[idx] = item;
					chkLoad--;

					// console.log(item, chkLoad);

					if(chkLoad === 0) {
						_getChallengeHTML(_challenge);
						_needTab3Refresh = false;
					}
				 }, function(e) {
					console.log('read file err' , _challengeDir + '/' + dir[idx]);
					chkLoad--;
					if(chkLoad === 0) {
						_getChallengeHTML(_challenge);
					}
				});
			};

			for (i=0; i<len; i++) {
				readFile(i);
			}

			if (len === 0) {
				app.common.isLoading = false;
			}

		}, function(e) {
			app.common.isLoading = false;
		});
	}

	function _getMyHTML(data) {

		var html = '',
			item,
			star,
			i,
			len = data.length;

		var ageText = '',
			sexTextF = app.nls.get('found_sex_txt_F'),
			sexTextM = app.nls.get('found_sex_txt_M'),
			ageDesc = app.nls.get('found_age'),
			ageLang = app.nls.lang;

		if (_DEBUG) { console.log('_getMyHTML data', data); }

		try{
			for (i=0; i<len; i++) {
				item = data[i];
				star = item.sameinfo[0];

				ageText = item.age;
				if (ageText === '-1' || ageText === -1) {
					ageText = '??';
				}

				if (ageLang !== 'en') {
					ageText = ageText + ageDesc + ' ';
				} else {
					ageText = ageDesc + ' ' + ageText + ', ';
				}
				if (item.sex ==='M') {
					ageText += sexTextM;
				} else if (item.sex === 'F') {
					ageText += sexTextF;
				} else {
					ageText += ' ??';
				}


				html += '<li data-item="' + item.tmppostid + '">';
				html += '<div class="item">';
				html += '<img class="i1" src="' + star.starurl + '" /><img class="i2" src="/appspresso/file/' + _historyDir + '/' + item.dir + '/face.jpg" />';
				html += '<div class="info">';
				html += '<strong>' + star.rate + '%</strong>';
				html += '<h3>' + star.name +'</h3>';
				html += '<span>' + ageText + '</span>';
				html += '</div>';
				html += '<button class="del"><img src="../image/my_btn_del.png" alt="삭제" /><span></span></button>';
				html += '</div>';
				html += '</li>';
			}
		} catch(e) {
			console.log(e.message);
		}

		$('#wrapperMyTab1 .scroller').html(html);
		if (len > 0) {
			showScroll(_wrapper1El);
			_wrapper1El.removeClass('no');
		} else {
			_wrapper1El.addClass('no');
		}
	}

	function getMyHistory() {
		app.common.isLoading = true;
		_history = [];

		xx.fexplorer.dir(_historyDir, function(dir){
			var i,
				len = dir.length,
				fileDir,
				item,
				chkLoad = len;

			dir.sort().reverse();
			_needTab1Refresh = false;

			var readFile = function(idx) {
				fileDir = _historyDir + '/' + dir[idx];
				xx.fexplorer.readFile(fileDir + '/match.json', false, function(match){
					item = JSON.parse(match);

					item.dir = dir[idx];
					_history[idx] = item;
					chkLoad--;

					// console.log(item, chkLoad);

					if(chkLoad === 0) {
						_getMyHTML(_history);
						_needTab1Refresh = false;
					}
				 }, function(e) {
					console.log('read file err' , _historyDir + '/' + dir[idx]);
					chkLoad--;
					if(chkLoad === 0) {
						_getMyHTML(_history);
					}
				});
			};

			for (i=0; i<len; i++) {
				readFile(i);
			}

			if (len === 0) {
				app.common.isLoading = false;
			}

		}, function(e) {
			app.common.isLoading = false;
		});
	}
	

	function refresh(){
		if (xx.scroll['wrapperMyTab' + _selectedTab]) {
			xx.scroll['wrapperMyTab' + _selectedTab].refresh();
		}
	}
	
	function _getBattleHTML(data) {
		
		if (_DEBUG) { console.log('_getBattleHTML',data); }
		
		var html = '',
			item,
			template,
			i,
			len = data.length;
		
		
		try{
		
			for (i=(len-1); i>=0; i--) {
				item = data[i];

				template = $("#templateBattleHistory").clone()[0];
				
				template.querySelector('li').setAttribute('data-item', item.dir);
				template.querySelector('h2').innerHTML = '<strong>' + item.name + '</strong>' + app.nls.get('battle_result_share');
				template.querySelector('.target').src = item.fileUrl;
				
				var j=0, 
					l=item.face.length;
				for (j; j<l; j++) {
					template.querySelector('.gamer .i' + (j+1)).src = '/appspresso/file/' + item.face[j].image;
				}
				
				for (j; j<4; j++) {
					//template.querySelector('.gamer .i' + (j+1)).style.display = 'none';
					template.querySelector('.gamer .i' + (j+1)).src = 'image/battle_default.png';
				}
				
				html += template.innerHTML;
			}
		} catch(e) {
			if (_DEBUG) { console.log('_getBattleHTML err', e.message); }
		}
		
		$('#wrapperMyTab2 .scroller').html(html);
		
		if (len > 0) {
			showScroll(_wrapper2El);
			_wrapper2El.removeClass('no');
		} else {
			_wrapper2El.addClass('no');
		}
		

	}
	
	function getBattleHistory() {
		app.common.isLoading = true;
		
		_battle = [];
		xx.fexplorer.dir(_battleDir, function(dir){
			var i, 
				len = dir.length,
				fileDir,
				item,
				chkLoad = len;
		
			dir.sort();
			_needTab2Refresh = false;
			
			var readFile = function(idx) {
				fileDir = _battleDir + '/' + dir[idx];
				xx.fexplorer.readFile(fileDir + '/battle.json', false, function(battle){
					item = JSON.parse(battle);
					
					item.dir = dir[idx];
					_battle[idx] = item;
					chkLoad--;
					
					//console.log(item, chkLoad);
					
					if(chkLoad === 0) {
						_getBattleHTML(_battle);
						app.common.isLoading = false;
					}
				}, function(e){
					if (_DEBUG) { console.log('read file err' , _battleDir + '/' + dir[idx]); }
					chkLoad--;
					if(chkLoad === 0) {
						_getBattleHTML(_battle);
						_needTab2Refresh = false;
					}
				});
			};
			
			for (i=0; i<len; i++) {
				readFile(i);
			}
			
			if (len === 0) {
				app.common.isLoading = false;
			}
			
		}, function(e) {
			app.common.isLoading = false;
		});
	}

    function showScroll(tab) {

        if (typeof tab === 'undefined') {
            tab = $('#wrapperMyTab' + _selectedTab);
        }

        if (_DEBUG) { console.log('showScroll',_selectedTab, tab.attr('id')); }

        var wrapperId = tab.attr('id');

        if (_selectedTab === 1 && _needTab1Refresh) {
            getMyHistory();
            return;
        } else if (_selectedTab === 2 && _needTab2Refresh) {
            getBattleHistory();
            return;
        } else if (_selectedTab === 3 && _needTab3Refresh) {
            getChallengeHistory();
            return;
        }

        app.common.isLoading = false;

        if ($('#' + wrapperId + ' li').length > 0) {
            xx.scroll[wrapperId].refresh();
        }
    }

    function _deleteMyHistory(id) {
		var dir = _historyDir + '/' + id;

		if (id) {
			xx.fexplorer.deleteFile(dir, function(){
				if (_DEBUG) { console.log(dir , 'deleted success!'); }
			}, function(e){
				if (_DEBUG) { console.log(dir , 'deleted err!', e.message); }
			});
		}
	}

	function _deleteBattleHistory(id) {
		var dir = _battleDir + '/' + id;
		
		if (id) {
			xx.fexplorer.deleteFile(dir, function(){
				if (_DEBUG) { console.log(dir , 'deleted success!'); }
			}, function(e){ 
				if (_DEBUG) { console.log(dir , 'deleted err!', e.message); }
			});
		}
	}

    function _deleteChallengeHistory(id) {
		var dir = _challengeDir + '/' + id;

		if (id) {
			xx.fexplorer.deleteFile(dir, function(){
				if (_DEBUG) { console.log(dir , 'deleted success!'); }
			}, function(e){
				if (_DEBUG) { console.log(dir , 'deleted err!', e.message); }
			});
		}
	}

	function showTab(num) {

		_selectedTab = num;
		
		if (num === 1) {
			if ($('#wrapperMyTab1 li').length > 0) {
				_wrapper1El.removeClass('no');
			} else {
				_wrapper1El.addClass('no');
			}
			if (_needTab1Refresh === true) {
				getMyHistory();
			}
		} else if (num === 2) {
			if ($('#wrapperMyTab2 li').length > 0) {
				_wrapper2El.removeClass('no');
			} else {
				_wrapper2El.addClass('no');
			}
			if (_needTab2Refresh === true) {
				getBattleHistory();
			}
		} else if (num === 3) {
            if ($('#wrapperMyTab3 li').length > 0) {
				_wrapper3El.removeClass('no');
			} else {
				_wrapper3El.addClass('no');
			}
			if (_needTab3Refresh === true) {
				getChallengeHistory();
			}
        }

        $('#pageMy .body')[0].className = 'body tab' + num + '_on';
		refresh();
	}

    function _onTouchEndTab1(e) {
        var i = 4,
            target = e.target,
            historyId,
            isDelete = false;

        while(i--) {
            // console.log(target.tagName);

            if (target.tagName === 'BODY') { return; }
            if (target.tagName === 'BUTTON') {
                isDelete = true;
                historyId = $(target.parentNode.parentNode).attr('data-item');
                break;
            }
            if (target.tagName === 'LI') {
                historyId = $(target).attr('data-item');
                break;
            }
            target = target.parentNode;
        }


        if (historyId) {
            $(target).addClass('pressed');

            setTimeout(function() {
                $(target).removeClass('pressed');
                if (_DEBUG) { console.log('historyId', historyId); }

                if (isDelete) {
                    _deleteMyHistory(historyId);
                    $(target.parentNode.parentNode).remove();
                    showTab(1);
                } else {
                    _goMyItem(historyId);
                }
            }, 200);
        }
    }

    function _onTouchEndTab2(e) {
        var i = 4,
            target = e.target,
            battleId,
            isDelete = false;

        while(i--) {
            if (target.tagName === 'BODY') { return; }
            if (target.tagName === 'BUTTON') {
                isDelete = true;
                battleId = $(target.parentNode.parentNode).attr('data-item');
                break;
            }
            if (target.tagName === 'LI') {
                battleId = $(target).attr('data-item');
                break;
            }
            target = target.parentNode;
        }


        if (battleId) {
            $(target).addClass('pressed');

            setTimeout(function() {
                $(target).removeClass('pressed');
                if (_DEBUG) { console.log('battleId', battleId); }

                if (isDelete) {
                    _deleteBattleHistory(battleId);
                    $(target.parentNode.parentNode).remove();
                    showTab(2);
                } else {
                    _goBattleItem(battleId);
                }
            }, 200);
        }
    }

    function _onTouchEndTab3(e) {
        var i = 4,
            target = e.target,
            historyId,
            isDelete = false;

        while(i--) {
            // console.log(target.tagName);

            if (target.tagName === 'BODY') { return; }
            if (target.tagName === 'BUTTON') {
                isDelete = true;
                historyId = $(target.parentNode.parentNode).attr('data-item');
                break;
            }
            if (target.tagName === 'LI') {
                historyId = $(target).attr('data-item');
                break;
            }
            target = target.parentNode;
        }


        if (historyId) {
            $(target).addClass('pressed');

            setTimeout(function() {
                $(target).removeClass('pressed');
                if (_DEBUG) { console.log('historyId', historyId); }

                if (isDelete) {
                    _deleteChallengeHistory(historyId);
                    $(target.parentNode.parentNode).remove();
                    showTab(3);
                } else {
                    _goChallengeItem(historyId);
                }
            }, 200);
        }
    }

    function resetStatus() {
        if (_DEBUG) { console.log('pageMy 현재는 resetStatus 없습니다.'); }
	}
	
	function initPage(){
		xx.scroll.addScroll({wrapperId:'wrapperMyTab1', onTouchEnd: _onTouchEndTab1});
		xx.scroll.addScroll({wrapperId:'wrapperMyTab3', onTouchEnd: _onTouchEndTab3});
		xx.scroll.addScroll({wrapperId:'wrapperMyTab2', onTouchEnd: _onTouchEndTab2});
    }
	
	ax.def(oPage)
		.property('needTab1Refresh', function() { return _needTab1Refresh; }, function(val) { _needTab1Refresh = val; })
		.property('needTab2Refresh', function() { return _needTab2Refresh; }, function(val) { _needTab2Refresh = val; })
        .property('needTab3Refresh', function() { return _needTab3Refresh; }, function(val) { _needTab3Refresh = val; })
		.property('historyMyResult', function() { return _historyMyResult; })
		.property('historyBattleResult', function() { return _historyBattleResult; })
        .property('historyChallengeResult', function() { return _historyChallengeResult; })
		.method('refresh', refresh)
		.method('showTab', showTab)
		.method('showScroll', showScroll)
		.method('initPage', initPage)
		.method('getMyHistory', getMyHistory)
		.method('getBattleHistory', getBattleHistory)
		.method('resetStatus', resetStatus);
		
	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!
// }catch(e){
	// console.log('page_my.js def err ', e.message); 
// }
}(window));