/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageSelectFace',
		oPage = {},
		_DEBUG = !!g._DEBUG;

	var _targetFile,
		_targetElement,
		_rectData,
		_isLock = false,
		_autoSelectTimer;
	
	function cancelAutoSelect() {
		if (_autoSelectTimer) {
			g.clearTimeout(_autoSelectTimer);
		}
		_autoSelectTimer = undefined;
	}
		
	function _selectFaceEvent(e) {
		try{
            if (_DEBUG) { console.log('CHECK _selectFaceEvent called'); }

            if (_isLock) { return; }
            _isLock = true;

            cancelAutoSelect();

            var idx = 0;
            if (typeof e !== 'number') {
                idx = parseInt($(this).attr('id'), 10);
            } else { // XXX:  숫자로 넘어온 경우 자동 이동 ㅠㅠ
                idx = e;
            }

            var startFinding = function() {
                if (_DEBUG) { console.log('startFinding'); }
                $('#global_loading').addClass('finding');

                xx.page.pageFinding.show(function(){
                    setTimeout(function() {
                        if (app.pageFind.findMode === 'find') {
                            app.pageFinding.whois(_rectData, idx);
                        } else {
                            app.pageFinding.challenge(_rectData, idx);
                        }
                        setTimeout(function() {
                            xx.page.pageSelectFace.hide();
                        }, 500);
                    }, 500);
                });
            };

            if (_rectData.sourceImageUrl) {
                var tfile = _rectData.image[idx],
                    tdir = tfile.substring(0, tfile.lastIndexOf('/')),
                    tfilename = tfile.substring(tfile.lastIndexOf('/')+1, tfile.length);

                app.api.crop(function(cropurl){
                    if (_DEBUG) { console.log('CROP PROCESS:', cropurl, tfile , tdir , tfilename); }

                    xx.download.download(cropurl, tdir, tfilename, function(){
                        startFinding();
                        if (_DEBUG) { console.log('download success!', tfile); }
                    }, function(e){
                        app.common.alert(function(){ xx.page.back(); }, app.nls.get('error_whois_message'));
                        if (_DEBUG) { console.log('download err (' + tfile + ')', e.message); }
                    });


                }, function(e) {
                    app.common.alert(function(){ xx.page.back(); }, app.nls.get('error_whois_message'));
                    //alert('error!!!!', e.message);
                }, _rectData.sourceImageUrl, _rectData.rect[idx]);


            } else {
                startFinding();
            }
            app.common.isLoading = true;

        } catch(err) {
            if (_DEBUG) { console.log('pageSelect _selectFaceEvent err' + err.message); }
        }
	}

	
	function setTargetImage() {
		
		var data = app.pageFind.targetImageData;
		if (_DEBUG) { console.log('pageSelect data', data); }
		
		_rectData = data;
		if (_DEBUG) { console.log('pageSelect data', data); }
		//if (_DEBUG) { data = data || ax.util.decodeJSON('{"image":["wgt-private-tmp/pick1.jpg","wgt-private-tmp/pick2.jpg"],"pgm":["wgt-private-tmp/pick1.pgm","wgt-private-tmp/pick2.pgm"],"rect":["304|245|111|111","60|276|135|135"],"sourceImage":"removable/pudface3.jpg"}'); }
		_targetFile = '/appspresso/file/' + data.sourceImage;
		
		if (!_targetElement) {
			_targetElement = $('#faceTargetImage');
			//$('#faceImageArea').css({width: '100%', height: xx.page.wrapperHeight, border: '3px solid #000'});
			
			_targetElement.css('maxWidth', xx.page.screenWidth);
		}
		
		var ts = new Date().getTime();
		_targetElement.attr('src', _targetFile + '?' + ts);
		
		if (!data.rect) {
			_targetElement.css({height:'', width: ''});
			
			$('#selectFaceInfo').addClass('noface');
			$('#selectFaceInfo .nofaceinfo').removeClass('hide');
			
			$('#pageSelectFace .btn_use').removeClass('off');
			
			_targetElement.animate({opacity:1},500);
			app.common.isLoading = false;
			return;
		}
		var position = data.rect,
			wrapperHeight = xx.page.wrapperHeight;
			
		if (_DEBUG) { console.log(_targetFile, position); }
		
		$('<img/>').attr('src', _targetFile + '?' + ts)
			.load(function(){
				try{
					var width = this.width,
						height = this.height,
						key,
						i,
						faceCount = 0;
					
					var relativeLeft = 0;
					
					
					
					var nh, nw, rate;
					if(height > width && height > wrapperHeight) {
						nh = wrapperHeight;
						rate = parseInt(nh, 10) / parseInt(height, 10);
						nw = parseInt(width, 10) * rate;
						
						if (width >= g.innerWidth) {
							nw = g.innerWidth;
							rate =  parseInt(nw, 10) / parseInt(width, 10);
							nh = parseInt(height, 10) * rate;
						} else {
							relativeLeft = (xx.page.screenWidth - nw) /2;
							console.log('relativeLeft', relativeLeft);
						}
						
						_targetElement.css({height:nh, width: nw});

					} else {
						nw = g.innerWidth;
						rate = parseInt(nw, 10) / parseInt(width, 10);
						nh = parseInt(height, 10) * rate;
						
						_targetElement.css({height:nh, width: nw});
					}
					
					
					var makeRect = function() {
						var alignTop = _targetElement.position().top,
                            key,
                            keyAutoSelect;

						for (key in position) {
							if (position.hasOwnProperty(key)) {
								var pos = position[key].split('|');
								//console.log(key, pos);
								for(i=0; i<4; i++) {
									pos[i] = pos[i] * rate;
								}
								// console.log(key, pos, '=============');
								if (_DEBUG) { console.log('width', width, 'height', height, 'nh', nh, 'nw', nw, ' 탑', (pos[1] + alignTop)); }

								//XXX: 뷰포트 아래 얼굴인식 영역은 무시.
								if ( (pos[1] + alignTop) < 280) {
									$('#faceRectTemplate')
										.clone()
										.attr('id',key)
										.css({top:pos[1] + alignTop, left:pos[0] + relativeLeft, height: pos[3], width: pos[2], display: 'block'})
										.appendTo('#faceImageArea')
										.bind('touchstart', _selectFaceEvent);
									faceCount++;
                                    keyAutoSelect = g.parseInt(key, 10);
								}
							}
						}
						
						_targetElement.animate({opacity:1},500);
						
						if (faceCount === 0) {
							_targetElement.css({height:'', width: ''});
							
							$('#selectFaceInfo').addClass('noface');
							$('#selectFaceInfo .nofaceinfo').removeClass('hide');
							
							$('#pageSelectFace .btn_use').removeClass('off');
							
							//_targetElement.css('opacity',1);
							return;
						} else if (faceCount > 1) {
							$('#multi_user_desc').removeClass('hide');
							$('#pageSelectFace .btn_use').removeClass('off');
						} else {
							_autoSelectTimer = setTimeout(function() {
								_selectFaceEvent(keyAutoSelect);
							}, 5000);
						}

						//읿부단말에서 바탕화면 깜박임으로 인한 버그 수정
						$('#pageSelectFace .complete').css({'visibility':'visible','opacity':'1'}).removeClass('hide').after(function(){
							setTimeout(function(){
								$('#pageSelectFace .complete').animate({opacity:0}, 500, function(){
									$('#pageSelectFace .complete').css('visibility','hidden');
								});
							}, 1000);
						});
						/*
						$('#pageSelectFace .complete').removeClass('hide').after(function(){
							setTimeout(function(){
								$('#pageSelectFace .complete').animate({opacity:0}, 500, function(){
									$('#pageSelectFace .complete').addClass('hide').after(function(){
										$('#pageSelectFace .complete').css({opacity:1});
									});
								});
							}, 1000);
						});
						*/
					};
					
					setTimeout(function() {
						makeRect();
					}, 500);

				}catch(e){
					//alert(e.message);
				}
			});
		
	}
	
	function removeRect() {
		$.each($('#pageSelectFace .faceRect'), function(){
			if($(this).css('display') !== 'none'){ 
				$(this).remove(); 
			}
		});
		
		_targetElement.css('opacity',0);
		$('#multi_user_desc').addClass('hide');
		$('#selectFaceInfo').removeClass('noface');
		$('#selectFaceInfo .nofaceinfo').addClass('hide');
		$('#pageSelectFace .btn_use').addClass('off');
		$('#faceTargetImage').attr('src','image/beacon.png');
		_isLock = false;
		
	}



    //사진선택 화면 박스 사이즈 계산 스크립트_영일추가
    var w = window.innerWidth,
        h = window.innerHeight,
        box = window.innerWidth - 80,
        iosbox = window.innerWidth - 60,
        arrow = box + 80,
        iosarrow = box + 60,
        bottom = window.innerHeight - box,
        iosbottom = window.innerHeight - iosbox;

    function initPage() {
		//app.nls.update('#pageSelectFace');
		
		$('#faceImageArea').css({'height': w + 'px', 'width': w + 'px'});
		$('.box_photo').css({'height': iosbox + 'px', 'width': iosbox + 'px'});
		$('.box_bot').css({'height': iosbottom + 'px'});
		$('#multi_user_desc').css({'top': (iosarrow+10) + 'px'});
		
		//$('#select_bnr').attr('src', 'locales/' + app.nls.langApp + '/image/select_bnr.png');
	}

	ax.def(oPage)
		.property('targetImage', function(){ return _targetFile; })
		.method('cancelAutoSelect', cancelAutoSelect)
		.method('setTargetImage', setTargetImage)
		.method('removeRect', removeRect)
		.method('initPage', initPage);

	ax.def(g.app).constant(pageID, oPage);

	
	initPage();

	
// }catch(e){
	// console.log('page_select_face.js def err ', e.message); 
// }
}(window));