/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app, 
		pageID = 'pageSetting',
		oPage = {},
		_DEBUG = g._DEBUG || false;
	
	function updateStarCategoryUI(starCategory) {
		try{
			starCategory = starCategory || app.common.getPreference('starCategory');
			$('#pageSetting #btnStarCountry .account').html(app.nls.get('setting_country_' + starCategory));
		
			$('#pageSettingCountry li').each(function(){
				$(this).removeClass('selected');
			});
			$('#' + starCategory).addClass('selected');
			
			$('#pageSettingCountry li.' + starCategory).addClass('selected');
			
		} catch (e) {
			if (_DEBUG) { console.log('pageSettingCountry가 열리지 않아 error throw. 의도된 예외상황...'); }	
		}
	}
	
	function updatePreference() {
		
		var pref = app.common.getPreference(),
			key;
		
		for (key in pref) {
			if (pref.hasOwnProperty(key)) {
				$('#setup_' + key + 'Check').attr('checked', (pref[key] === 'true') ? true : false);
			}
		}
		
	}
	
	function updateTwitterUI() {
		if (twitter.is_connected) {
			document.body.querySelector('#option_twitter .account').innerHTML = '@' + twitter.user_name;
		} else {
			document.body.querySelector('#option_twitter .account').innerHTML = '';
		}
	}
	
	function updateFacebookUI() {
		try{
			if (facebook.is_connected) {
				document.body.querySelector('#option_facebook .account').innerHTML = facebook.user_name;
			} else {
				document.body.querySelector('#option_facebook .account').innerHTML = '';
			}
		} catch (e){
			console.log('updateFacebookUI err', e.message);
		}
	}
	
	function updateAutoSaveUI(value) {
		value = value || app.common.getPreference('autosave');
		
		//console.log('updateAutoSaveUI', value);
		if (value === 'true') {
			$('#btnAutoSave .btn').removeClass('off');
		} else {
			$('#btnAutoSave .btn').addClass('off');
		}
	}
	
	function onClickTwitter() {
		try{
			
			var connectTwitter = function() {
				twitter.connect(function() {
					xx.page.back();
					updateTwitterUI();
				}, function(e) {
					console.log('twitter account setting fail:', e.message);
					xx.page.back();
					updateTwitterUI();
				});
			};
		
		
			if (twitter.is_connected) {
				var opts = {'positive': app.nls.get('common_ok'), 'negative': app.nls.get('common_cancel')};
				ax.ext.ui.confirm(function(yes) {
					if (yes) {
						twitter.disconnect();
						//connectTwitter();
						updateTwitterUI();
					}
				}, app.nls.get('share_t_unlink'), opts);
			} else {
				
				xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('share_headline_twitter');
				xx.page.pageEmpty.show();
				connectTwitter();
				
			}
		}catch(e){
			console.log('onClickTwitter err:' , e.message);
		}
	}
	
	
	
	function onClickFacebook() {
		try{
	
			var connectFacebook = function() {
				console.log('connectFacebook');
				facebook.connect(function() {
					xx.page.back();
					updateFacebookUI();
				}, function(e) {
					console.log('facebook account setting fail:', e.message);
					xx.page.back();
					updateFacebookUI();
				});
			};
	
			if (facebook.is_connected) {
				var opts = {'positive': app.nls.get('common_ok'), 'negative': app.nls.get('common_cancel')};
				ax.ext.ui.confirm(function(yes) {
						if (yes) {
							facebook.disconnect();
							updateFacebookUI();
							
							xx.download.db = {};
							xx.fexplorer.deleteFile('downloads/fb', function(){
								xx.fexplorer.createDirectory('downloads/fb', function() {
									if (_DEBUG) { console.log('downloads/fb folder create success'); }
								}, function(e){
									if (_DEBUG) { console.log('downloads/fb folder create err', e.message); }
								});
							});
							xx.fexplorer.writeFile('documents/download.json', '{}', false);
							xx.fexplorer.writeFile('documents/facebook.json', '{}', false);
							
							
							if (typeof app.pageFacebookGallery !== 'undefined') {
								app.pageFacebookGallery.resetStatus();
							}
						} 
					}, app.nls.get('share_f_unlink'), opts);
			} else {
				
				xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('share_headline_facebook');
				xx.page.pageEmpty.show();
				setTimeout(function(){
					connectFacebook();
				}, 320);
				
			}
		}catch(e){
			console.log('onClickFacebook err:' , e.message);
		}
	}

	function onCountryTouchEnd(e) {
		console.log('onCountryTouchEnd', e);	
		var target = e.target,
			i=4,
			country,
			starCategory;

		while(i--) {
			if(target.tagName === 'LI') {
				break;
			}
			target = target.parentNode;
		}
		
		country = $(target).attr('title');
		if (!country) { return; }
		
		$(target).addClass('pressed');
		
		
		setTimeout(function() {
			$(target).removeClass('pressed');

			switch(country) {
				case 'btnCountryKorea':
					starCategory = 'KR';
					break;
				case 'btnCountryKorean':
					starCategory = 'AS';
					break;
				case 'btnCountryJapan':
					starCategory = 'JP';
					break;
				case 'btnCountryChinese':
					starCategory = 'CH';
					break;
				case 'btnCountryHollywood':
					starCategory = 'US';
					break;
				case 'btnCountryAll':
					starCategory = 'ALL';
					break;
				default:
					starCategory = 'ALL';
					break;
			}
			
			updateStarCategoryUI(starCategory);
			
			app.common.setPreference('starCategory', starCategory);
		}, 200);
	}

	function onOptionTouchEnd(e) {
		var target = e.target,
			i=4;

		while(i--) {
			if(target.tagName === 'LI') {
				if (target.id) { target.className += ' pressed'; /*target.style.backgroundColor = '#3575ed'; target.style.color = '#fff';*/ }
				break;
			} else if (target.tagName === 'BUTTON') {
				if (app.common.getPreference('autosave') === 'true') {
					updateAutoSaveUI('false');
					app.common.setPreference('autosave', 'false');
				} else {
					updateAutoSaveUI('true');
					app.common.setPreference('autosave', 'true');
				}
				return;
			}
			target = target.parentNode;
		}
		
		setTimeout(function(){
			//target.style.backgroundColor = '';
			//target.style.color = '';
			
			target.className = target.className.replace('pressed','');
			
			switch (target.id){
			case 'btnStarCountry':
				xx.page.pageSettingCountry.show();
				break;
			case 'btnAutoSave':

				break;
			case 'btnAnimation':
				
				if (app.common.getPreference('animation') === 'true') {
					app.common.setPreference('animation', 'false');

					$(g.document.body).addClass('nofx');
					
					$('#setup_animationCheck').attr('checked', false);
					if (_DEBUG) { console.log('animation off'); }

				} else {
					app.common.setPreference('animation', 'true');
					$(g.document.body).removeClass('nofx');
					
					$('#setup_animationCheck').attr('checked', true);
					
					if (_DEBUG) { console.log('animation on'); }
				}
				
				break;
			case 'btnUseSplash':
				if (app.common.getPreference('useSplash') === 'false') {
					app.common.setPreference('useSplash', 'true');
				} else {
					app.common.setPreference('useSplash', 'false');
				}
				break;
			case 'btnAnimationType':
				if (app.common.getPreference('animationType') === 'fade') {
					app.common.setPreference('animationType', 'slide');
					xx.page.setAnimationType('slide');
				} else {
					app.common.setPreference('animationType', 'fade');
					xx.page.setAnimationType('fade');
				}
				break;
			case 'option_twitter':
				onClickTwitter();
				break;
			case 'option_facebook':
				onClickFacebook();
				break;
			case 'setup_puddingCamera':
			case 'setup_puddingTo':
			case 'setup_puddingFace':
			case 'setup_puddingTwitter':
			case 'setup_puddingBlog':
			case 'setup_help':
			case 'setup_utos':
				var nlsTmp = $('#'+target.id + ' span').attr('nls-key'),
					zoomDensity,
					url = app.nls.get($('#'+target.id).attr('nls-link-key'));
				
				if (nlsTmp === 'setting_pudding_twitter') {
					nlsTmp += '_headline';
				} else if (nlsTmp === 'setting_pudding_blog' && app.pageMain.settingIdx) {
					app.common.setPreference('settingIdx', app.pageMain.settingIdx);
					$('#pageMain .new').addClass('hide');
				} else if (nlsTmp === "setting_pudding_help") {
					zoomDensity = 'FAR';
				} else if (nlsTmp === 'setting_pudding_face' || nlsTmp === 'setting_pudding_camera' || nlsTmp === 'setting_pudding_to') {
					url += app.pageMain.telco;
				}
				xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get(nlsTmp);
				xx.page.pageEmpty.show();
				app.common.addWebView(url, undefined, zoomDensity);
				break;

			}
			
			
			
		}, 200);

	}

	
	function initPage(){
		$('#setup_versionText').html(app.def.APP_VERSION);
		
		if(typeof xx.scroll.wrapperSetting === 'undefined'){
			var scrollOption = {
				'wrapperId': 'wrapperSetting',
				scrollbarClass: 'noScroll',
				onTouchEnd: onOptionTouchEnd
			};
			xx.scroll.addScroll(scrollOption);
		}
	}
	
	function updateUI() {

		updateFacebookUI();
		updateTwitterUI();
		updatePreference();
		updateAutoSaveUI();
		updateStarCategoryUI();
		
		if(xx.scroll.wrapperSetting) {
			setTimeout(function(){ 
				xx.scroll.wrapperSetting.refresh();
			}, 100);
		}
		
		if (app.pageMain.settingIdx) {
			if (app.pageMain.settingIdx !== app.common.getPreference('settingIdx')) {
				$('#wrapperSetting .newIcon').removeClass('hide');
			} else {
				$('#wrapperSetting .newIcon').addClass('hide');
			}
		}
		
		
	}
	
	ax.def(oPage)
		.method('updateUI', updateUI)
		.method('updateFacebookUI', updateFacebookUI)
		.method('updateTwitterUI', updateTwitterUI)
		.method('updateStarCategoryUI', updateStarCategoryUI)
		.method('updatePreference', updatePreference)
		.method('updateAutoSaveUI', updateAutoSaveUI)
		.method('onCountryTouchEnd', onCountryTouchEnd)
		.method('initPage', initPage);

	ax.def(g.app).constant(pageID, oPage);
	
	initPage(); // 즉시실행!!
// }catch(e){
	// console.log('page_setting.js def err ' + e.message);
// }
}(window));

