/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g) {
	"use strict";
	
	var _DEBUG = !!g._DEBUG;
	
	var ax = g.ax,	// require('ax');
        xx = g.xx,
		app = g.app;
	
	_DEBUG = true;

    var isMobile = (xx.page.platform !== 'pc');

	/**
	 * MUST MAVE TO CHANGE APP_ID
	 * http://developers.facebook.com/
	 */
	var APP_ID = '337499799670404';
	var APP_SECRET = '91085e585e061961cbcebe2aa693f500';

    var CONNECT_CALLBACK_URL_PREFIX = 'http://korcelebatch.pudding.kr/social_authorize.html';
    var DISCONNECT_CALLBACK_URL_PREFIX = 'http://korcelebatch.pudding.kr/social_deauthorize.html';

	var CONNECT_URL = 'https://www.facebook.com/dialog/oauth?client_id=' + APP_ID  + '&scope=user_photos,friends_photos,read_stream,publish_stream&response_type=token&display=touch&redirect_uri=' + encodeURI(CONNECT_CALLBACK_URL_PREFIX);
	var DISCONNECT_URL = 'https://www.facebook.com/logout.php?next=' + encodeURI(DISCONNECT_CALLBACK_URL_PREFIX) + '&access_token=';
	var ACCESS_TOKEN_URL = 'https://graph.facebook.com/oauth/access_token?client_id=' + APP_ID + '&grant_type=fb_exchange_token&client_secret=' + APP_SECRET + '&fb_exchange_token=';
	
	// deprecatied api
	//var DISCONNECT_URL = 'http://api.facebook.com/method/auth.expireSession?access_token=';
	//var DISCONNECT_URL = 'http://www.facebook.com/logout.php';//?confirm=1&next=' + DISCONNECT_CALLBACK_URL_PREFIX;
	var GRAPH_USER_URL = "https://graph.facebook.com/me";
	var GRAPH_PHOTO_POST_URL = "https://graph.facebook.com/me/photos";
	var GRAPH_ALBUMS_URL = "https://graph.facebook.com/me/albums?fields=id&access_token=";
	var GRAPH_FEED_URL = "https://graph.facebook.com/me/feed";
	var GRAPH_URL = "https://graph.facebook.com/";
	
	
	var PREFS_STORAGE_KEY = 'facebook_oauth_prefs';
	var _prefs = {
		access_token: null,
		user_id: null,
		user_name: null
	};
	

	function save_prefs() {
		app.common.setPreference(PREFS_STORAGE_KEY, JSON.stringify(_prefs));
		//g.localStorage.setItem(PREFS_STORAGE_KEY, JSON.stringify(_prefs));
	}
	
	function access_token(callback, errback) {
        var opts = {
			method:'GET',
            type: 'GET',
            dataType: 'json',
			url: ACCESS_TOKEN_URL + _prefs.access_token,
			//params: {  },
			success:function(result) {
				try{
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}

				var i,
					len,
					tmp,
					res = result.data.split('&');

				for (i=0, len=res.length; i<len; i++) {
					tmp = res[i].split('=');

					if (tmp[0] === 'access_token') {
						_prefs.access_token = tmp[1]||'';
					} else if (tmp[0] === 'expires') {
						_prefs.expires = tmp[1]||'';
					}
				}

				save_prefs();
				if(_DEBUG) { console.log('facebook fb_exchange_token success:', _prefs); }
				if(typeof callback === 'function') { callback(_prefs); }
				}catch(e){
					console.log('aa', e.message);
				}
			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook fb_exchange_token error:', e); }
				if(typeof errback  === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            ax.ext.net.curl();
        } else {
            $.ajax(opts);
        }
		
	}
	
	function load_prefs() {
		try {

			if (app.common.getPreference(PREFS_STORAGE_KEY)) {
				_prefs = JSON.parse(app.common.getPreference(PREFS_STORAGE_KEY));
			}
			
			//if(_DEBUG) { console.log('facebook load_prefs ok:', _prefs); }
		} catch(e) {
			if(_DEBUG) { console.log('facebook load_prefs error:', e); }
		}
	}
	
	function user_profile(access_token, callback, errback) {

        var scb = function(result) {
            if(result.status < 200 || result.status >= 300) {
                if(typeof errback  === 'function') { errback(result.status); }
                return;
            }
            var data = (isMobile) ? JSON.parse(result.data) : result;
            _prefs.access_token = access_token||'';
            _prefs.user_id = data.id||'';
            _prefs.user_name = data.name||'';
            if(_DEBUG) { console.log('facebook user_profile success:', data); }
            save_prefs();
            if(typeof callback === 'function') { callback(data); }
        };
        var ecb = function(e) {
            save_prefs();
            if(_DEBUG) { console.log('facebook user_profile error:', e); }
            if(typeof errback  === 'function') { errback(e); }
        };

        if (isMobile) {
            ax.ext.net.curl({
                method:'GET',
                url: GRAPH_USER_URL + '?access_token=' + encodeURIComponent(access_token),
                //params: {  },
                success: scb,
                error: ecb
            });
        } else {
            $.ajax({
                type:'GET',
                dataType: 'json',
                url: GRAPH_USER_URL + '?access_token=' + encodeURIComponent(access_token),
                success: scb,
                error: ecb
            });
        }
	}

	function decodeQueryString(query) {
		var params = {};
		if(query) {
			var tmp = query.split('&'),
				i,
				len = tmp.length,
				pair,
				kv;
			
			for (i=0; i<len; i++){
				pair = tmp[i];
				kv = pair.split('=');
				if(kv.length === 2) {
					params[decodeURIComponent(kv[0])] = decodeURIComponent(kv[1]);
				}
			}
		}
		return params;
	}
	
	function connect(callback, errback) {
		var url = CONNECT_URL;
		if(_DEBUG) { console.log('facebook connect...'); }
	
		function hookCallbackUrl(callbackUrl) {
			
			if (callbackUrl.indexOf('http://m.facebook.com/home.php') === 0) {
				// XXX: 갑자기 m.facebook.com/home.php로 넘어감 ㅠㅠ
				if (isMobile) { ax.ext.ui.removeWebView(); }
				connect(callback, errback);
				return;
			}
			
			if(callbackUrl.indexOf(CONNECT_CALLBACK_URL_PREFIX) !== 0) {
				return;
			}

			
			if(_DEBUG) { console.log('facebook connect callback: ' + callbackUrl); }
			if (isMobile) { ax.ext.ui.removeWebView(); }

			var data = decodeQueryString(callbackUrl.substring(callbackUrl.indexOf('#') + 1));

			if(data.access_token) {
				user_profile(data.access_token, callback, errback);
			} else {
				if(typeof errback === 'function') { errback(data); }
			}
		}
	
		g.app.common.addWebView(url, hookCallbackUrl);
	}
	
	function getUserProfile(callback, errback){
        if(!_prefs.access_token) {
			connect(function() {
				getUserProfile(callback, errback);
			});
			return;
		} else {
            user_profile(_prefs.access_token, callback, errback);
        }
	}

	function disconnect() {
		if(_DEBUG) { console.log('facebook disconnect...'); }
	
	
		var url = DISCONNECT_URL + encodeURIComponent(_prefs.access_token);
	
		g.app.common.addWebView(url, function(callbackUrl) {
			if (callbackUrl.indexOf(DISCONNECT_CALLBACK_URL_PREFIX) !== 0) {
				return;
			}
            if (isMobile) { ax.ext.ui.removeWebView(); }
		});
		
		_prefs.access_token = null;
		_prefs.user_id = null;
		_prefs.user_name = null;
		
		save_prefs();
		
	}
	
	function post_feed(message, callback, errback) {
		if(!_prefs.access_token) {
			connect(function() {
				post_feed(message, callback, errback);
			});
		}

        var opts = {
			method:'POST',
            type: 'POST',
            dataType: 'json',
			url: GRAPH_FEED_URL,
			success:function(result) {
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}
				var data = (isMobile) ? JSON.parse(result.data) : result;
				if(_DEBUG) { console.log('facebook post_feed success:', data); }
				if(typeof callback === 'function') { callback(data); }
			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook post_feed error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            opts.params = { 'access_token': _prefs.access_token, 'message': message };
            ax.ext.net.curl();
        } else {
            opts.data = { 'access_token': _prefs.access_token, 'message': message };
            $.ajax(opts);
        }
	}
	
	function post_photo(message, image, callback, errback) {
		ax.ext.net.curl({
			method:'POST',
			url: GRAPH_PHOTO_POST_URL,
			params: { 'access_token': _prefs.access_token, 'message': message },
			files: { 'source': image },
			success:function(result) {
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}
				var data = JSON.parse(result.data);
				if(_DEBUG) { console.log('facebook post_photo success:', data); }
				if(typeof callback === 'function') { callback(data); }
			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook post_photo error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});
	}
	
	function post(message, image, callback, errback) {
		if(!_prefs.access_token) {
			if(_DEBUG) { console.log('signin with facebook and try again...'); }
			connect(function() {
				post(message, image, callback, errback);
			}, errback);
			return;
		}
	//		post_feed(message, callback, errback);
	
		if(image) {
			post_photo(message, image, callback, errback);
		} else {
			post_feed(message, callback, errback);
		}
	}

    // facebook.friendsPictures(function(o){console.log(ax.util.dump(o));}, function(e){console.log(e.message);}, {friends:[311300426,535629184,634267953,703228425,730931473], width: 300})
    function friendsPictures(callback, errback, optParam) {
        // opts = {friends:[311300426,535629184,634267953,703228425,730931473], width: 300}

        var batch = [],
			i,
			len,
			tmp,
            friends = optParam.friends,
            width = optParam.width;

		for (i=0, len = friends.length; i<len; i++) {
			tmp = {
					"method": "GET",
					"relative_url": friends[i] + '?fields=picture.width(' + width + '),id'
                    //"relative_url": friends[i] + '/picture?width=' + width
			};
			batch.push(tmp);
		}

        //console.log(ax.util.dump(batch));

        var opts = {
            method: 'POST', // for ax.ext.net
            type: 'POST',   // for jquery
			url: GRAPH_URL,
            dataType: 'json',
			success:function(result) {

				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}


				var data = (isMobile) ? JSON.parse(result.data) : result,
                    item;

				var i,
					len,
					pictures = [];

				for (i=0, len=data.length; i<len; i++) {
                    if (data[i].code === 200) {
                        item = JSON.parse(data[i].body);
                        // console.log(item.id,ax.util.dump(item));
                        pictures.push({
                            id: item.id,
                            picture: item.picture.data.url
                        });
                    }
				}

				if(_DEBUG) { console.log('facebook friendsPictures success:', pictures); }
				if(typeof callback === 'function') { callback(pictures); }

			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook friendsPictures error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            opts.params = {'access_token': encodeURIComponent(_prefs.access_token) ,'batch': JSON.stringify(batch)};
            ax.ext.net.curl(opts);
        } else {
            opts.data = {'access_token': encodeURIComponent(_prefs.access_token) ,'batch': JSON.stringify(batch)};
            $.ajax(opts);
        }



    }
	
	function friends(callback, errback) {
		if(!_prefs.access_token) {
			connect(function() {
				friends(callback, errback);
			});
		}

		var url = 'https://graph.facebook.com/' + _prefs.user_id + '/friends?access_token=' + encodeURIComponent(_prefs.access_token);
        var opts = {
			method:'GET',
			url: url,
            dataType: 'json',
			success:function(result) {
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}
				var data = (isMobile) ? JSON.parse(result.data) : result;
				if(_DEBUG) { console.log('facebook get friends success:', data); }
				if(typeof callback === 'function') { callback(data); }
			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook get friends error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            ax.ext.net.curl(opts);
        } else {
            $.ajax(opts);
        }
	}
	
	
	function feeds(callback, errback) {
		if(!_prefs.access_token) {
			connect(function() {
				feeds(callback, errback);
			});
			return;
		}
		
		var url = 'https://graph.facebook.com/me/home?access_token=' + encodeURIComponent(_prefs.access_token);

        var opts = {
			method:'GET',
            type: 'GET',
            dataType: 'json',
			url: url,
			success:function(result) {
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}
				var data = (isMobile) ? JSON.parse(result.data) : result;
				if(_DEBUG) { console.log('facebook feeds success:', data); }
				if(typeof callback === 'function') { callback(data); }
			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook feeds error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            ax.ext.net.curl(opts);
        } else {
            $.ajax(opts);
        }
	}
	
	function _photos(albums, callback, errback) {
		
		var batch = [],
			i,
			len,
			tmp;

		for (i=0, len = albums.length; i<len; i++) {
			tmp = {
					"method": "GET",
					"relative_url": albums[i].id + "/photos?fields=picture,source"
			};
			batch.push(tmp);
		}

        var opts = {
            method: 'POST', // for ax.ext.net
            type: 'POST',   // for jquery
			url: GRAPH_URL,
            dataType: 'json',
			success:function(result) {

				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}

				var data = (isMobile) ? JSON.parse(result.data) : result;

				var i,
					len,
					photos = [];

				for (i=0, len=data.length; i<len; i++) {
					photos.push(JSON.parse(data[i].body).data);
				}

				if(_DEBUG) { console.log('facebook _photos success:', photos); }
				if(typeof callback === 'function') { callback(photos); }

			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook _photos error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            opts.params = {'access_token': encodeURIComponent(_prefs.access_token) ,'batch': JSON.stringify(batch)};
            ax.ext.net.curl(opts);
        } else {
            opts.data = {'access_token': encodeURIComponent(_prefs.access_token) ,'batch': JSON.stringify(batch)};
            $.ajax(opts);
        }
	}
	

	
	function photos(callback, errback) {	// 실제로는 album 목록 가져오기
		if(!_prefs.access_token) {
			connect(function() {
				photos(callback, errback);
			});
			return;
		}
		
		var url = GRAPH_ALBUMS_URL + encodeURIComponent(_prefs.access_token);

        var opts = {
			method:'GET',
			url: url,
            dataType: 'json',
			success:function(result) {
				if(result.status < 200 || result.status >= 300) {
					if(typeof errback  === 'function') { errback(result.status); }
					return;
				}
				var data = (isMobile) ? JSON.parse(result.data) : result;
				if(_DEBUG) { console.log('facebook feeds success:', data); }
				//if(typeof callback === 'function') { callback(data); }

				_photos(data.data, callback, errback);

			},
			error:function(e) {
				if(_DEBUG) { console.log('facebook feeds error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		};

        if (isMobile) {
            ax.ext.net.curl(opts);
        } else {
            $.ajax(opts);
        }
	}	
	
	//load_prefs();
	
	var facebook = {};
	
	ax.def(facebook)
		.method('connect', connect)
		.method('disconnect', disconnect)
		.method('friends', friends)
        .method('friendsPictures', friendsPictures)
		.method('feeds', feeds)
		.method('photos', photos)
		.method('post', post)
		.method('profile', getUserProfile)
		.method('user_home', function(userid) { return 'http://www.facebook.com/profile.php?id=' + (userid||_prefs.user_id); })
		.method('access_token', access_token)
		.method('load_prefs', load_prefs)
		.property('user_id', function() { return _prefs.user_id; })
		.property('user_name', function() { return _prefs.user_name; })
		.property('pref', function() { return _prefs; })
		.property('is_connected', function() { return !!_prefs.access_token; });
		
	
	//-----------------------------------------------------------
	
	ax.def(g).constant('facebook', facebook);

}(window));
