/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g) {
	"use strict";

	var _DEBUG = !!g._DEBUG;
	_DEBUG=true;
	var ax = g.ax,
		OAuth = g.OAuth,
		app = g.app;
	
	// twitter api
	
	/**
	 * MUST HAVE TO CHANGE CONSUMER_KEY & CONSUMER_SECRET
	 * https://dev.twitter.com/
	 */
	var CONSUMER_KEY = 'LTNvFpFuF9zAcaiT74cU1w';//XXX:secure!!
	var CONSUMER_SECRET = 'dzfqwGBUf5Sw9VdG4PapBCoN8hgs4JL8OC6XreiiHN8';//XXX:secure!!
	var CALLBACK_URL_PREFIX = 'http://apidev.pudding.kr/pud/twitter/mlangcallback.kth';//XXX:test
	
	var REQUEST_TOKEN_URL = 'https://api.twitter.com/oauth/request_token';
	var ACCESS_TOKEN_URL = 'https://api.twitter.com/oauth/access_token';
	var AUTHORIZE_URL = 'https://api.twitter.com/oauth/authorize';
	var STATUSES_UPDATE_URL = 'https://api.twitter.com/1/statuses/update.json';
	var TIMELINE_QUERY_URL = 'https://api.twitter.com/1/statuses/home_timeline.json';
	var UPLOAD_URL = 'https://upload.twitter.com/1/statuses/update_with_media.json';

	var PREFS_STORAGE_KEY = 'twitter_oauth_prefs';
	var _prefs = {
		token: null,
		tokenSecret: null,
		user_id: null,
		screen_name: null
	};
	
	function upload(file, status, callback, errback) {

		var accessor = {
			consumerKey: CONSUMER_KEY,
			consumerSecret: CONSUMER_SECRET,
			token: _prefs.token||null,
			tokenSecret: _prefs.token_secret||null
		};

		var message = {
			action: UPLOAD_URL,
			method: 'POST',
			parameters: {'status': status}
		};
		
		OAuth.completeRequest(message, accessor);
		OAuth.SignatureMethod.sign(message, accessor);
		
		if(_DEBUG) { console.log('twitter statuses update...'); }
		var headers = {'Content-Type': 'multipart/form-data', 'Authorization': OAuth.getAuthorizationHeader(null, message.parameters) };
		var params = { 'status': status };
		var files = { 'media[]': file };
		
		ax.ext.net.curl({
			method: 'POST',
			url: message.action,
			headers: headers,
			params: params,
			files: files,
			success: function(result) {
				console.log(result.data);
				if(result.status < 200 || result.status >= 300) {
					errback(result.status);
					return;
				}
				if(_DEBUG) { console.log('twitter update_with_media success:', result.data); }
				var data = JSON.parse(result.data);
				if(typeof callback === 'function') { callback(data); }
			},
			error: function(e) {
				console.log('error',e.message);
				if(_DEBUG) { console.log('twitter update_with_media error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});

	}
	
	function load_prefs() {
		try {
//			if (g.localStorage.getItem(PREFS_STORAGE_KEY)) {
//				_prefs = JSON.parse(g.localStorage.getItem(PREFS_STORAGE_KEY));
//			} 
			if (app.common.getPreference(PREFS_STORAGE_KEY)) {
				_prefs = JSON.parse(app.common.getPreference(PREFS_STORAGE_KEY));
			}
			//if(_DEBUG) { console.log('twitter load_prefs ok:', _prefs); }
		} catch(e) {
			if(_DEBUG) { console.log('twitter load_prefs error:', e); }
		}
	}
	
	function save_prefs() {
		//g.localStorage.setItem(PREFS_STORAGE_KEY, JSON.stringify(_prefs));
		app.common.setPreference(PREFS_STORAGE_KEY, JSON.stringify(_prefs));
	}
	
	function decodeQueryString(query) {
		var params = {};
		if(query) {
			var tmp = query.split('&'),
				i,
				len = tmp.length,
				pair,
				kv;
			
			for (i=0; i<len; i++){
				pair = tmp[i];
				kv = pair.split('=');
				if(kv.length === 2) {
					params[decodeURIComponent(kv[0])] = decodeURIComponent(kv[1]);
				}
			}
		}
		return params;
	}
	
	function access_token(data, callback, errback) {
		var accessor = {
			consumerKey: CONSUMER_KEY,
			consumerSecret: CONSUMER_SECRET,
			token: data.oauth_token,
			tokenSecret: null
		};
		
		var message = {
			action: ACCESS_TOKEN_URL,
			method: 'GET',
			parameters: { 'oauth_verifier': data.oauth_verifier }
		};
		
		OAuth.completeRequest(message, accessor);
		OAuth.SignatureMethod.sign(message, accessor);
	
		if(_DEBUG) { console.log('twitter access token...'); }
		var headers = { 'Authorization': OAuth.getAuthorizationHeader(null, message.parameters) };
	
		ax.ext.net.curl({
			method: 'GET',
			url: message.action,
			headers: headers,
			success: function(result) {
				if(result.status < 200 || result.status >= 300) {
					errback(result.status);
					return;
				}
				// we've got the long-time token/secret
				if(_DEBUG) { console.log('twitter access_token success:', result.data); }
				var data = decodeQueryString(result.data);
				_prefs.token = data.oauth_token;	
				_prefs.token_secret = data.oauth_token_secret;
				_prefs.user_id = data.user_id;
				_prefs.screen_name = data.screen_name;
				save_prefs();
				if(typeof callback === 'function') { callback(data); }
			},
			error: function(e) {
				if(_DEBUG) { console.log('twitter access_token error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});
	}
	
	function authorize(data, callback, errback) {
		var url = AUTHORIZE_URL + '?oauth_token=' + encodeURIComponent(data.oauth_token);
		if(_DEBUG) { console.log('twitter oauth authorize...'); }
		
		function hookCallbackUrl(callbackUrl) {
			if(callbackUrl.indexOf(CALLBACK_URL_PREFIX) !== 0) {
				return;
			}
			// using verifier, exchange one-time token with long-token
			if(_DEBUG) { console.log('twitter authorize success:', callbackUrl); }
			ax.ext.ui.removeWebView();
			var data = decodeQueryString(callbackUrl.substring(callbackUrl.indexOf('?') + 1));
			access_token(data, callback, errback);
		}
	
		g.app.common.addWebView(url, hookCallbackUrl, errback);
	}
	
	function connect(callback, errback) {
		
		var accessor = {
			consumerKey: CONSUMER_KEY,
			consumerSecret: CONSUMER_SECRET,
			token: null,
			tokenSecret: null
		};
		
		var message = {
			action: REQUEST_TOKEN_URL,
			method: 'GET'
		};
	
		OAuth.completeRequest(message, accessor);
		OAuth.SignatureMethod.sign(message, accessor);
	
		if(_DEBUG) { console.log('twitter connect request_token...'); }
		var headers = { 'Authorization': OAuth.getAuthorizationHeader(null, message.parameters) };
		if(_DEBUG) { console.log('twitter connect request_token...'); }
	
		ax.ext.net.curl({
			method: 'GET',
			url: message.action,
			headers: headers,
			success: function(result) {
				if(result.status === 401) {
					console.log('twitter oauth request token failed! try again!');
					console.log('twitter ', JSON.stringify(result));
					connect(callback, errback);
					return;
				}
				if(result.status < 200 || result.status >= 300) {
					errback(result.status);
					return;
				}
				// we've got the one-time token/secret
				if(_DEBUG) { console.log('twitter oauth request_token success:', result.data); }
				var data = decodeQueryString(result.data);
				authorize(data, callback, errback);
			},
			error: function(e) {
				if(_DEBUG) { console.log('twitter oauth request_token error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});
		if(_DEBUG) { console.log('twitter connect request_token...'); }
	}
	
	function disconnect() {
		_prefs.token = null;
		_prefs.token_secret = null;
		_prefs.user_id = null;
		_prefs.screen_name = null;
		save_prefs();
	}
	
	function timeline(callback, errback, since) {
		var accessor = {
			consumerKey: CONSUMER_KEY,
			consumerSecret: CONSUMER_SECRET,
			token: _prefs.token||null,
			tokenSecret: _prefs.token_secret||null
		};
		
		var message = {
			action: TIMELINE_QUERY_URL,
			method: 'GET'
		};
	
		if (since) {
			message.parameters = { 'since_id': since };
		}
		
		OAuth.completeRequest(message, accessor);
		OAuth.SignatureMethod.sign(message, accessor);
	
		var headers = { 'Authorization': OAuth.getAuthorizationHeader(null, message.parameters) };
		if (since) {
			message.action += '?since_id=' + since;
		}
		
		ax.ext.net.curl({
			method: 'GET',
			url: message.action,
			headers: headers,
			success: function(result) {
				if(result.status < 200 || result.status >= 300) {
					errback(result.status);
					return;
				}
				if(_DEBUG) { console.log('twitter fetch timeline success:', result); }
				var data = JSON.parse(result.data);
				if(typeof callback === 'function') { callback(data); }
			},
			error: function(e) {
				if(_DEBUG) { console.log('twitter fetch timeline error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});
	
	}
	
	function statuses_update(status, callback, errback) {

		var accessor = {
			consumerKey: CONSUMER_KEY,
			consumerSecret: CONSUMER_SECRET,
			token: _prefs.token||null,
			tokenSecret: _prefs.token_secret||null
		};
		
		var message = {
			action: STATUSES_UPDATE_URL,
			method: 'POST',
			parameters: { 'status': status }
		};
		
		OAuth.completeRequest(message, accessor);
		OAuth.SignatureMethod.sign(message, accessor);
		
		if(_DEBUG) { console.log('twitter statuses update...'); }
		var headers = { 'Authorization': OAuth.getAuthorizationHeader(null, message.parameters) };
		
		var params = {status: OAuth.getParameterMap(message.parameters).status};
		
		ax.ext.net.curl({
			method: 'POST',
			url: message.action,
			headers: headers,
			params: params,
			success: function(result) {
				if(result.status < 200 || result.status >= 300) {
					errback(result.status);
					return;
				}
				if(_DEBUG) { console.log('twitter statuses update success:', result.data); }
				var data = JSON.parse(result.data);
				if(typeof callback === 'function') { callback(data); }
			},
			error: function(e) {
				console.log('error',e.message);
				if(_DEBUG) { console.log('twitter statuses update error:', e); }
				if(typeof errback === 'function') { errback(e); }
			}
		});

	}

	
	//load_prefs();
	
	var twitter = {};
	
	ax.def(twitter)
		.method('connect', connect)
		.method('disconnect', disconnect)
		.method('timeline', timeline)
		.method('post', statuses_update)
		.method('upload', upload)
		.method('load_prefs', load_prefs)
		.method('user_home', function(userid){ return 'http://twitter.com/' + (userid||_prefs.screen_name); })
		.property('user_id', function(){ return _prefs.user_id;})
		.property('user_name', function(){ return _prefs.screen_name;})
		.property('is_connected', function(){ return !!_prefs.token && !!_prefs.token_secret; });
	
	ax.def(g).constant('twitter', twitter);

}(window));

