/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		_DEBUG = !!g._DEBUG,
		xxModule = {},
		queue = {},
		_tryCount = 6,
		db = {},
		_cacheDB = 'documents/download.json',
		_isNeedStoreDb = false,
		addFilesCallback,
		removeFilesCallback,
		_queueCheck;
	
	
	xx.fexplorer.readFile(_cacheDB, false, function(cache){
		db = JSON.parse(cache);
		if (_DEBUG) { console.log('download cache', db); }
	}, function(e){
		if (_DEBUG) { console.log('download cache err', e.message); }
	});
	
	function _queueCount(){
		var count = 0,
			tmp;
			
		for (tmp in queue) {
			if (queue.hasOwnProperty(tmp)) { 
				if(queue[tmp].progress) {
					count++;
				}
			}
		}
		return count;
	}

	function download(url, dir, filename, scb, ecb) {
		var path = dir + '/' + filename;
		
		var callback = function(){
			delete queue[filename];
			
			db[filename] = {path: '/appspresso/file/' + path};	// XXX: resolve 안하는게 속도는 빠른데...
			if (scb) { scb(db[filename].path); }
			
			_queueCheck();
			/*
			deviceapis.filesystem.resolve( 
				function(file){
					db[filename] = {path: file.toURI()};
					//document.body.innerHTML+= '<img src="' + file.toURI() + '">';
					if (scb) { scb(db[filename].path); }
					_queueCheck();
				}, function(e){
					console.log('resolve err:' + e.message);
				}, path,  "r"
			);
			*/
		};
		
		var errback = function(e){
			queue[filename].progress = undefined;
			if (_DEBUG) { console.log('xx.download err but it will be retrying:', e.message, queue[filename]); }
		};

        if (typeof queue[filename] !== 'undefined') {
            queue[filename].progress = ax.ext.net.download(url, path, callback, errback);
        } else {
            ax.ext.net.download(url, path, callback, ecb);
        }

	}
	
	_queueCheck = function() {
		// console.log('_queueCheck', _queueCount());
		var queueCount = _queueCount(),
			count = 0,
			key,
			item;
			
		for (key in queue) {
			if (queue.hasOwnProperty(key)) {
				item = queue[key];
				if(!item.progress) {
					// console.log('_queueCheck',item.url, item.dir, item.filename, item.scb, item.ecb);
					download(item.url, item.dir, item.filename, item.scb, item.ecb);
					count++;
					
					if (count >= 3) { return; }
				}
			}
		}
		
		if (queueCount === 0 && _isNeedStoreDb) {
			xx.fexplorer.writeFile(_cacheDB, JSON.stringify(db));
			if (addFilesCallback) { 
				addFilesCallback(); 
				addFilesCallback = undefined;
			}
			_isNeedStoreDb = false;
		}
	};

	function add(url, dir, filename, scb, ecb) {
		if (_DEBUG) { console.log('add', filename); }
		queue[filename] = {url: url, dir: dir, filename: filename, scb: scb, ecb: ecb, progress: undefined};
		_isNeedStoreDb = true;
		
		if (_queueCount() < _tryCount) {
			download(url, dir, filename, scb, ecb);
		}

	}
	
	function addFiles(arr, scb){
		var i,
			len;
		for(i=0, len=arr.length; i<len; i++){
			add(arr[i][0],arr[i][1],arr[i][2],arr[i][3],arr[i][4]);
		}
		addFilesCallback = scb;
	}
	
	function removeFiles(arr, scb) {
		var i,
			len = arr.length,
			chk = len,
			path;
		var callback = function() {
			
			chk--;
			if (chk === 0) {
				xx.fexplorer.writeFile(_cacheDB, JSON.stringify(db));
				if (removeFilesCallback) {
					removeFilesCallback();
					removeFilesCallback = undefined;
				}
			}
		};
		
		var errback = function(e) {
			if (_DEBUG) { console.log('deleteFile err', e.message); }
			callback();
		};
		
		for(i=0; i<len; i++){
			path = db[arr[i]].path;
			path = path.substring(17, path.length);
			
			xx.fexplorer.deleteFile(path, callback, errback);
			delete db[arr[i]];
		}
		removeFilesCallback = scb;
		
	}
	
	ax.def(xxModule)
		//.property('os', getOSVersion)
		.property('queue', function(){ return queue; })
		.property('db', function(){ return db; }, function(o){ db = o; })
		.method('add', add)
		.method('download', download)
		.method('addFiles', addFiles)
		.method('removeFiles', removeFiles);
	
	ax.def(xx).constant('download', xxModule);

// }catch(e){
	// alert('xx.download def err:' + e.message);
// }
}(window));
