/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function (g) {
	"use strict";
// try {

	var ax = g.ax,	// require('ax');
		xx = g.xx,
		_DEBUG = !!g._DEBUG,
		_module_name = 'xx_fexplorer.js';

	var currentPath,
		//parentPath = 'root',
		fileListElement,
		filePreviewElement,
		fileDetailElement,
		rootDir = [ "images", "videos", "music", "documents", "downloads", "wgt-package", "wgt-private", "wgt-private-tmp", "removable", "removable/DCIM", "removable/pud"],
		fileInfo = [],
		cachedHtml = '',
		iscroll = '',
		isInit = false;
	
	function _setCurrentPath(path) {
		currentPath = path;
	}
	
	function _getCurrentPath() {
		return currentPath;
	}

	function _getFolderIcon(dir){
		var icon = 'image/icon_folder.png';
	
		if(dir.indexOf('wgt-package')>=0){
			icon = 'image/icon_folder_lock.png';
		}
		return icon;
	}
	
	function _getRootList(){
		var html = '<li>Root:</li>',
			icon = '',
			i;
	
		try{
			for(i=0; i<rootDir.length; i++) {
				icon = _getFolderIcon(rootDir[i]);	// check readonly folder
				html += '<li class="list" targetFolder="' + rootDir[i] + '"><img class="ui-li-icon" src="' + icon  + '" />' + rootDir[i] + '</li>';
			}
			fileListElement.innerHTML = html;
			
			setTimeout(function(){
					iscroll.refresh();
				},500); 
		
		}catch(e){
			if (_DEBUG) { console.log(_module_name, '_getRootList err', e.message); }
		}
	}
	
	function successSubListCallback(files){
		var html,
			name = '',
			icon = '',
			i,
			depth = currentPath.lastIndexOf('/'),
			parentPath;
	
		if(depth > 0){
			parentPath = currentPath.substring(0,depth);
		} else {
			parentPath = 'root';
		}
		
		html = '<li class="backfolder" parentPath="' + parentPath + '">.. / ' + currentPath + '</li>';
	
		for(i=0; i<files.length; i++) { 
			name = files[i].name || ' ?? ';
	
			if(files[i].isDirectory){	
				icon = _getFolderIcon(currentPath + '/' + name);
				html += '<li class="list" targetFolder="' + currentPath + '/' + name + '"><img class="ui-li-icon" src="' + icon + '"/>' + name + '</li>';
			}else{
				html += '<li class="file" targetFile="' + i + '">' + name + '</li>';
			}
		} 
			
		if (i === 0) {
			html+= '<li>No file exists</li>';
		}

		fileInfo = files;

		fileListElement.innerHTML+= html;

		setTimeout(function(){
			iscroll.refresh();
		}, 400);

	}
	
	function getSubList(path){
		filePreviewElement.innerHTML = '';
		filePreviewElement.style.display = 'none';
		fileDetailElement.innerHTML = '';
		fileListElement.innerHTML = '';
		
		if (typeof path !== 'undefined'){
			if(path === 'root'){
				_getRootList();
				return;
			}else{
				currentPath = path;
			}
		} else if (currentPath === undefined) {
			_getRootList();
			return;
		}

		if (_DEBUG) { console.log(_module_name, 'getSubList ', currentPath); }

		var errorSubListCallback = function(error){
			if (_DEBUG) { console.log("getSubList error", error.message); }
		};	
	
		deviceapis.filesystem.resolve( 
			function(dir){ 
				dir.listFiles(successSubListCallback,errorSubListCallback); 
			}, function(e){ 
				alert(e.message); 
				_getRootList();
			}, currentPath,  "r" 
		); 
	}
		
	function _readAsText(str){
		alert(str);
	}
		

	function _readFile(idx){

		var file = fileInfo[idx],
			filetype = file.name,
			html = '';
		
		filetype = filetype.substring(filetype.lastIndexOf('.')+1,filetype.length);
		filetype = filetype.toUpperCase();
		
		
		switch(filetype){
			case 'MP3':
			case 'WAV':
				// html = '<audio src="' + file.toURI() + '" controls="controls" width="100%"></audio>';
				// filePreviewElement.style.display = 'block';
				// break;
			case '3GP':
			case 'MP4':
				html = '<video src="' + file.toURI() + '" controls="controls" width="100%"></video>';
				filePreviewElement.style.display = 'block';
				break;
			case 'XML':
			case 'HTML':
			case 'JS':
			case 'CSS':
			case 'TXT':
			case 'JSON':
				try{
					file.readAsText(_readAsText, function(e) {
						if (_DEBUG) { console.log(_module_name, 'file readAsText err', e.message); }
					}, "utf-8");
				}catch(e){
					//console.log(e.message);
				}
				break;
			case 'PNG':
			case 'JPG':
			case 'JPEG':
				html = '<img src="' + file.toURI() + '?' + (new Date().getTime()) +'" style="max-width: 300px;"/>';
				filePreviewElement.style.display = 'block';
				break;
			default:
				break;
		}
	
		filePreviewElement.innerHTML = html;
		
		setTimeout(function(){
			iscroll.refresh();
		}, 500);

	}
	
	
	function _getFileInfo(idx){
			
		var file = fileInfo[idx],
			html = '',
			parentPath;
		
		try{
			parentPath = file.path.substring(0,file.path.lastIndexOf('/'));
	
			cachedHtml = fileListElement.innerHTML;

			html+= '<li class="backfolder" parentPath="' + parentPath + '">.. / ' + file.path + ' </li>';
			
			html+= '<li><h3>' + file.name + '</h3>';
			html+= '<p>URI: <em>' + file.toURI() + '</em><br/>';
			html+= 'Parent dir: <em>' + file.parent.name + '</em><br/>'; 
			html+= 'Readonly: <em>' + file.readOnly + '</em><br/>';
			html+= 'Created: <em>' + file.created + '</em><br/>';
			html+= 'Modified: <em>' + file.modified + '</em><br/>';
			html+= 'Path: <em>' + file.path + '</em><br/>';			
			html+= 'Path(full): <em>' + file.fullPath + '</em><br/>';
			html+= 'Size: <em>' + file.fileSize + '</em><br/>';
			html+= 'Length: <em>' + file.length + '</em><br/>';
			html+= '</li>';
			
			fileListElement.innerHTML = html;
		
			
			html = '<li class="read" targetFile="' + idx + '">View file</li>';
			html+= '<li class="delete" targetFile="' + idx + '" parentPath="' + parentPath + '">Delete file</li>';
			//html+= '<li data-icon="alert"><a href="#not-supported">Edit file</a></li>';
			
			fileDetailElement.innerHTML = html;
			
			setTimeout(function(){
				iscroll.refresh();	
			}, 500);
			
	
		}catch(e){
			if (_DEBUG) { console.log(_module_name, 'getFileInfo err:', e.message); }
		}	
		
	}

	/**
	 * 파일 쓰기 매소드 
	 *
	 * @name writeFile
	 * @property {string} path 저장될 파일명을 포함한 풀 경로
	 * @property {string} text 저장할 텍스트
	 * @property {boolean} base64 여부. default false
	 * @property {function} scb success callback
	 * @property {function} ecb error callback
	 * @memberOf xx.fexplorer
	 */
	function writeFile(path, text, isBase64, scb, ecb) {
		if (!ax.util.isValidPath(path)) {
			ecb(new Error('invalid file path:' + path));
			return;
		}

		var pos = path.lastIndexOf('/'),
			folder = path.substring(0, pos),
			filename = path.substring(pos + 1, path.length);
		
		if (_DEBUG) { console.log(_module_name, 'writeFile', folder, filename); }

		var writeStream = function(stream){
			if (isBase64) {
				stream.writeBase64(text.toString());
			} else {
				if (_DEBUG) { console.log(_module_name, 'write text:', text); }
				stream.write(text.toString());
			}
			stream.close();
			if (scb) { scb(); }
		};

		deviceapis.filesystem.resolve( 
			function(dir){
				dir.listFiles(function(files){
					var i=0, len = files.length, f;
					for(i=0; i<len; i++) {
						f = files[i];
						if (f.name === filename) {
							f.openStream(writeStream, ecb, "w", "utf-8");
							return;
						}
					}
					var newFile = dir.createFile(filename); 
					newFile.openStream(writeStream, ecb, "w", "utf-8");
				}, ecb); 
			}, ecb, folder,  'rw' 
		); 
	}

	function createDirectory(dir, scb, ecb) {
		if (!ax.util.isValidPath(dir)) {
			if (ecb) { ecb(new Error('invalid file path:' + dir)); }
			return;
		}
		if (dir.lastIndexOf('/') === dir.length - 1) {
			dir = dir.substring(0,dir.length - 1);
		}
		var pos = dir.indexOf('/'),
		folder = dir.substring(0, pos),
		filename = dir.substring(pos + 1, dir.length);

		if (_DEBUG) { console.log(_module_name, 'createDirectory', folder, filename); }

		deviceapis.filesystem.resolve(function(dir){
				try{
					dir.createDirectory(filename); 
					if (scb) { scb('success'); }
				}catch(e){
					if (e.code && e.code === 100) { scb(); return; }
					if (ecb) { ecb(e); }
				}
			}, function(e){
				if (_DEBUG) { console.log(_module_name, 'createDirectory err:', e.message); }
				if (ecb) { ecb(e); }
			}, folder, 'rw'
		); 
	}
	
	function copy(sourceDir, targetDir, scb, ecb, isMove) {
		if (!ax.util.isValidPath(sourceDir)) {
			ecb(new Error('invalid file path:' + sourceDir));
			return;
		}
		
		if (sourceDir.lastIndexOf('/') === sourceDir.length - 1) {
			sourceDir = sourceDir.substring(0, sourceDir.length - 1);
		}
		
		var pos = sourceDir.lastIndexOf('/'),
		folder = sourceDir.substring(0, pos);
		
		deviceapis.filesystem.resolve( 
			function(dir){
				if (isMove) {
					dir.moveTo(scb, ecb, sourceDir, targetDir, true);
				} else {
					dir.copyTo(scb, ecb, sourceDir, targetDir, true);
				}
			}, ecb, folder,  'r' 
		); 
	}

	function move(sourceDir, targetDir, scb, ecb) {
		copy(sourceDir, targetDir, scb, ecb, true);
	}
	
	function _delete(file, dir, scb, ecb) {
		if (file.isDirectory) {
			dir.deleteDirectory(function(){
					if (_DEBUG) { console.log('xx_fexplorer.js', file.fullPath, 'Directory deleted'); }
					if (scb) { scb(); }
				}, function(e) {
					if (_DEBUG) { console.log('xx_fexplorer.js', file.fullPath, 'Directory delete err', e.message); }
					if (ecb) { ecb(); }
				}, 
				file.fullPath,
				true
			); 
		} else {
			dir.deleteFile(function(){ 
					if (_DEBUG) { console.log('xx_fexplorer.js', file.fullPath, 'File deleted'); }
					if (scb) { scb(); }
				}, function(e) { 
					if (_DEBUG) { console.log('xx_fexplorer.js', file.fullPath, 'File delete err', e.message); } 
					if (ecb) { ecb(); }
				},
				file.fullPath
			);
		}
	}
	
	/**
	 * 파일 삭제 매소드 
	 *
	 * @name deleteFile
	 * @property {string} dir 삭제할 파일명을 제외한 경로
	 * @property {string} filename 삭제할 파일 명. 전체 파일 삭제는 "*", 폴더 전체 삭제는 undefined
	 * @property {function} scb success callback
	 * @property {function} ecb error callback
	 * @memberOf xx.fexplorer
	 */
	function deleteFile(dir, scb, ecb) {
		if (!ax.util.isValidPath(dir)) {
			ecb(new Error('invalid file path:' + dir));
			return;
		}
		
		if (dir.lastIndexOf('/') === dir.length - 1) {
			dir = dir.substring(0,dir.length - 1);
		}
		
		var pos = dir.lastIndexOf('/'),
		folder = dir.substring(0, pos),
		filename = dir.substring(pos + 1, dir.length);
		
		
		console.log('deleteFile', folder, filename);
		
		deviceapis.filesystem.resolve( 
			function(dir){

				dir.listFiles(function(files){
					var i, len=files.length;
					for(i=0; i < len; i++) { 
						 if (files[i].name === filename) {
							 _delete(files[i], dir, scb, ecb);
							 //scb();
							 return;
						 }
					 }
					
					ecb({code:'000',message:'file does not exists'});
				}, ecb); 

			}, ecb, folder,  'rw' 
		); 
	}
	
	/**
	 * 
	 * image 파일을 오픈한 경우 isBase64를 true로 설정해야하고,
	 * <img src="data:image/jpeg;base64, + 내용 처럼 이미지 테그를 생성한다.
	 */
	function readFile(dir, isBase64, scb, ecb) {
		if (!ax.util.isValidPath(dir)) {
			ecb(new Error('invalid file path:' + dir));
			return;
		}
		
		if (dir.lastIndexOf('/') === dir.length - 1) {
			dir = dir.substring(0,dir.length - 1);
		}
		
		var pos = dir.lastIndexOf('/'),
		folder = dir.substring(0, pos),
		filename = dir.substring(pos + 1, dir.length);

		if (_DEBUG) { console.log(_module_name, 'readFile', folder, filename); }
		
		deviceapis.filesystem.resolve( 
			function(dir){
				
				dir.listFiles(function(files){
					var i, len=files.length;
					
					var scbList = function(fs) {
						if (isBase64) {
							scb(fs.readBase64(files[i].fileSize));
						} else {
							scb(fs.read(files[i].fileSize));  
						}
						fs.close();
					};
					
					var ecbList = function(e) {
						if (_DEBUG) { console.log('xx_fexplorer.js', files[i].fullPath , 'read err:', e.message); }
					};
					
					for(i=0; i < len; i++) { 
						if (files[i].name === filename) {
							files[i].openStream(scbList, ecbList, "r", "UTF-8");
							return;
						}
					}
					ecb(new Error('file does not exists:' + folder + '/' + filename));
				}, ecb);

			}, ecb, folder, 'r'
		); 
	}
	
	
	function dir(targetDir, scb, ecb) {
		if (!ax.util.isValidPath(targetDir)) {
			if (ecb) { ecb(new Error('invalid file path:' + targetDir)); }
			return;
		}
		
		if (targetDir.lastIndexOf('/') === targetDir.length - 1) {
			targetDir = targetDir.substring(0,targetDir.length - 1);
		}
		
		deviceapis.filesystem.resolve(function(dir){
			var tmp = [];
			dir.listFiles(function(files) {
				var i,
					len;
					
				for(i=0, len=files.length; i < len; i++) { 
					tmp.push(files[i].name);
				}
				if (scb) { scb(tmp); }
			}, ecb);
		}, ecb, targetDir, 'r');
	}
	
	function _onTouchEnd(e){
		var target = e.target,
			i=4,
			className;
		
		while(i--) {
			if(target.tagName === 'LI') { break; }
			target = target.parentNode;
		}
		
		className = target.className;
		if (className !== '') { target.style.backgroundColor = '#ddd'; }
		
		setTimeout(function(){
			try{
				target.style.backgroundColor = '';
				switch (className){
				case 'backfolder':
					if (_DEBUG) { console.log(_module_name, 'target.getAttribute(parentPath)', target.getAttribute('parentPath')); }
					getSubList(target.getAttribute('parentPath'));
					break;
				case 'list':
					getSubList(target.getAttribute('targetFolder'));
					break;
				case 'file':
					_getFileInfo(target.getAttribute('targetFile'));
					break;
				case 'read':
					_readFile(target.getAttribute('targetFile'));
					break;
				case 'delete':
					var file = fileInfo[target.getAttribute('targetFile')],
						parentPath = target.getAttribute('parentPath');

					deleteFile(file.fullPath, function(){
						getSubList(parentPath);
					});
					break;
				}

			}catch(e){
				if (_DEBUG) { console.log(_module_name, '_onTouchEnd err', e.message); }
			}
	
		}, 200);
	}
	
	function init(arg) {
		if (isInit) { return; }
		if (navigator.userAgent.match(/iPad|iPhone|iPod/)) {
			rootDir.pop(); // IOS doesn't support removable dir
			rootDir.pop(); // IOS doesn't support removable/DCIM dir
		}

		fileListElement = arg.fileListElement || document.getElementById('file_list');
		filePreviewElement = arg.filePreviewElement || document.getElementById('file_preview');
		fileDetailElement = arg.fileDetailElement || document.getElementById('file_detail');

		iscroll = xx.scroll.addScroll({
			wrapperId: arg.wrapperId || 'wrapperFileExplorer', 
			onTouchEnd: _onTouchEnd,
			useQuickScroll: arg.useQuickScroll || false
		});
		isInit = true;
	}
	
	var oFileExplorer = {};

	ax.def(oFileExplorer)
		.property('currentPath', _getCurrentPath, _setCurrentPath)
		.method('init', init)
		.method('writeFile', writeFile)
		.method('readFile', readFile)
		.method('deleteFile', deleteFile)
		.method('copy', copy)
		.method('move', move)
		.method('dir', dir)
		.method('createDirectory', createDirectory)
		.method('getSubList', getSubList);
	
	ax.def(g.xx).constant('fexplorer', oFileExplorer);

// }catch(e){
	// console.log('xx_fexplorer.js init err:', e.message); 
// }
}(window));
