/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
	
(function(g){
	"use strict";
// try{
	
	var ax = g.ax,	// require('ax');
		_DEBUG = !!g._DEBUG,
		oPage = {},
		pages = {},
		zIndex = 100,
		history = [],
		loadingPage,
		isToggleMenu = false,
		useAdmob = false,
		admobHeight = 42,	// admob 사용시 iscroll wrapper 사이즈를 줄여주기 위함.
		menuPosition,	// number
		verticalHidePosition,	// number
		horizontalHidePosition,		// number
		screenWidth = g.innerWidth,	// number
		screenHeight = g.innerHeight,	// number
		wrapperHeight,	// wrapper 사이즈 = screenHeight - fht - 헤더바 사이즈
		platform = 'unknown',	// ios || android
		os = 'unknown',	// OS version
		model = 'unknown',	// 단말모델
		useTransition = true,
		animationScale = 0.1,
		animationTime = 300,
		animationType = 'slide',
		body,				// document.body
		pageMenuCloseArea,	// DOM Element
		pageMenu,			// DOM Element
		agent = navigator.userAgent,
		onPageLoadGlobal,
		_lang;
	
	ax.ext.ui.isWebView = false;
	ax.ext.ui.removeWebView();

	if (/(iPad|iPhone|iPod)/i.test(agent)) {
		platform = 'ios';
	} else {
		platform = 'android';
		animationType = 'fade';
		//if (g.outerWidth > 480) { useTransition = false; }	// XXX: 옵티머스LTE등 고해상도 단말에서 넘 버벅임 ㅠㅠ
	}
	
	if (/(Android 4)/i.test(agent)) {
		os = 'ics';
	}
	
	deviceapis.devicestatus.getPropertyValue( 
			function (value) { os = value; },  
			function () {
				if (platform === 'ios') {
					os = navigator.userAgent.split(/\s*[;)(]\s*/)[2];
				}
			}, 
			{ aspect: "Device", property : "version"} ); 
	
	deviceapis.devicestatus.getPropertyValue(
		function (value) { model = value; },
		function () { model = 'unknown';}, 
		{ aspect: "Device", property : "model"});

	function _getPrePage() {
		return history[history.length -2];
	}
	
	function _getWrapperHeight() { 
		wrapperHeight = useAdmob ? (g.innerHeight - admobHeight - admobHeight) : g.innerHeight - admobHeight;
		//console.log('wrapperHeight', wrapperHeight);
		return wrapperHeight;
	}
	
	function init(opt){
		if (!opt.mainPageId || !opt.menuId) {
			if (_DEBUG) { console.log('xx page init failed; mainPageId reauired'); }
			return;
		}
		
		if (opt.animationType) { animationType = opt.animationType; }
		
		onPageLoadGlobal = opt.onPageLoad || function(){};
		
		if(platform === 'android') {
			admobHeight = (screenWidth * 42 / 320);
		} else {
			admobHeight = 42;
		}
		
		menuPosition = opt.menuPosition || screenWidth - (screenWidth * 50 / 320);
		verticalHidePosition = opt.verticalHidePosition || screenHeight;
		horizontalHidePosition = opt.horizontalHidePosition || screenWidth;
		useAdmob = opt.useAdmob || false;
		_getWrapperHeight();
		
		history.push(opt.mainPageId);
		
		body = g.document.body;
		
		// XXX: 옵티머스 블랙(android 2.2x) 에서 화면이 스크롤되는 증상 방지를 위한 wrapper 정의. - althjs
		// document.width가 hidden 된 영역까지 포함하여 설정됨. bodyWrapper의 position 을 relative 하게 설정 함
		// 참고: http://stackoverflow.com/questions/3970455/overflow-hidden-not-working
		//		If you are trying to hide absolute positioned elements make sure the container of those absolute positioned elements is relatively positioned.
		var bodyWrapper = body.querySelector('.bodyWrapper');
		bodyWrapper.style.height = '100%'; //screenHeight + 'px';
		bodyWrapper.style.width = '100%'; //screenWidth + 'px';
		bodyWrapper.style.overflow = 'hidden';
		bodyWrapper.style.position = 'absolute';
		
		if (opt.menuId) {
			pageMenu = body.querySelector('#' + opt.menuId);
			pageMenu.info = {isShown: true};
			pageMenuCloseArea = body.querySelector('.pageMenuCloseArea');
			pageMenuCloseArea.style.height = screenHeight + 'px';
			pageMenuCloseArea.style.left = (screenWidth - (screenWidth * 50 / 320)) + 'px';
			pageMenuCloseArea.style.width = (screenWidth * 50 / 320) + 'px';
			setTimeout(function(){
				pageMenu.style.width = (screenWidth - (screenWidth * 50 / 320)) + 'px';
				pageMenu.style.left = 0;
			}, 200);
		}
		
		if (opt.lang) {
			_lang = opt.lang;
		}

	}
	
	function _getToggleMenu(){
		return isToggleMenu;
	}
	
	function currentPage(){
		if (isToggleMenu) {
			return 'menu';
		} else {
			return history[history.length -1];
		}
	}
	
	//TODO: should deprecate 
	function _getAdmob(){
		return useAdmob;
	}
	
	//TODO: should deprecate
	function _setAdmob(use){
		
		if (use !== true && use !== false) { return; }
		
		useAdmob = use;
		_getWrapperHeight();

		var el,
			pageId,
			wrappers,
			i,
			len,
			ids = [];
		
		for (pageId in pages){
			if (pages.hasOwnProperty(pageId)) {
				el = pages[pageId];
	
				el.style['-webkit-transition-duration'] = '0';
				el.style.height = use ? (screenHeight - admobHeight) + 'px' : (screenHeight) + 'px';
				
				ids.push(pageId);
			}
		}
		
		var reset = function() {
			for (i=0, len=ids.length; i<len; i++) {
				pageId = ids[i];
				el = pages[pageId];
				el.style['-webkit-transition-duration'] = '0.2s';
			}
		};
		setTimeout(reset, 20);
		
		// XXX: current page's iscroll refresh...
		pageId = currentPage();
		wrappers = this[pageId].querySelectorAll('.wrapper');
		
		var refresh = function(pageId) {
			setTimeout(function(){
				g.xx.scroll[pageId].refresh();
			}, 500);
		};
		
		for (i=0, len = wrappers.length; i < len; i++){
			pageId = wrappers[i].id;
			
			if (g.xx.scroll[pageId]) {
				refresh(pageId);
			}
		}

	}
	
	function _menuShow() {
		this.style.left = menuPosition + 'px';
	}
	
	function _menuHide() {
		this.style.left = 0;
	}
	
	function show(callback){
		var arg = this.info,
			self = this,
			prePageId = history[history.length -1];
		
		if(prePageId === arg.id) {
			self.style.top = 0;
			self.style.left = 0;
			self.style.display = 'block';
			return;
		}
		history.push(arg.id);
		loadingPage = arg.id;
		if (_DEBUG) { console.log('XXX 같은페이지가 두번나오면 안됨...',loadingPage); }
		pages[prePageId].info.isShown = false;

		var aftercb = function(){
			
			loadingPage = undefined;
			self.style.zIndex = ++zIndex;
			self.style.display = 'block';
		
			setTimeout(function(){
				
				if (animationType === 'slide') {
					if(arg.type === 'vertical'){
						if (useTransition === false) {
							$(self).animate({top:0}, animationTime);
						} else {
							self.style.top = 0;
						}
					}else{
						if (useTransition === false) {
							$(self).animate({left:0}, animationTime);
						} else {
							self.style.left = 0;	
						}
						
					}
				} else {
					if (useTransition === false) {
						$(self).animate({opacity:1}, animationTime);
					} else {
						$(self).css({opacity:1, '-webkit-transform': 'scale(1)'});
					}
				}
				
				setTimeout(function(){
					try {
						arg.isShown = true;
						
						var prePage = _getPrePage();
						if (prePage) { pages[prePage].style.display = 'none'; }
	
						if (_DEBUG) { console.log('PAGE callback', arg.id); }
						if (callback) { callback.call(self); }
						if (_DEBUG) { console.log('PAGE callback onPageLoad', arg.id, arg.onPageLoad); }
						if (arg.onPageLoad) { arg.onPageLoad.call(self); }
						if (_DEBUG) { console.log('PAGE callback onPageLoadGlobal', arg.id); }
						onPageLoadGlobal.call(self);
					} catch(e) {
						if (_DEBUG) { console.debug('XX.PAGE AFTER CALLBACK ERR:', e.message); }
					}
					
				},animationTime);
			}, 100);
		};

		if (this.innerHTML === '') {
			var loadContentCallback = function(){
				setTimeout(function(){
					if (arg.onPageBeforeLoadForInit && arg.isInit === false) {
						if (_DEBUG) { console.log('onPageBeforeLoadForInit ------------------------', arg.id); }
						arg.onPageBeforeLoadForInit.apply(self);
						arg.isInit = true;
						
						setTimeout(function(){
							aftercb();
						},100);
					} else {
						if(arg.onPageBeforeLoad) {
							arg.onPageBeforeLoad();
							
							setTimeout(function(){
								aftercb();
							},100);
						} else {
							aftercb();
						}
					}
				}, 100);
			};
			
			var targetHTML = arg.id + '.html?' + (new Date().getTime());
			if (arg.useLocale === true) {
				targetHTML = 'locales/' + _lang + '/' + targetHTML;
			}
			
			if (_DEBUG) { console.log('$ajax ', targetHTML); }
			
			$.ajax({
				  url: targetHTML,
				  context: body
				}).done(function(data) {
					//console.log(data);
					//self.innerHTML = data;
					$(self).html(data).after(function(){
						loadContentCallback();
					});
					
				});

		} else {
			if (arg.onPageBeforeLoadForInit && arg.isInit === false) {
				if (_DEBUG) { console.log('onPageBeforeLoadForInit ------------------------', arg.id); }
				arg.onPageBeforeLoadForInit.apply(self);
				arg.isInit = true;
				
				setTimeout(function(){
					aftercb();
				},200);
			} else {
				if(arg.onPageBeforeLoad) {
					arg.onPageBeforeLoad();
					setTimeout(function(){
						aftercb();
					},100);
				} else {
					aftercb();
				}
			}
		}

	}
	
	function hide(callback){
		var arg = this.info,
			self = this,
			prePageId = history[history.length -1],
			i,
			len;
		
		pages[prePageId].info.isShown = true;

		if (arg.onPageBeforeHide) {
			arg.onPageBeforeHide();
		}
		
		this.info.isShown = false;
		
		for (i=0, len=history.length; i<len; i++) {
			if (history[i] === arg.id) {
				history.splice(i,1);
				break;
			}
		}
		
		if (animationType === 'slide') {
			if(arg.type === 'vertical'){
				if (useTransition === false) {
					$(self).animate({top:verticalHidePosition+'px'}, animationTime);
				} else {
					self.style.top = verticalHidePosition + 'px';	
				}
				
			}else if (arg.type === 'horizontal') {
				if (useTransition === false) {
					$(self).animate({left:horizontalHidePosition+'px'}, animationTime);
				} else {
					self.style.left = horizontalHidePosition + 'px';	
				}
			} // else if (arg.type === 'none') {}
		} else {
			if (useTransition === false) {
				$(self).animate({opacity: 0}, animationTime);
			} else {
				if (arg.type !== 'none') {
					$(self).css({opacity: 0, '-webkit-transform': 'scale(' + animationScale + ')'});
				}
			}
		}
		

		setTimeout(function(){
			self.style.display = 'none';
			self.style.zIndex = 1;
			
			if (callback) { callback.call(self); }
			if (arg.onPageHide) { arg.onPageHide.call(self); }
		}, animationTime);

	}
	
	function back(){
		if(history.length > 1){
			var pageNameCurrent = history[history.length-1],
				pageNamePre = history[history.length-2];
			
			if (pageMenu) { pageMenu.style.zIndex = 0; }
			
			history.pop();
			pages[pageNamePre].style.display = 'block';

			if(pages[pageNamePre].info.onPageLoad) { pages[pageNamePre].info.onPageLoad(); }
			
			pages[pageNameCurrent].hide();
			
			try{
				onPageLoadGlobal.call(pages[pageNamePre]);
			}catch(e){
				console.debug('XX.PAGE BACK() ERR', e.message);
			}
			
		}
	}
	
	/*
	function onMenuSelect(callback){
		var arg = this.info,
			self = this,
			prePageId = history[history.length -1];
		
		if(prePageId !== arg.id){
			
			//pages[prePageId].hide();
			pages[prePageId].style.display = 'none';
			pages[prePageId].style.left = '0';
			if(pages[prePageId].info.onPageHide) pages[prePageId].info.onPageHide();
			
			history.push(arg.id);
			console.log('onMenuSelect', arg.id, history);
		
			this.style['-webkit-transition-duration'] = '0';
			
			if(arg.type === 'vertical'){
				this.style.top = 0;	
			}else{
				this.style.left = 0;	
			}
			
			this.style.display = 'block';
			this.style.zIndex = ++zIndex;
			this.info.isShown = true;
			
		}
		
		toggleMenu();
		
		setTimeout(function(){	
			self.style['-webkit-transition-duration'] = '';
			if(callback) callback();
			if(self.info.onPageLoad) self.info.onPageLoad();
		}, 400);
	}
	*/

	
	function toggleMenu(){
		var page = pages[history[history.length-1]],
			pagePre = pages[history[history.length - 2]];

		if(isToggleMenu){
			isToggleMenu = false;
			page._menuHide();
			pageMenuCloseArea.style.display = 'none';
			
			setTimeout(function(){
				pageMenu.style.display = 'none';
			}, animationTime);
		}else{
			pageMenu.style.display = 'block';
			if (pagePre) { pagePre.style.display = 'none'; }
			isToggleMenu = true;
			page._menuShow();
			pageMenuCloseArea.style.display = 'block';
		}
	}
	
	function setAnimationType(type) {
		var el,
			arg,
			curPage = currentPage(),
			pageId;
		
		animationType = type;
		
		if (animationType === 'slide') {
			for (pageId in pages){
				if (pages.hasOwnProperty(pageId)) {
					el = pages[pageId];
					arg = el.info;
					
					if (pageId !== curPage) {
						if(arg.type === 'vertical'){
							el.style.top = verticalHidePosition + 'px';
						} else if (arg.type === 'horizontal') {
							el.style.left = horizontalHidePosition + 'px';
						}
					}
					if (arg.type !== 'main') { $(el).css({opacity: '', '-webkit-transform': 'none'}); }
				}
			}
		} else {
			for (pageId in pages){
				if (pages.hasOwnProperty(pageId)) {
					el = pages[pageId];
					arg = el.info;
					$(el).css({top:'', left: ''});
					
					if (pageId !== curPage) {
						if(arg.type !== 'main') { $(el).css({opacity:0, '-webkit-transform': 'scale(' + animationScale + ')'}); }
					}
				}
			}
		}
	}

	function add(arg, ownerArray){
		try{
		
			var el = body.querySelector('#' + arg.id);	// page element
			
			el.hide = hide;
			el.show = show;
			el._menuShow = _menuShow;
			el._menuHide = _menuHide;
			
			arg.type = arg.type || 'horizontal';
			arg.isInit = false;
			arg.isShown = (arg.type === 'main') ? true : false;
		
			//console.log(id, el.arg.type);
			if (animationType === 'slide') {
				if(arg.type === 'vertical'){
					el.style.top = verticalHidePosition + 'px';
				} else if (arg.type === 'horizontal') {
					el.style.left = horizontalHidePosition + 'px';
				} else if (arg.type === 'none') {
					el.style.left = 0;
					el.style.top = 0;
				}
				
				if(arg.type !== 'main') { $(el).css({opacity: '', '-webkit-transform': 'none'}); }
			} else {
				if(arg.type !== 'main' && arg.type !== 'none') {
					
					if (useTransition === false) {
						$(el).css({opacity:0});
					} else {
						$(el).css({opacity:0, '-webkit-transform': 'scale(' + animationScale + ')'});
					}
					 
				}
			}
			
			if (useAdmob) {
				el.style.height = (screenHeight - 49) + 'px';	// admob 사용시 wrapper 사이즈를 49px 줄임.
			}

			el.style.zIndex = 10;
			el.info = arg;
			
			pages[arg.id] = el;

			if (ownerArray) { ownerArray[arg.id] = el; }
			oPage[arg.id] = el;
			
		}catch(e){
			console.log('add page(' + arg.id + ') err', e.message);
		}
		
		return this;
	}
	
	ax.def(oPage)
		.constant('history', history)
		.constant('screenWidth', screenWidth)
		.constant('screenHeight', screenHeight)
		.constant('pixelRatio', g.devicePixelRatio)
		.constant('platform', platform)
		.property('loadingPage', function() { return loadingPage; })
		.property('os', function() { return os; })
		.property('model', function() { return model; })
		.property('admobHeight', function(){ return admobHeight; })
		.property('wrapperHeight', _getWrapperHeight)
		.property('useAdmob', _getAdmob, _setAdmob)
		.property('isToggleMenu', _getToggleMenu)
		.property('useTransition', function(){ return useTransition; }, function(use){ useTransition = use; })
		.property('prePage', _getPrePage)
		.property('lang', function() { return _lang; })
		.method('add', add)
		.method('init', init)
		.method('back', back)
		.method('toggleMenu', toggleMenu)
		.method('currentPage', currentPage)
		.method('setAnimationType', setAnimationType);

	if (!g.xx) {
		ax.def(g).constant('xx', {});	
	}
	ax.def(g.xx).constant('page', oPage);

// }catch(e){
	// console.log('xx_page.js def err:', e.message);
// }
}(window));
