/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax, // require('ax');
		xx = g.xx,
		_DEBUG = !!g._DEBUG,
		oScroll = {},
		body, // window.document.body;
		touchTime,
		isScrolling = false,
		touchStart,
		scrollTime,
		quick_scroll_icon_height = 48,
		quick_scroll_interval_id = null,
		quick_scroll_btn,
		isTouchEvent = true;
	

	// XXX: iscroll을 뜯어고쳐야하나? 리스트에서 아이템 선택 반응 최적화를 위함 - althjs
	g.document.addEventListener('DOMContentLoaded', function(){
		if (typeof document.body.ontouchstart === 'undefined' ) { isTouchEvent = false; }
		
		body = g.document.body;
		body.addEventListener(isTouchEvent ? 'touchstart' : 'mousedown', function(e){
			touchStart = new Date().getTime();
		}, false);
		
		body.addEventListener(isTouchEvent ? 'touchmove' : 'mousemove', function(e){
			if (isTouchEvent) { isScrolling = true; }
		}, false);
		
		body.addEventListener(isTouchEvent ? 'touchend' : 'mouseup', function(e){
			isScrolling = false;
		}, false);
	});
	
	function stopQuickBarMoving(){
		clearInterval(quick_scroll_interval_id);
		quick_scroll_interval_id = null;
	}
	
	function getTime(){
		var items = this.wrapper.querySelectorAll('.fbtl li'),
			top = -this.y,
			i,
			len,
			tmp;
		
		for (i=0, len=items.length; i<len; i++) {
			tmp = items[i];
			
			if (tmp.offsetTop > top && tmp.offsetTop < top + this.wrapperH){
				tmp = tmp.querySelector('.ts').innerHTML;
				
				var a = new Date();
				a.setISO8601(tmp);
				a.setTime(a.getHours(), a.getMinutes());
				return;
			} 
		}
	}
	
	function startQuickBarMoving(){
		if (quick_scroll_interval_id) { return; }
		
		var sc = this;
		var target = quick_scroll_btn;

		
		var move = function(){
			try{

				var wrapperH = sc.wrapperH,
					scrollerH = sc.scrollerH,
					y = sc.y,
					posY = wrapperH * (-y) / scrollerH + sc.wrapperOffsetTop;
				
				
				if (posY + quick_scroll_icon_height > window.innerHeight) {
					
					posY = wrapperH +  sc.wrapperOffsetTop - quick_scroll_icon_height;
				}
				//getTime.apply(sc);
				
				sc.args.quick_scroll_position = posY;
				target.style.top = posY + 'px'; 

				var tmp = new Date().getTime();
			
				if (xx.scroll.scrollTime + 2000 < tmp) {
					target.style.opacity = 0;
					stopQuickBarMoving();
				} 
			}catch(e){
				ax.log(e.message);
			}
		};
		quick_scroll_interval_id = setInterval(move, 300); 
		
	}
		
	function resetQuickScrollPosition() {

		var sc = this;

		quick_scroll_btn.style['-webkit-transition-duration'] = '0';
		quick_scroll_btn.style.opacity = 0;
		quick_scroll_btn.style.top = (sc.args.quick_scroll_position || sc.wrapperOffsetTop) + 'px';

	}

	function setQuickScroll(){
		var sc = this,
			wrapperH = sc.wrapperH,
			scrollerH = sc.scrollerH,
			y,
			posY;
		

		resetQuickScrollPosition.apply(this);
		
		stopQuickBarMoving();
		
		setTimeout(function(){
			quick_scroll_btn.style['-webkit-transition-duration'] = '0.6s';
		}, 200);

		var ontouchstart = function(e){
			stopQuickBarMoving();
			quick_scroll_btn.style['-webkit-transition-duration'] = '0';
			sc.options.bounce = false;	
		};
		
		var ontouchend = function(e){
			quick_scroll_btn.style['-webkit-transition-duration'] = '0.6s';
			sc.options.bounce = true;	
			
			setTimeout(function(){
				quick_scroll_btn.style.opacity = 0;
			},2000);
			
			
		};
		
		var ontouchmove = function(e){
			try{
				quick_scroll_btn.style.opacity = 1;
				e.preventDefault();
				y = e.touches[0].screenY;
			
				if (y > window.innerHeight - 50) {
					sc.scrollTo(0, sc.maxScrollY, 0);
					quick_scroll_btn.style.top = (wrapperH + sc.wrapperOffsetTop - quick_scroll_icon_height) + 'px';
					return;
				} else if (y < sc.wrapperOffsetTop) {
					sc.scrollTo(0, 0, 0);
					quick_scroll_btn.style.top = sc.wrapperOffsetTop  + 'px';
					return;
				}
					
				posY =  (y - sc.wrapperOffsetTop) * scrollerH / wrapperH;
				
				sc.scrollTo(0, -posY, 0);
				quick_scroll_btn.style.top = y + 'px';
				sc.args.quick_scroll_position = y;
				
				e.stopPropagation();

			} catch (err) {
				if (_DEBUG) { console.log('button err:', err.message); }
			}
		};

		quick_scroll_btn.ontouchstart = ontouchstart;
		quick_scroll_btn.ontouchend = ontouchend;
		quick_scroll_btn.ontouchmove = ontouchmove;

	}
	
	
	function loadLazyImages(){
		if (_DEBUG) { console.log('loadLazyImages ============== '); }
		try{
			var args = this.args,
				self = this,
				flag = false;
			
			var imgs = args.lazyImages,
				top = this.y,
				height = this.wrapperH,
				imgTop,
				src,
				i,
				len;

			for(i=0, len=imgs.length; i<len; i++) {
				if(imgs[i] !== false) {
					imgTop = imgs[i].offsetTop + top;
	
					if(imgTop < height && imgTop > -70) {
						
						src = $(imgs[i]).attr('data-original');
						
						if (!!src) {
							$(imgs[i]).attr('data-original', '');
							imgs[i] = false;
							
							//if(src !== imgs[i].src) ax.log(i, imgTop, src);
							
							imgs[i].src = src;
							flag = true;
						}
					}
				}
				
			}
			this.args.lazyImages = imgs;
			
			if (flag === true) {
				if (_DEBUG) { console.log('refresh'); }
				setTimeout(function(){
					self.refresh();
					flag = false;
				}, 1000);
			}
		}catch(e){
			// XXX: error occurred when the first time 
			// ax.log('loadLazyImages', e.message);
		}
	}
	
	
	/* XXX: needs zepto 
	function refreshSwipeEvent(){
		ax.log('refreshSwipeEvent');
		
		$('.theList li').unbind('swipeLeft');
		$('.theList li').unbind('swipeRight');

		$('.theList li').swipeRight(function(e){
			//ax.log('SWIPE Left >>' , e.target.innerHTML);
			if(e.target.querySelector('.btnDelete') == null){
				e.target.innerHTML+= '<div class="btnDelete"><button>Delete</button></div>';
			}
			
		});
		
		$('.theList li').swipeLeft(function(e){
			//ax.log('SWIPE Right >>' , e.target.innerHTML);
			
			var btn = e.target.querySelector('.btnDelete');
			if(btn) btn.parentNode.removeChild(btn);
		
		});
	}
	*/
	
	function onScrollMove(){
		var args = this.args;

		
		try{

		if (args.useUpdateDown === true) {
			if(this.y > 5 && !args.pullDownEl.className.match('flip')) {
				args.pullDownEl.className = 'pullDown flip';
				//args.pullDownLabel.innerHTML = 'Release to refresh...';
				this.minScrollY = 0;
			} else if(this.y < 5 && args.pullDownEl.className.match('flip')) {
				args.pullDownEl.className = 'pullDown';
				args.pullDownLabel.innerHTML = args.pullDownMsg; //'Pull down to refresh...';
				this.minScrollY = args.pullDownOffset;
			}
			
		}
		
		if (args.useUpdateUp === true) {
			if(this.y < (this.maxScrollY - 5) && !args.pullUpEl.className.match('flip')) {
				args.pullUpEl.className = 'pullUp flip';
				//args.pullUpLabel.innerHTML = 'Release to refresh...';
				//this.maxScrollY = this.maxScrollY;
			} else if(this.y > (this.maxScrollY + 5) && args.pullUpEl.className.match('flip')) {
				args.pullUpEl.className = 'pullUp';
				args.pullUpLabel.innerHTML = args.pullUpMsg; //'Pull up to load more...';
				this.maxScrollY = args.pullUpOffset;
			}
		}
		
		}catch(e){
			ax.log('onScrollMove err:', e.message);
		}

	}
	

	function onScrollEnd(){
		try {
			//ax.log('onScrollEnd');
			var args = this.args;
			
	
			if(args.useQuickScroll) {
				scrollTime = new Date().getTime();
			}
			
			if(args.useLazyImageLoading) {
				loadLazyImages.apply(this);
			}
			
			
			if (args.useUpdateDown === true) {
				if(args.pullDownEl.className.match('flip')) {
					args.pullDownEl.className = 'pullDown loading';
					args.pullDownLabel.innerHTML = args.pullDownUpLoading; //'Loading...';
					args.pullDownAction(this);
					// Execute custom function (ajax call?)
				}
			}
			
			if (args.useUpdateUp === true) {
				if(args.pullUpEl.className.match('flip')) {
					args.pullUpEl.className = 'pullUp loading';
					args.pullUpLabel.innerHTML = args.pullDownUpLoading; //'Loading...';
					args.pullUpAction(this);
					// Execute custom function (ajax call?)
				}
			}
			
			if (typeof args.onScrollEnd === 'function') {
				args.onScrollEnd();
			}
		} catch(e) {
			if (_DEBUG) { console.log('onScrollEnd err', e.message); }
		}
	}

	function onTouchEnd(e){
		var args = this.args,
			target = e.target,
			eventPage,
			i = 10;
			
		//ax.log('onTouchEnd, isScrolling:', isScrolling, 'touchTime', touchTime);
		
		if (isScrolling) {
			isScrolling = false;
		} else {

			while (i--) {
				if($(target).hasClass('page')) {
					eventPage = $(target).attr('id');
					break;
				}
				target = target.parentNode;
			}

			if (!xx.page[eventPage] || xx.page[eventPage].info.isShown) {
				if(touchTime < 300 && touchTime > 1) {	// 25
					
					
					if (args.onTouchEnd) { args.onTouchEnd(e); }
				}
			}

			
			// if(args.useLazyImageLoading){ loadLazyImages.apply(this); }
		}

	}
	
	
	function addScroll(args){
		
		if (_DEBUG) { console.debug("iscroll initializing: ===========================", args.wrapperId); }
		
		if (!quick_scroll_btn) { quick_scroll_btn = document.getElementById('quickScrollButton'); }
		
		var isFirstRefresh = true,
			wrapper = document.getElementById(args.wrapperId);

		if (typeof args.momentum === 'undefined'){ args.momentum = true; }
		if (typeof args.bounce === 'undefined'){ args.bounce = true; }
		if (typeof args.useSwipe === 'undefined'){ args.useSwipe = false; }
		if (typeof args.useQuickScroll === 'undefined'){ args.useQuickScroll = false; }
		if (typeof args.useLazyImageLoading === 'undefined'){ args.useLazyImageLoading = false; }
		
		if (args.wrapperHeight) { wrapper.style.height = args.wrapperHeight + 'px'; }
		
		
		if (args.useQuickScroll){
			
			if (quick_scroll_btn) {
				args.scrollbarClass = 'noScroll';
			} else {
				args.useQuickScroll = false;
				ax.log('quick scroll button element does not exists');
			}
		}
			
		args.wrapperEl = wrapper;

		if (wrapper.querySelector('.pullDown') === null) {
			args.useUpdateDown = false;
		} else {
			args.useUpdateDown = true;
			
			args.pullDownEl = wrapper.querySelector('.pullDown');
			args.pullDownOffset = args.pullDownEl.offsetHeight;
			args.pullDownLabel = args.pullDownEl.querySelector('.pullDownLabel');
			
			//args['thelist'] = wrapper.querySelector('.theList');
		}
		
		
		if (wrapper.querySelector('.pullUp') === null) {
			args.useUpdateUp = false;
		} else {
			args.useUpdateUp = true;
			
			args.pullUpEl = wrapper.querySelector('.pullUp');
			args.pullUpOffset = args.pullUpEl.offsetHeight;
			args.pullUpLabel = args.pullUpEl.querySelector('.pullUpLabel');
			
			//args['thelist'] = wrapper.querySelector('.theList');
		} 
		
		var myScroll = new g.iScroll(args.wrapperId, {

			//iscroll full version option - scrollbar & pull up/down update related
			hideScrollbar: true,
			fadeScrollbar: true,
			bounce: args.bounce,
			topOffset : args.pullDownOffset,
			scrollbarClass: args.scrollbarClass || undefined,

			hScrollbar: (typeof args.hScrollbar === 'boolean') ? args.hScrollbar : true,
			snap: args.snap || false,
			momentum: args.momentum,
			useTransition : false,	// performance!! 
			onRefresh: function(){
				ax.log('onRefresh');

				try{
					var a = args || this.args;
					
					if(isFirstRefresh){
						this.args = args;
						isFirstRefresh = false;
					}
					//if (a.useLazyImageLoading) {
						//onScrollEnd.apply(this);	// lazy image load
					//}
					if (a.useQuickScroll) {
						setQuickScroll.apply(this);
					}
					if (a.useUpdateDown) {
						if(a.pullDownEl.className.match('loading')) {
							a.pullDownEl.className = 'pullDown';
							a.pullDownLabel.innerHTML = a.pullDownMsg; //'Pull down to refresh...';
						}
					}
					if (a.useUpdateUp) {
						if(a.pullUpEl.className.match('loading')) {
							a.pullUpEl.className = 'pullUp';
							a.pullUpLabel.innerHTML = a.pullUpMsg; //'Pull up to load more...';
						}
					}
				}catch(e){console.debug(e,e.message);}
		
				if (args.onRefresh) { args.onRefresh(); }
				//if(args.useSwipe) refreshSwipeEvent();
			},
			onScrollMove: onScrollMove,
			onScrollEnd: onScrollEnd,
			onScrollStart: args.onScrollStart || undefined,
			onTouchEnd: onTouchEnd,
			onBeforeScrollEnd: function(){
				touchTime = (new Date().getTime()) - touchStart;
			},
			onBeforeScrollStart: function(e){
				//ax.log('onBeforeScrollStart');
				
				if(this.args.useQuickScroll) {
					//ax.log('onBeforeScrollStart');
					quick_scroll_btn.style.opacity = 1;
					
					startQuickBarMoving.apply(this);
					scrollTime = new Date().getTime();
				}
				// prevent iScroll input box focus issue
				// http://code.google.com/p/iscroll-js/issues/detail?id=17#c32
				var target = e.target,
					tagName = target.tagName;
				while (target.nodeType !== g.Node.ELEMENT_NODE) { target = target.parentNode; }	// Node.ELEMENT_NODE = 1 
				if (tagName !== 'SELECT' && tagName !== 'INPUT' && tagName !== 'TEXTAREA'){
					e.preventDefault();
				}
			}
		});

		setTimeout(function() {
			wrapper.style.left = '0';
			//if(args.useSwipe) refreshSwipeEvent();
		}, 200);
		
		if (myScroll.args.useQuickScroll) {
			resetQuickScrollPosition.apply(myScroll);
		}
		
		if(myScroll.args.useLazyImageLoading) {
			myScroll.args.lazyImages = myScroll.scroller.querySelectorAll('img');
			
			loadLazyImages.apply(myScroll);
		}
		
		
		oScroll[args.wrapperId] = myScroll;
		
		return myScroll;
	}
	
	ax.def(oScroll)
		.method('onTouchEnd', onTouchEnd)
		.method('addScroll', addScroll)
		.property('scrollTime', function(){ return scrollTime;});
		//.method('refreshSwipeEvent', refreshSwipeEvent);

	if (!g.xx) {
		ax.def(g).constant('xx', {});		
	}
	ax.def(g.xx).constant('scroll', oScroll);
	
// }catch(e){
	// alert('oScroll def err:' + e.message);
// }
}(window));



